package org.hl7.fhir.dstu3.model.codesystems;




/*
  Copyright (c) 2011+, HL7, Inc.
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without modification, 
  are permitted provided that the following conditions are met:
  
   * Redistributions of source code must retain the above copyright notice, this 
     list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright notice, 
     this list of conditions and the following disclaimer in the documentation 
     and/or other materials provided with the distribution.
   * Neither the name of HL7 nor the names of its contributors may be used to 
     endorse or promote products derived from this software without specific 
     prior written permission.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
  POSSIBILITY OF SUCH DAMAGE.
  
*/

// Generated on Sat, Mar 25, 2017 21:03-0400 for FHIR v3.0.0


import org.hl7.fhir.exceptions.FHIRException;

public enum V3Race {

        /**
         * American Indian or Alaska Native
         */
        _10025, 
        /**
         * American Indian
         */
        _10041, 
        /**
         * Abenaki
         */
        _10066, 
        /**
         * Algonquian
         */
        _10082, 
        /**
         * Apache
         */
        _10108, 
        /**
         * Chiricahua
         */
        _10116, 
        /**
         * Fort Sill Apache
         */
        _10124, 
        /**
         * Jicarilla Apache
         */
        _10132, 
        /**
         * Lipan Apache
         */
        _10140, 
        /**
         * Mescalero Apache
         */
        _10157, 
        /**
         * Oklahoma Apache
         */
        _10165, 
        /**
         * Payson Apache
         */
        _10173, 
        /**
         * San Carlos Apache
         */
        _10181, 
        /**
         * White Mountain Apache
         */
        _10199, 
        /**
         * Arapaho
         */
        _10215, 
        /**
         * Northern Arapaho
         */
        _10223, 
        /**
         * Southern Arapaho
         */
        _10231, 
        /**
         * Wind River Arapaho
         */
        _10249, 
        /**
         * Arikara
         */
        _10264, 
        /**
         * Assiniboine
         */
        _10280, 
        /**
         * Assiniboine Sioux
         */
        _10306, 
        /**
         * Fort Peck Assiniboine Sioux
         */
        _10314, 
        /**
         * Bannock
         */
        _10330, 
        /**
         * Blackfeet
         */
        _10355, 
        /**
         * Brotherton
         */
        _10371, 
        /**
         * Burt Lake Band
         */
        _10397, 
        /**
         * Caddo
         */
        _10413, 
        /**
         * Oklahoma Cado
         */
        _10421, 
        /**
         * Cahuilla
         */
        _10447, 
        /**
         * Agua Caliente Cahuilla
         */
        _10454, 
        /**
         * Augustine
         */
        _10462, 
        /**
         * Cabazon
         */
        _10470, 
        /**
         * Los Coyotes
         */
        _10488, 
        /**
         * Morongo
         */
        _10496, 
        /**
         * Santa Rosa Cahuilla
         */
        _10504, 
        /**
         * Torres-Martinez
         */
        _10512, 
        /**
         * California Tribes
         */
        _10538, 
        /**
         * Cahto
         */
        _10546, 
        /**
         * Chimariko
         */
        _10553, 
        /**
         * Coast Miwok
         */
        _10561, 
        /**
         * Digger
         */
        _10579, 
        /**
         * Kawaiisu
         */
        _10587, 
        /**
         * Kern River
         */
        _10595, 
        /**
         * Mattole
         */
        _10603, 
        /**
         * Red Wood
         */
        _10611, 
        /**
         * Santa Rosa
         */
        _10629, 
        /**
         * Takelma
         */
        _10637, 
        /**
         * Wappo
         */
        _10645, 
        /**
         * Yana
         */
        _10652, 
        /**
         * Yuki
         */
        _10660, 
        /**
         * Canadian and Latin American Indian
         */
        _10686, 
        /**
         * Canadian Indian
         */
        _10694, 
        /**
         * Central American Indian
         */
        _10702, 
        /**
         * French American Indian
         */
        _10710, 
        /**
         * Mexican American Indian
         */
        _10728, 
        /**
         * South American Indian
         */
        _10736, 
        /**
         * Spanish American Indian
         */
        _10744, 
        /**
         * Catawba
         */
        _10769, 
        /**
         * Alatna
         */
        _17418, 
        /**
         * Alexander
         */
        _17426, 
        /**
         * Allakaket
         */
        _17434, 
        /**
         * Alanvik
         */
        _17442, 
        /**
         * Anvik
         */
        _17459, 
        /**
         * Arctic
         */
        _17467, 
        /**
         * Beaver
         */
        _17475, 
        /**
         * Birch Creek
         */
        _17483, 
        /**
         * Cantwell
         */
        _17491, 
        /**
         * Chalkyitsik
         */
        _17509, 
        /**
         * Chickaloon
         */
        _17517, 
        /**
         * Chistochina
         */
        _17525, 
        /**
         * Chitina
         */
        _17533, 
        /**
         * Circle
         */
        _17541, 
        /**
         * Cook Inlet
         */
        _17558, 
        /**
         * Copper Center
         */
        _17566, 
        /**
         * Copper River
         */
        _17574, 
        /**
         * Dot Lake
         */
        _17582, 
        /**
         * Doyon
         */
        _17590, 
        /**
         * Eagle
         */
        _17608, 
        /**
         * Eklutna
         */
        _17616, 
        /**
         * Evansville
         */
        _17624, 
        /**
         * Fort Yukon
         */
        _17632, 
        /**
         * Gakona
         */
        _17640, 
        /**
         * Galena
         */
        _17657, 
        /**
         * Grayling
         */
        _17665, 
        /**
         * Gulkana
         */
        _17673, 
        /**
         * Healy Lake
         */
        _17681, 
        /**
         * Holy Cross
         */
        _17699, 
        /**
         * Hughes
         */
        _17707, 
        /**
         * Huslia
         */
        _17715, 
        /**
         * Iliamna
         */
        _17723, 
        /**
         * Kaltag
         */
        _17731, 
        /**
         * Kluti Kaah
         */
        _17749, 
        /**
         * Knik
         */
        _17756, 
        /**
         * Koyukuk
         */
        _17764, 
        /**
         * Lake Minchumina
         */
        _17772, 
        /**
         * Lime
         */
        _17780, 
        /**
         * Mcgrath
         */
        _17798, 
        /**
         * Manley Hot Springs
         */
        _17806, 
        /**
         * Mentasta Lake
         */
        _17814, 
        /**
         * Minto
         */
        _17822, 
        /**
         * Nenana
         */
        _17830, 
        /**
         * Nikolai
         */
        _17848, 
        /**
         * Ninilchik
         */
        _17855, 
        /**
         * Nondalton
         */
        _17863, 
        /**
         * Northway
         */
        _17871, 
        /**
         * Nulato
         */
        _17889, 
        /**
         * Pedro Bay
         */
        _17897, 
        /**
         * Rampart
         */
        _17905, 
        /**
         * Ruby
         */
        _17913, 
        /**
         * Salamatof
         */
        _17921, 
        /**
         * Seldovia
         */
        _17939, 
        /**
         * Slana
         */
        _17947, 
        /**
         * Shageluk
         */
        _17954, 
        /**
         * Stevens
         */
        _17962, 
        /**
         * Stony River
         */
        _17970, 
        /**
         * Takotna
         */
        _17988, 
        /**
         * Tanacross
         */
        _17996, 
        /**
         * Tanaina
         */
        _18002, 
        /**
         * Tanana
         */
        _18010, 
        /**
         * Tanana Chiefs
         */
        _18028, 
        /**
         * Tazlina
         */
        _18036, 
        /**
         * Telida
         */
        _18044, 
        /**
         * Tetlin
         */
        _18051, 
        /**
         * Tok
         */
        _18069, 
        /**
         * Tyonek
         */
        _18077, 
        /**
         * Venetie
         */
        _18085, 
        /**
         * Wiseman
         */
        _18093, 
        /**
         * Cayuse
         */
        _10785, 
        /**
         * Chehalis
         */
        _10801, 
        /**
         * Chemakuan
         */
        _10827, 
        /**
         * Hoh
         */
        _10835, 
        /**
         * Quileute
         */
        _10843, 
        /**
         * Chemehuevi
         */
        _10868, 
        /**
         * Cherokee
         */
        _10884, 
        /**
         * Cherokee Alabama
         */
        _10892, 
        /**
         * Cherokees of Northeast Alabama
         */
        _10900, 
        /**
         * Cherokees of Southeast Alabama
         */
        _10918, 
        /**
         * Eastern Cherokee
         */
        _10926, 
        /**
         * Echota Cherokee
         */
        _10934, 
        /**
         * Etowah Cherokee
         */
        _10942, 
        /**
         * Northern Cherokee
         */
        _10959, 
        /**
         * Tuscola
         */
        _10967, 
        /**
         * United Keetowah Band of Cherokee
         */
        _10975, 
        /**
         * Western Cherokee
         */
        _10983, 
        /**
         * Cherokee Shawnee
         */
        _11007, 
        /**
         * Cheyenne
         */
        _11023, 
        /**
         * Northern Cheyenne
         */
        _11031, 
        /**
         * Southern Cheyenne
         */
        _11049, 
        /**
         * Cheyenne-Arapaho
         */
        _11064, 
        /**
         * Chickahominy
         */
        _11080, 
        /**
         * Eastern Chickahominy
         */
        _11098, 
        /**
         * Western Chickahominy
         */
        _11106, 
        /**
         * Chickasaw
         */
        _11122, 
        /**
         * Chinook
         */
        _11148, 
        /**
         * Clatsop
         */
        _11155, 
        /**
         * Columbia River Chinook
         */
        _11163, 
        /**
         * Kathlamet
         */
        _11171, 
        /**
         * Upper Chinook
         */
        _11189, 
        /**
         * Wakiakum Chinook
         */
        _11197, 
        /**
         * Willapa Chinook
         */
        _11205, 
        /**
         * Wishram
         */
        _11213, 
        /**
         * Chippewa
         */
        _11239, 
        /**
         * Bad River
         */
        _11247, 
        /**
         * Bay Mills Chippewa
         */
        _11254, 
        /**
         * Bois Forte
         */
        _11262, 
        /**
         * Burt Lake Chippewa
         */
        _11270, 
        /**
         * Fond du Lac
         */
        _11288, 
        /**
         * Grand Portage
         */
        _11296, 
        /**
         * Grand Traverse Band of Ottawa-Chippewa
         */
        _11304, 
        /**
         * Keweenaw
         */
        _11312, 
        /**
         * Lac Courte Oreilles
         */
        _11320, 
        /**
         * Lac du Flambeau
         */
        _11338, 
        /**
         * Lac Vieux Desert Chippewa
         */
        _11346, 
        /**
         * Lake Superior
         */
        _11353, 
        /**
         * Leech Lake
         */
        _11361, 
        /**
         * Little Shell Chippewa
         */
        _11379, 
        /**
         * Mille Lacs
         */
        _11387, 
        /**
         * Minnesota Chippewa
         */
        _11395, 
        /**
         * Ontonagon
         */
        _11403, 
        /**
         * Red Cliff Chippewa
         */
        _11411, 
        /**
         * Red Lake Chippewa
         */
        _11429, 
        /**
         * Saginaw Chippewa
         */
        _11437, 
        /**
         * St. Croix Chippewa
         */
        _11445, 
        /**
         * Sault Ste. Marie Chippewa
         */
        _11452, 
        /**
         * Sokoagon Chippewa
         */
        _11460, 
        /**
         * Turtle Mountain
         */
        _11478, 
        /**
         * White Earth
         */
        _11486, 
        /**
         * Chippewa Cree
         */
        _11502, 
        /**
         * Rocky Boy's Chippewa Cree
         */
        _11510, 
        /**
         * Chitimacha
         */
        _11536, 
        /**
         * Choctaw
         */
        _11551, 
        /**
         * Clifton Choctaw
         */
        _11569, 
        /**
         * Jena Choctaw
         */
        _11577, 
        /**
         * Mississippi Choctaw
         */
        _11585, 
        /**
         * Mowa Band of Choctaw
         */
        _11593, 
        /**
         * Oklahoma Choctaw
         */
        _11601, 
        /**
         * Chumash
         */
        _11627, 
        /**
         * Santa Ynez
         */
        _11635, 
        /**
         * Clear Lake
         */
        _11650, 
        /**
         * Coeur D'Alene
         */
        _11676, 
        /**
         * Coharie
         */
        _11692, 
        /**
         * Colorado River
         */
        _11718, 
        /**
         * Colville
         */
        _11734, 
        /**
         * Comanche
         */
        _11759, 
        /**
         * Oklahoma Comanche
         */
        _11767, 
        /**
         * Coos, Lower Umpqua, Siuslaw
         */
        _11783, 
        /**
         * Coos
         */
        _11809, 
        /**
         * Coquilles
         */
        _11825, 
        /**
         * Costanoan
         */
        _11841, 
        /**
         * Coushatta
         */
        _11866, 
        /**
         * Alabama Coushatta
         */
        _11874, 
        /**
         * Cowlitz
         */
        _11890, 
        /**
         * Cree
         */
        _11916, 
        /**
         * Creek
         */
        _11932, 
        /**
         * Alabama Creek
         */
        _11940, 
        /**
         * Alabama Quassarte
         */
        _11957, 
        /**
         * Eastern Creek
         */
        _11965, 
        /**
         * Eastern Muscogee
         */
        _11973, 
        /**
         * Kialegee
         */
        _11981, 
        /**
         * Lower Muscogee
         */
        _11999, 
        /**
         * Machis Lower Creek Indian
         */
        _12005, 
        /**
         * Poarch Band
         */
        _12013, 
        /**
         * Principal Creek Indian Nation
         */
        _12021, 
        /**
         * Star Clan of Muscogee Creeks
         */
        _12039, 
        /**
         * Thlopthlocco
         */
        _12047, 
        /**
         * Tuckabachee
         */
        _12054, 
        /**
         * Croatan
         */
        _12070, 
        /**
         * Crow
         */
        _12096, 
        /**
         * Cupeno
         */
        _12112, 
        /**
         * Agua Caliente
         */
        _12120, 
        /**
         * Delaware
         */
        _12146, 
        /**
         * Eastern Delaware
         */
        _12153, 
        /**
         * Lenni-Lenape
         */
        _12161, 
        /**
         * Munsee
         */
        _12179, 
        /**
         * Oklahoma Delaware
         */
        _12187, 
        /**
         * Rampough Mountain
         */
        _12195, 
        /**
         * Sand Hill
         */
        _12203, 
        /**
         * Diegueno
         */
        _12229, 
        /**
         * Campo
         */
        _12237, 
        /**
         * Capitan Grande
         */
        _12245, 
        /**
         * Cuyapaipe
         */
        _12252, 
        /**
         * La Posta
         */
        _12260, 
        /**
         * Manzanita
         */
        _12278, 
        /**
         * Mesa Grande
         */
        _12286, 
        /**
         * San Pasqual
         */
        _12294, 
        /**
         * Santa Ysabel
         */
        _12302, 
        /**
         * Sycuan
         */
        _12310, 
        /**
         * Eastern Tribes
         */
        _12336, 
        /**
         * Attacapa
         */
        _12344, 
        /**
         * Biloxi
         */
        _12351, 
        /**
         * Georgetown
         */
        _12369, 
        /**
         * Moor
         */
        _12377, 
        /**
         * Nansemond
         */
        _12385, 
        /**
         * Natchez
         */
        _12393, 
        /**
         * Nausu Waiwash
         */
        _12401, 
        /**
         * Nipmuc
         */
        _12419, 
        /**
         * Paugussett
         */
        _12427, 
        /**
         * Pocomoke Acohonock
         */
        _12435, 
        /**
         * Southeastern Indians
         */
        _12443, 
        /**
         * Susquehanock
         */
        _12450, 
        /**
         * Tunica Biloxi
         */
        _12468, 
        /**
         * Waccamaw-Siousan
         */
        _12476, 
        /**
         * Wicomico
         */
        _12484, 
        /**
         * Esselen
         */
        _12500, 
        /**
         * Fort Belknap
         */
        _12526, 
        /**
         * Fort Berthold
         */
        _12542, 
        /**
         * Fort Mcdowell
         */
        _12567, 
        /**
         * Fort Hall
         */
        _12583, 
        /**
         * Gabrieleno
         */
        _12609, 
        /**
         * Grand Ronde
         */
        _12625, 
        /**
         * Gros Ventres
         */
        _12641, 
        /**
         * Atsina
         */
        _12658, 
        /**
         * Haliwa
         */
        _12674, 
        /**
         * Hidatsa
         */
        _12690, 
        /**
         * Hoopa
         */
        _12716, 
        /**
         * Trinity
         */
        _12724, 
        /**
         * Whilkut
         */
        _12732, 
        /**
         * Hoopa Extension
         */
        _12757, 
        /**
         * Houma
         */
        _12773, 
        /**
         * Inaja-Cosmit
         */
        _12799, 
        /**
         * Iowa
         */
        _12815, 
        /**
         * Iowa of Kansas-Nebraska
         */
        _12823, 
        /**
         * Iowa of Oklahoma
         */
        _12831, 
        /**
         * Iroquois
         */
        _12856, 
        /**
         * Cayuga
         */
        _12864, 
        /**
         * Mohawk
         */
        _12872, 
        /**
         * Oneida
         */
        _12880, 
        /**
         * Onondaga
         */
        _12898, 
        /**
         * Seneca
         */
        _12906, 
        /**
         * Seneca Nation
         */
        _12914, 
        /**
         * Seneca-Cayuga
         */
        _12922, 
        /**
         * Tonawanda Seneca
         */
        _12930, 
        /**
         * Tuscarora
         */
        _12948, 
        /**
         * Wyandotte
         */
        _12955, 
        /**
         * Juaneno
         */
        _12971, 
        /**
         * Kalispel
         */
        _12997, 
        /**
         * Karuk
         */
        _13011, 
        /**
         * Kaw
         */
        _13037, 
        /**
         * Kickapoo
         */
        _13052, 
        /**
         * Oklahoma Kickapoo
         */
        _13060, 
        /**
         * Texas Kickapoo
         */
        _13078, 
        /**
         * Kiowa
         */
        _13094, 
        /**
         * Oklahoma Kiowa
         */
        _13102, 
        /**
         * Klallam
         */
        _13128, 
        /**
         * Jamestown
         */
        _13136, 
        /**
         * Lower Elwha
         */
        _13144, 
        /**
         * Port Gamble Klallam
         */
        _13151, 
        /**
         * Klamath
         */
        _13177, 
        /**
         * Konkow
         */
        _13193, 
        /**
         * Kootenai
         */
        _13219, 
        /**
         * Lassik
         */
        _13235, 
        /**
         * Long Island
         */
        _13250, 
        /**
         * Matinecock
         */
        _13268, 
        /**
         * Montauk
         */
        _13276, 
        /**
         * Poospatuck
         */
        _13284, 
        /**
         * Setauket
         */
        _13292, 
        /**
         * Luiseno
         */
        _13318, 
        /**
         * La Jolla
         */
        _13326, 
        /**
         * Pala
         */
        _13334, 
        /**
         * Pauma
         */
        _13342, 
        /**
         * Pechanga
         */
        _13359, 
        /**
         * Soboba
         */
        _13367, 
        /**
         * Twenty-Nine Palms
         */
        _13375, 
        /**
         * Temecula
         */
        _13383, 
        /**
         * Lumbee
         */
        _13409, 
        /**
         * Lummi
         */
        _13425, 
        /**
         * Maidu
         */
        _13441, 
        /**
         * Mountain Maidu
         */
        _13458, 
        /**
         * Nishinam
         */
        _13466, 
        /**
         * Makah
         */
        _13482, 
        /**
         * Maliseet
         */
        _13508, 
        /**
         * Mandan
         */
        _13524, 
        /**
         * Mattaponi
         */
        _13540, 
        /**
         * Menominee
         */
        _13565, 
        /**
         * Miami
         */
        _13581, 
        /**
         * Illinois Miami
         */
        _13599, 
        /**
         * Indiana Miami
         */
        _13607, 
        /**
         * Oklahoma Miami
         */
        _13615, 
        /**
         * Miccosukee
         */
        _13631, 
        /**
         * Micmac
         */
        _13656, 
        /**
         * Aroostook
         */
        _13664, 
        /**
         * Mission Indians
         */
        _13680, 
        /**
         * Miwok
         */
        _13706, 
        /**
         * Modoc
         */
        _13722, 
        /**
         * Mohegan
         */
        _13748, 
        /**
         * Mono
         */
        _13763, 
        /**
         * Nanticoke
         */
        _13789, 
        /**
         * Narragansett
         */
        _13805, 
        /**
         * Navajo
         */
        _13821, 
        /**
         * Alamo Navajo
         */
        _13839, 
        /**
         * Canoncito Navajo
         */
        _13847, 
        /**
         * Ramah Navajo
         */
        _13854, 
        /**
         * Nez Perce
         */
        _13870, 
        /**
         * Nomalaki
         */
        _13896, 
        /**
         * Northwest Tribes
         */
        _13912, 
        /**
         * Alsea
         */
        _13920, 
        /**
         * Celilo
         */
        _13938, 
        /**
         * Columbia
         */
        _13946, 
        /**
         * Kalapuya
         */
        _13953, 
        /**
         * Molala
         */
        _13961, 
        /**
         * Talakamish
         */
        _13979, 
        /**
         * Tenino
         */
        _13987, 
        /**
         * Tillamook
         */
        _13995, 
        /**
         * Wenatchee
         */
        _14001, 
        /**
         * Yahooskin
         */
        _14019, 
        /**
         * Omaha
         */
        _14035, 
        /**
         * Oregon Athabaskan
         */
        _14050, 
        /**
         * Osage
         */
        _14076, 
        /**
         * Otoe-Missouria
         */
        _14092, 
        /**
         * Ottawa
         */
        _14118, 
        /**
         * Burt Lake Ottawa
         */
        _14126, 
        /**
         * Michigan Ottawa
         */
        _14134, 
        /**
         * Oklahoma Ottawa
         */
        _14142, 
        /**
         * Paiute
         */
        _14167, 
        /**
         * Bishop
         */
        _14175, 
        /**
         * Bridgeport
         */
        _14183, 
        /**
         * Burns Paiute
         */
        _14191, 
        /**
         * Cedarville
         */
        _14209, 
        /**
         * Fort Bidwell
         */
        _14217, 
        /**
         * Fort Independence
         */
        _14225, 
        /**
         * Kaibab
         */
        _14233, 
        /**
         * Las Vegas
         */
        _14241, 
        /**
         * Lone Pine
         */
        _14258, 
        /**
         * Lovelock
         */
        _14266, 
        /**
         * Malheur Paiute
         */
        _14274, 
        /**
         * Moapa
         */
        _14282, 
        /**
         * Northern Paiute
         */
        _14290, 
        /**
         * Owens Valley
         */
        _14308, 
        /**
         * Pyramid Lake
         */
        _14316, 
        /**
         * San Juan Southern Paiute
         */
        _14324, 
        /**
         * Southern Paiute
         */
        _14332, 
        /**
         * Summit Lake
         */
        _14340, 
        /**
         * Utu Utu Gwaitu Paiute
         */
        _14357, 
        /**
         * Walker River
         */
        _14365, 
        /**
         * Yerington Paiute
         */
        _14373, 
        /**
         * Pamunkey
         */
        _14399, 
        /**
         * Passamaquoddy
         */
        _14415, 
        /**
         * Indian Township
         */
        _14423, 
        /**
         * Pleasant Point Passamaquoddy
         */
        _14431, 
        /**
         * Pawnee
         */
        _14456, 
        /**
         * Oklahoma Pawnee
         */
        _14464, 
        /**
         * Penobscot
         */
        _14480, 
        /**
         * Peoria
         */
        _14506, 
        /**
         * Oklahoma Peoria
         */
        _14514, 
        /**
         * Pequot
         */
        _14530, 
        /**
         * Marshantucket Pequot
         */
        _14548, 
        /**
         * Pima
         */
        _14563, 
        /**
         * Gila River Pima-Maricopa
         */
        _14571, 
        /**
         * Salt River Pima-Maricopa
         */
        _14589, 
        /**
         * Piscataway
         */
        _14605, 
        /**
         * Pit River
         */
        _14621, 
        /**
         * Pomo
         */
        _14647, 
        /**
         * Central Pomo
         */
        _14654, 
        /**
         * Dry Creek
         */
        _14662, 
        /**
         * Eastern Pomo
         */
        _14670, 
        /**
         * Kashia
         */
        _14688, 
        /**
         * Northern Pomo
         */
        _14696, 
        /**
         * Scotts Valley
         */
        _14704, 
        /**
         * Stonyford
         */
        _14712, 
        /**
         * Sulphur Bank
         */
        _14720, 
        /**
         * Ponca
         */
        _14746, 
        /**
         * Nebraska Ponca
         */
        _14753, 
        /**
         * Oklahoma Ponca
         */
        _14761, 
        /**
         * Potawatomi
         */
        _14787, 
        /**
         * Citizen Band Potawatomi
         */
        _14795, 
        /**
         * Forest County
         */
        _14803, 
        /**
         * Hannahville
         */
        _14811, 
        /**
         * Huron Potawatomi
         */
        _14829, 
        /**
         * Pokagon Potawatomi
         */
        _14837, 
        /**
         * Prairie Band
         */
        _14845, 
        /**
         * Wisconsin Potawatomi
         */
        _14852, 
        /**
         * Powhatan
         */
        _14878, 
        /**
         * Pueblo
         */
        _14894, 
        /**
         * Acoma
         */
        _14902, 
        /**
         * Arizona Tewa
         */
        _14910, 
        /**
         * Cochiti
         */
        _14928, 
        /**
         * Hopi
         */
        _14936, 
        /**
         * Isleta
         */
        _14944, 
        /**
         * Jemez
         */
        _14951, 
        /**
         * Keres
         */
        _14969, 
        /**
         * Laguna
         */
        _14977, 
        /**
         * Nambe
         */
        _14985, 
        /**
         * Picuris
         */
        _14993, 
        /**
         * Piro
         */
        _15008, 
        /**
         * Pojoaque
         */
        _15016, 
        /**
         * San Felipe
         */
        _15024, 
        /**
         * San Ildefonso
         */
        _15032, 
        /**
         * San Juan Pueblo
         */
        _15040, 
        /**
         * San Juan De
         */
        _15057, 
        /**
         * San Juan
         */
        _15065, 
        /**
         * Sandia
         */
        _15073, 
        /**
         * Santa Ana
         */
        _15081, 
        /**
         * Santa Clara
         */
        _15099, 
        /**
         * Santo Domingo
         */
        _15107, 
        /**
         * Taos
         */
        _15115, 
        /**
         * Tesuque
         */
        _15123, 
        /**
         * Tewa
         */
        _15131, 
        /**
         * Tigua
         */
        _15149, 
        /**
         * Zia
         */
        _15156, 
        /**
         * Zuni
         */
        _15164, 
        /**
         * Puget Sound Salish
         */
        _15180, 
        /**
         * Duwamish
         */
        _15198, 
        /**
         * Kikiallus
         */
        _15206, 
        /**
         * Lower Skagit
         */
        _15214, 
        /**
         * Muckleshoot
         */
        _15222, 
        /**
         * Nisqually
         */
        _15230, 
        /**
         * Nooksack
         */
        _15248, 
        /**
         * Port Madison
         */
        _15255, 
        /**
         * Puyallup
         */
        _15263, 
        /**
         * Samish
         */
        _15271, 
        /**
         * Sauk-Suiattle
         */
        _15289, 
        /**
         * Skokomish
         */
        _15297, 
        /**
         * Skykomish
         */
        _15305, 
        /**
         * Snohomish
         */
        _15313, 
        /**
         * Snoqualmie
         */
        _15321, 
        /**
         * Squaxin Island
         */
        _15339, 
        /**
         * Steilacoom
         */
        _15347, 
        /**
         * Stillaguamish
         */
        _15354, 
        /**
         * Suquamish
         */
        _15362, 
        /**
         * Swinomish
         */
        _15370, 
        /**
         * Tulalip
         */
        _15388, 
        /**
         * Upper Skagit
         */
        _15396, 
        /**
         * Quapaw
         */
        _15412, 
        /**
         * Quinault
         */
        _15438, 
        /**
         * Rappahannock
         */
        _15453, 
        /**
         * Reno-Sparks
         */
        _15479, 
        /**
         * Round Valley
         */
        _15495, 
        /**
         * Sac and Fox
         */
        _15511, 
        /**
         * Iowa Sac and Fox
         */
        _15529, 
        /**
         * Missouri Sac and Fox
         */
        _15537, 
        /**
         * Oklahoma Sac and Fox
         */
        _15545, 
        /**
         * Salinan
         */
        _15560, 
        /**
         * Salish
         */
        _15586, 
        /**
         * Salish and Kootenai
         */
        _15602, 
        /**
         * Schaghticoke
         */
        _15628, 
        /**
         * Scott Valley
         */
        _15644, 
        /**
         * Seminole
         */
        _15669, 
        /**
         * Big Cypress
         */
        _15677, 
        /**
         * Brighton
         */
        _15685, 
        /**
         * Florida Seminole
         */
        _15693, 
        /**
         * Hollywood Seminole
         */
        _15701, 
        /**
         * Oklahoma Seminole
         */
        _15719, 
        /**
         * Serrano
         */
        _15735, 
        /**
         * San Manual
         */
        _15743, 
        /**
         * Shasta
         */
        _15768, 
        /**
         * Shawnee
         */
        _15784, 
        /**
         * Absentee Shawnee
         */
        _15792, 
        /**
         * Eastern Shawnee
         */
        _15800, 
        /**
         * Shinnecock
         */
        _15826, 
        /**
         * Shoalwater Bay
         */
        _15842, 
        /**
         * Shoshone
         */
        _15867, 
        /**
         * Battle Mountain
         */
        _15875, 
        /**
         * Duckwater
         */
        _15883, 
        /**
         * Elko
         */
        _15891, 
        /**
         * Ely
         */
        _15909, 
        /**
         * Goshute
         */
        _15917, 
        /**
         * Panamint
         */
        _15925, 
        /**
         * Ruby Valley
         */
        _15933, 
        /**
         * Skull Valley
         */
        _15941, 
        /**
         * South Fork Shoshone
         */
        _15958, 
        /**
         * Te-Moak Western Shoshone
         */
        _15966, 
        /**
         * Timbi-Sha Shoshone
         */
        _15974, 
        /**
         * Washakie
         */
        _15982, 
        /**
         * Wind River Shoshone
         */
        _15990, 
        /**
         * Yomba
         */
        _16006, 
        /**
         * Shoshone Paiute
         */
        _16022, 
        /**
         * Duck Valley
         */
        _16030, 
        /**
         * Fallon
         */
        _16048, 
        /**
         * Fort McDermitt
         */
        _16055, 
        /**
         * Siletz
         */
        _16071, 
        /**
         * Sioux
         */
        _16097, 
        /**
         * Blackfoot Sioux
         */
        _16105, 
        /**
         * Brule Sioux
         */
        _16113, 
        /**
         * Cheyenne River Sioux
         */
        _16121, 
        /**
         * Crow Creek Sioux
         */
        _16139, 
        /**
         * Dakota Sioux
         */
        _16147, 
        /**
         * Flandreau Santee
         */
        _16154, 
        /**
         * Fort Peck
         */
        _16162, 
        /**
         * Lake Traverse Sioux
         */
        _16170, 
        /**
         * Lower Brule Sioux
         */
        _16188, 
        /**
         * Lower Sioux
         */
        _16196, 
        /**
         * Mdewakanton Sioux
         */
        _16204, 
        /**
         * Miniconjou
         */
        _16212, 
        /**
         * Oglala Sioux
         */
        _16220, 
        /**
         * Pine Ridge Sioux
         */
        _16238, 
        /**
         * Pipestone Sioux
         */
        _16246, 
        /**
         * Prairie Island Sioux
         */
        _16253, 
        /**
         * Prior Lake Sioux
         */
        _16261, 
        /**
         * Rosebud Sioux
         */
        _16279, 
        /**
         * Sans Arc Sioux
         */
        _16287, 
        /**
         * Santee Sioux
         */
        _16295, 
        /**
         * Sisseton-Wahpeton
         */
        _16303, 
        /**
         * Sisseton Sioux
         */
        _16311, 
        /**
         * Spirit Lake Sioux
         */
        _16329, 
        /**
         * Standing Rock Sioux
         */
        _16337, 
        /**
         * Teton Sioux
         */
        _16345, 
        /**
         * Two Kettle Sioux
         */
        _16352, 
        /**
         * Upper Sioux
         */
        _16360, 
        /**
         * Wahpekute Sioux
         */
        _16378, 
        /**
         * Wahpeton Sioux
         */
        _16386, 
        /**
         * Wazhaza Sioux
         */
        _16394, 
        /**
         * Yankton Sioux
         */
        _16402, 
        /**
         * Yanktonai Sioux
         */
        _16410, 
        /**
         * Siuslaw
         */
        _16436, 
        /**
         * Spokane
         */
        _16451, 
        /**
         * Stewart
         */
        _16477, 
        /**
         * Stockbridge
         */
        _16493, 
        /**
         * Susanville
         */
        _16519, 
        /**
         * Tohono O'Odham
         */
        _16535, 
        /**
         * Ak-Chin
         */
        _16543, 
        /**
         * Gila Bend
         */
        _16550, 
        /**
         * San Xavier
         */
        _16568, 
        /**
         * Sells
         */
        _16576, 
        /**
         * Tolowa
         */
        _16592, 
        /**
         * Tonkawa
         */
        _16618, 
        /**
         * Tygh
         */
        _16634, 
        /**
         * Umatilla
         */
        _16659, 
        /**
         * Umpqua
         */
        _16675, 
        /**
         * Cow Creek Umpqua
         */
        _16683, 
        /**
         * Ute
         */
        _16709, 
        /**
         * Allen Canyon
         */
        _16717, 
        /**
         * Uintah Ute
         */
        _16725, 
        /**
         * Ute Mountain Ute
         */
        _16733, 
        /**
         * Wailaki
         */
        _16758, 
        /**
         * Walla-Walla
         */
        _16774, 
        /**
         * Wampanoag
         */
        _16790, 
        /**
         * Gay Head Wampanoag
         */
        _16808, 
        /**
         * Mashpee Wampanoag
         */
        _16816, 
        /**
         * Warm Springs
         */
        _16832, 
        /**
         * Wascopum
         */
        _16857, 
        /**
         * Washoe
         */
        _16873, 
        /**
         * Alpine
         */
        _16881, 
        /**
         * Carson
         */
        _16899, 
        /**
         * Dresslerville
         */
        _16907, 
        /**
         * Wichita
         */
        _16923, 
        /**
         * Wind River
         */
        _16949, 
        /**
         * Winnebago
         */
        _16964, 
        /**
         * Ho-chunk
         */
        _16972, 
        /**
         * Nebraska Winnebago
         */
        _16980, 
        /**
         * Winnemucca
         */
        _17004, 
        /**
         * Wintun
         */
        _17020, 
        /**
         * Wiyot
         */
        _17046, 
        /**
         * Table Bluff
         */
        _17053, 
        /**
         * Yakama
         */
        _17079, 
        /**
         * Yakama Cowlitz
         */
        _17095, 
        /**
         * Yaqui
         */
        _17111, 
        /**
         * Barrio Libre
         */
        _17129, 
        /**
         * Pascua Yaqui
         */
        _17137, 
        /**
         * Yavapai Apache
         */
        _17152, 
        /**
         * Yokuts
         */
        _17178, 
        /**
         * Chukchansi
         */
        _17186, 
        /**
         * Tachi
         */
        _17194, 
        /**
         * Tule River
         */
        _17202, 
        /**
         * Yuchi
         */
        _17228, 
        /**
         * Yuman
         */
        _17244, 
        /**
         * Cocopah
         */
        _17251, 
        /**
         * Havasupai
         */
        _17269, 
        /**
         * Hualapai
         */
        _17277, 
        /**
         * Maricopa
         */
        _17285, 
        /**
         * Mohave
         */
        _17293, 
        /**
         * Quechan
         */
        _17301, 
        /**
         * Yavapai
         */
        _17319, 
        /**
         * Yurok
         */
        _17327, 
        /**
         * Coast Yurok
         */
        _17335, 
        /**
         * Alaska Native
         */
        _17350, 
        /**
         * Alaska Indian
         */
        _17376, 
        /**
         * Alaskan Athabascan
         */
        _17392, 
        /**
         * Ahtna
         */
        _17400, 
        /**
         * Southeast Alaska
         */
        _18119, 
        /**
         * Tlingit-Haida
         */
        _18135, 
        /**
         * Angoon
         */
        _18143, 
        /**
         * Central Council of Tlingit and Haida Tribes
         */
        _18150, 
        /**
         * Chilkat
         */
        _18168, 
        /**
         * Chilkoot
         */
        _18176, 
        /**
         * Craig
         */
        _18184, 
        /**
         * Douglas
         */
        _18192, 
        /**
         * Haida
         */
        _18200, 
        /**
         * Hoonah
         */
        _18218, 
        /**
         * Hydaburg
         */
        _18226, 
        /**
         * Kake
         */
        _18234, 
        /**
         * Kasaan
         */
        _18242, 
        /**
         * Kenaitze
         */
        _18259, 
        /**
         * Ketchikan
         */
        _18267, 
        /**
         * Klawock
         */
        _18275, 
        /**
         * Pelican
         */
        _18283, 
        /**
         * Petersburg
         */
        _18291, 
        /**
         * Saxman
         */
        _18309, 
        /**
         * Sitka
         */
        _18317, 
        /**
         * Tenakee Springs
         */
        _18325, 
        /**
         * Tlingit
         */
        _18333, 
        /**
         * Wrangell
         */
        _18341, 
        /**
         * Yakutat
         */
        _18358, 
        /**
         * Tsimshian
         */
        _18374, 
        /**
         * Metlakatla
         */
        _18382, 
        /**
         * Eskimo
         */
        _18408, 
        /**
         * Greenland Eskimo
         */
        _18424, 
        /**
         * Inupiat Eskimo
         */
        _18440, 
        /**
         * Ambler
         */
        _18457, 
        /**
         * Anaktuvuk
         */
        _18465, 
        /**
         * Anaktuvuk Pass
         */
        _18473, 
        /**
         * Arctic Slope Inupiat
         */
        _18481, 
        /**
         * Arctic Slope Corporation
         */
        _18499, 
        /**
         * Atqasuk
         */
        _18507, 
        /**
         * Barrow
         */
        _18515, 
        /**
         * Bering Straits Inupiat
         */
        _18523, 
        /**
         * Brevig Mission
         */
        _18531, 
        /**
         * Buckland
         */
        _18549, 
        /**
         * Chinik
         */
        _18556, 
        /**
         * Council
         */
        _18564, 
        /**
         * Deering
         */
        _18572, 
        /**
         * Elim
         */
        _18580, 
        /**
         * Golovin
         */
        _18598, 
        /**
         * Inalik Diomede
         */
        _18606, 
        /**
         * Inupiaq
         */
        _18614, 
        /**
         * Kaktovik
         */
        _18622, 
        /**
         * Kawerak
         */
        _18630, 
        /**
         * Kiana
         */
        _18648, 
        /**
         * Kivalina
         */
        _18655, 
        /**
         * Kobuk
         */
        _18663, 
        /**
         * Kotzebue
         */
        _18671, 
        /**
         * Koyuk
         */
        _18689, 
        /**
         * Kwiguk
         */
        _18697, 
        /**
         * Mauneluk Inupiat
         */
        _18705, 
        /**
         * Nana Inupiat
         */
        _18713, 
        /**
         * Noatak
         */
        _18721, 
        /**
         * Nome
         */
        _18739, 
        /**
         * Noorvik
         */
        _18747, 
        /**
         * Nuiqsut
         */
        _18754, 
        /**
         * Point Hope
         */
        _18762, 
        /**
         * Point Lay
         */
        _18770, 
        /**
         * Selawik
         */
        _18788, 
        /**
         * Shaktoolik
         */
        _18796, 
        /**
         * Shishmaref
         */
        _18804, 
        /**
         * Shungnak
         */
        _18812, 
        /**
         * Solomon
         */
        _18820, 
        /**
         * Teller
         */
        _18838, 
        /**
         * Unalakleet
         */
        _18846, 
        /**
         * Wainwright
         */
        _18853, 
        /**
         * Wales
         */
        _18861, 
        /**
         * White Mountain
         */
        _18879, 
        /**
         * White Mountain Inupiat
         */
        _18887, 
        /**
         * Mary's Igloo
         */
        _18895, 
        /**
         * Siberian Eskimo
         */
        _18911, 
        /**
         * Gambell
         */
        _18929, 
        /**
         * Savoonga
         */
        _18937, 
        /**
         * Siberian Yupik
         */
        _18945, 
        /**
         * Yupik Eskimo
         */
        _18960, 
        /**
         * Akiachak
         */
        _18978, 
        /**
         * Akiak
         */
        _18986, 
        /**
         * Alakanuk
         */
        _18994, 
        /**
         * Aleknagik
         */
        _19000, 
        /**
         * Andreafsky
         */
        _19018, 
        /**
         * Aniak
         */
        _19026, 
        /**
         * Atmautluak
         */
        _19034, 
        /**
         * Bethel
         */
        _19042, 
        /**
         * Bill Moore's Slough
         */
        _19059, 
        /**
         * Bristol Bay Yupik
         */
        _19067, 
        /**
         * Calista Yupik
         */
        _19075, 
        /**
         * Chefornak
         */
        _19083, 
        /**
         * Chevak
         */
        _19091, 
        /**
         * Chuathbaluk
         */
        _19109, 
        /**
         * Clark's Point
         */
        _19117, 
        /**
         * Crooked Creek
         */
        _19125, 
        /**
         * Dillingham
         */
        _19133, 
        /**
         * Eek
         */
        _19141, 
        /**
         * Ekuk
         */
        _19158, 
        /**
         * Ekwok
         */
        _19166, 
        /**
         * Emmonak
         */
        _19174, 
        /**
         * Goodnews Bay
         */
        _19182, 
        /**
         * Hooper Bay
         */
        _19190, 
        /**
         * Iqurmuit (Russian Mission)
         */
        _19208, 
        /**
         * Kalskag
         */
        _19216, 
        /**
         * Kasigluk
         */
        _19224, 
        /**
         * Kipnuk
         */
        _19232, 
        /**
         * Koliganek
         */
        _19240, 
        /**
         * Kongiganak
         */
        _19257, 
        /**
         * Kotlik
         */
        _19265, 
        /**
         * Kwethluk
         */
        _19273, 
        /**
         * Kwigillingok
         */
        _19281, 
        /**
         * Levelock
         */
        _19299, 
        /**
         * Lower Kalskag
         */
        _19307, 
        /**
         * Manokotak
         */
        _19315, 
        /**
         * Marshall
         */
        _19323, 
        /**
         * Mekoryuk
         */
        _19331, 
        /**
         * Mountain Village
         */
        _19349, 
        /**
         * Naknek
         */
        _19356, 
        /**
         * Napaumute
         */
        _19364, 
        /**
         * Napakiak
         */
        _19372, 
        /**
         * Napaskiak
         */
        _19380, 
        /**
         * Newhalen
         */
        _19398, 
        /**
         * New Stuyahok
         */
        _19406, 
        /**
         * Newtok
         */
        _19414, 
        /**
         * Nightmute
         */
        _19422, 
        /**
         * Nunapitchukv
         */
        _19430, 
        /**
         * Oscarville
         */
        _19448, 
        /**
         * Pilot Station
         */
        _19455, 
        /**
         * Pitkas Point
         */
        _19463, 
        /**
         * Platinum
         */
        _19471, 
        /**
         * Portage Creek
         */
        _19489, 
        /**
         * Quinhagak
         */
        _19497, 
        /**
         * Red Devil
         */
        _19505, 
        /**
         * St. Michael
         */
        _19513, 
        /**
         * Scammon Bay
         */
        _19521, 
        /**
         * Sheldon's Point
         */
        _19539, 
        /**
         * Sleetmute
         */
        _19547, 
        /**
         * Stebbins
         */
        _19554, 
        /**
         * Togiak
         */
        _19562, 
        /**
         * Toksook
         */
        _19570, 
        /**
         * Tulukskak
         */
        _19588, 
        /**
         * Tuntutuliak
         */
        _19596, 
        /**
         * Tununak
         */
        _19604, 
        /**
         * Twin Hills
         */
        _19612, 
        /**
         * Georgetown
         */
        _19620, 
        /**
         * St. Mary's
         */
        _19638, 
        /**
         * Umkumiate
         */
        _19646, 
        /**
         * Aleut
         */
        _19661, 
        /**
         * Alutiiq Aleut
         */
        _19687, 
        /**
         * Tatitlek
         */
        _19695, 
        /**
         * Ugashik
         */
        _19703, 
        /**
         * Bristol Bay Aleut
         */
        _19729, 
        /**
         * Chignik
         */
        _19737, 
        /**
         * Chignik Lake
         */
        _19745, 
        /**
         * Egegik
         */
        _19752, 
        /**
         * Igiugig
         */
        _19760, 
        /**
         * Ivanof Bay
         */
        _19778, 
        /**
         * King Salmon
         */
        _19786, 
        /**
         * Kokhanok
         */
        _19794, 
        /**
         * Perryville
         */
        _19802, 
        /**
         * Pilot Point
         */
        _19810, 
        /**
         * Port Heiden
         */
        _19828, 
        /**
         * Chugach Aleut
         */
        _19844, 
        /**
         * Chenega
         */
        _19851, 
        /**
         * Chugach Corporation
         */
        _19869, 
        /**
         * English Bay
         */
        _19877, 
        /**
         * Port Graham
         */
        _19885, 
        /**
         * Eyak
         */
        _19901, 
        /**
         * Koniag Aleut
         */
        _19927, 
        /**
         * Akhiok
         */
        _19935, 
        /**
         * Agdaagux
         */
        _19943, 
        /**
         * Karluk
         */
        _19950, 
        /**
         * Kodiak
         */
        _19968, 
        /**
         * Larsen Bay
         */
        _19976, 
        /**
         * Old Harbor
         */
        _19984, 
        /**
         * Ouzinkie
         */
        _19992, 
        /**
         * Port Lions
         */
        _20008, 
        /**
         * Sugpiaq
         */
        _20024, 
        /**
         * Suqpigaq
         */
        _20040, 
        /**
         * Unangan Aleut
         */
        _20065, 
        /**
         * Akutan
         */
        _20073, 
        /**
         * Aleut Corporation
         */
        _20081, 
        /**
         * Aleutian
         */
        _20099, 
        /**
         * Aleutian Islander
         */
        _20107, 
        /**
         * Atka
         */
        _20115, 
        /**
         * Belkofski
         */
        _20123, 
        /**
         * Chignik Lagoon
         */
        _20131, 
        /**
         * King Cove
         */
        _20149, 
        /**
         * False Pass
         */
        _20156, 
        /**
         * Nelson Lagoon
         */
        _20164, 
        /**
         * Nikolski
         */
        _20172, 
        /**
         * Pauloff Harbor
         */
        _20180, 
        /**
         * Qagan Toyagungin
         */
        _20198, 
        /**
         * Qawalangin
         */
        _20206, 
        /**
         * St. George
         */
        _20214, 
        /**
         * St. Paul
         */
        _20222, 
        /**
         * Sand Point
         */
        _20230, 
        /**
         * South Naknek
         */
        _20248, 
        /**
         * Unalaska
         */
        _20255, 
        /**
         * Unga
         */
        _20263, 
        /**
         * Asian
         */
        _20289, 
        /**
         * Asian Indian
         */
        _20297, 
        /**
         * Bangladeshi
         */
        _20305, 
        /**
         * Bhutanese
         */
        _20313, 
        /**
         * Burmese
         */
        _20321, 
        /**
         * Cambodian
         */
        _20339, 
        /**
         * Chinese
         */
        _20347, 
        /**
         * Taiwanese
         */
        _20354, 
        /**
         * Filipino
         */
        _20362, 
        /**
         * Hmong
         */
        _20370, 
        /**
         * Indonesian
         */
        _20388, 
        /**
         * Japanese
         */
        _20396, 
        /**
         * Korean
         */
        _20404, 
        /**
         * Laotian
         */
        _20412, 
        /**
         * Malaysian
         */
        _20420, 
        /**
         * Okinawan
         */
        _20438, 
        /**
         * Pakistani
         */
        _20446, 
        /**
         * Sri Lankan
         */
        _20453, 
        /**
         * Thai
         */
        _20461, 
        /**
         * Vietnamese
         */
        _20479, 
        /**
         * Iwo Jiman
         */
        _20487, 
        /**
         * Maldivian
         */
        _20495, 
        /**
         * Nepalese
         */
        _20503, 
        /**
         * Singaporean
         */
        _20511, 
        /**
         * Madagascar
         */
        _20529, 
        /**
         * Black or African American
         */
        _20545, 
        /**
         * Black
         */
        _20560, 
        /**
         * African American
         */
        _20586, 
        /**
         * African
         */
        _20602, 
        /**
         * Botswanan
         */
        _20610, 
        /**
         * Ethiopian
         */
        _20628, 
        /**
         * Liberian
         */
        _20636, 
        /**
         * Namibian
         */
        _20644, 
        /**
         * Nigerian
         */
        _20651, 
        /**
         * Zairean
         */
        _20669, 
        /**
         * Bahamian
         */
        _20677, 
        /**
         * Barbadian
         */
        _20685, 
        /**
         * Dominican
         */
        _20693, 
        /**
         * Dominica Islander
         */
        _20701, 
        /**
         * Haitian
         */
        _20719, 
        /**
         * Jamaican
         */
        _20727, 
        /**
         * Tobagoan
         */
        _20735, 
        /**
         * Trinidadian
         */
        _20743, 
        /**
         * West Indian
         */
        _20750, 
        /**
         * Native Hawaiian or Other Pacific Islander
         */
        _20768, 
        /**
         * Polynesian
         */
        _20784, 
        /**
         * Native Hawaiian
         */
        _20792, 
        /**
         * Samoan
         */
        _20800, 
        /**
         * Tahitian
         */
        _20818, 
        /**
         * Tongan
         */
        _20826, 
        /**
         * Tokelauan
         */
        _20834, 
        /**
         * Micronesian
         */
        _20859, 
        /**
         * Guamanian or Chamorro
         */
        _20867, 
        /**
         * Guamanian
         */
        _20875, 
        /**
         * Chamorro
         */
        _20883, 
        /**
         * Mariana Islander
         */
        _20891, 
        /**
         * Marshallese
         */
        _20909, 
        /**
         * Palauan
         */
        _20917, 
        /**
         * Carolinian
         */
        _20925, 
        /**
         * Kosraean
         */
        _20933, 
        /**
         * Pohnpeian
         */
        _20941, 
        /**
         * Saipanese
         */
        _20958, 
        /**
         * Kiribati
         */
        _20966, 
        /**
         * Chuukese
         */
        _20974, 
        /**
         * Yapese
         */
        _20982, 
        /**
         * Melanesian
         */
        _21006, 
        /**
         * Fijian
         */
        _21014, 
        /**
         * Papua New Guinean
         */
        _21022, 
        /**
         * Solomon Islander
         */
        _21030, 
        /**
         * New Hebrides
         */
        _21048, 
        /**
         * Note that this term remains in the table for completeness, even though within HL7, the notion of Other code is deprecated.
         */
        _25007, 
        /**
         * White
         */
        _21063, 
        /**
         * European
         */
        _21089, 
        /**
         * Armenian
         */
        _21097, 
        /**
         * English
         */
        _21105, 
        /**
         * French
         */
        _21113, 
        /**
         * German
         */
        _21121, 
        /**
         * Irish
         */
        _21139, 
        /**
         * Italian
         */
        _21147, 
        /**
         * Polish
         */
        _21154, 
        /**
         * Scottish
         */
        _21162, 
        /**
         * Middle Eastern or North African
         */
        _21188, 
        /**
         * Assyrian
         */
        _21196, 
        /**
         * Egyptian
         */
        _21204, 
        /**
         * Iranian
         */
        _21212, 
        /**
         * Iraqi
         */
        _21220, 
        /**
         * Lebanese
         */
        _21238, 
        /**
         * Palestinian
         */
        _21246, 
        /**
         * Syrian
         */
        _21253, 
        /**
         * Afghanistani
         */
        _21261, 
        /**
         * Israeili
         */
        _21279, 
        /**
         * Arab
         */
        _21295, 
        /**
         * Note that this term remains in the table for completeness, even though within HL7, the notion of Other code is deprecated.
         */
        _21311, 
        /**
         * added to help the parsers
         */
        NULL;
        public static V3Race fromCode(String codeString) throws FHIRException {
            if (codeString == null || "".equals(codeString))
                return null;
        if ("1002-5".equals(codeString))
          return _10025;
        if ("1004-1".equals(codeString))
          return _10041;
        if ("1006-6".equals(codeString))
          return _10066;
        if ("1008-2".equals(codeString))
          return _10082;
        if ("1010-8".equals(codeString))
          return _10108;
        if ("1011-6".equals(codeString))
          return _10116;
        if ("1012-4".equals(codeString))
          return _10124;
        if ("1013-2".equals(codeString))
          return _10132;
        if ("1014-0".equals(codeString))
          return _10140;
        if ("1015-7".equals(codeString))
          return _10157;
        if ("1016-5".equals(codeString))
          return _10165;
        if ("1017-3".equals(codeString))
          return _10173;
        if ("1018-1".equals(codeString))
          return _10181;
        if ("1019-9".equals(codeString))
          return _10199;
        if ("1021-5".equals(codeString))
          return _10215;
        if ("1022-3".equals(codeString))
          return _10223;
        if ("1023-1".equals(codeString))
          return _10231;
        if ("1024-9".equals(codeString))
          return _10249;
        if ("1026-4".equals(codeString))
          return _10264;
        if ("1028-0".equals(codeString))
          return _10280;
        if ("1030-6".equals(codeString))
          return _10306;
        if ("1031-4".equals(codeString))
          return _10314;
        if ("1033-0".equals(codeString))
          return _10330;
        if ("1035-5".equals(codeString))
          return _10355;
        if ("1037-1".equals(codeString))
          return _10371;
        if ("1039-7".equals(codeString))
          return _10397;
        if ("1041-3".equals(codeString))
          return _10413;
        if ("1042-1".equals(codeString))
          return _10421;
        if ("1044-7".equals(codeString))
          return _10447;
        if ("1045-4".equals(codeString))
          return _10454;
        if ("1046-2".equals(codeString))
          return _10462;
        if ("1047-0".equals(codeString))
          return _10470;
        if ("1048-8".equals(codeString))
          return _10488;
        if ("1049-6".equals(codeString))
          return _10496;
        if ("1050-4".equals(codeString))
          return _10504;
        if ("1051-2".equals(codeString))
          return _10512;
        if ("1053-8".equals(codeString))
          return _10538;
        if ("1054-6".equals(codeString))
          return _10546;
        if ("1055-3".equals(codeString))
          return _10553;
        if ("1056-1".equals(codeString))
          return _10561;
        if ("1057-9".equals(codeString))
          return _10579;
        if ("1058-7".equals(codeString))
          return _10587;
        if ("1059-5".equals(codeString))
          return _10595;
        if ("1060-3".equals(codeString))
          return _10603;
        if ("1061-1".equals(codeString))
          return _10611;
        if ("1062-9".equals(codeString))
          return _10629;
        if ("1063-7".equals(codeString))
          return _10637;
        if ("1064-5".equals(codeString))
          return _10645;
        if ("1065-2".equals(codeString))
          return _10652;
        if ("1066-0".equals(codeString))
          return _10660;
        if ("1068-6".equals(codeString))
          return _10686;
        if ("1069-4".equals(codeString))
          return _10694;
        if ("1070-2".equals(codeString))
          return _10702;
        if ("1071-0".equals(codeString))
          return _10710;
        if ("1072-8".equals(codeString))
          return _10728;
        if ("1073-6".equals(codeString))
          return _10736;
        if ("1074-4".equals(codeString))
          return _10744;
        if ("1076-9".equals(codeString))
          return _10769;
        if ("1741-8".equals(codeString))
          return _17418;
        if ("1742-6".equals(codeString))
          return _17426;
        if ("1743-4".equals(codeString))
          return _17434;
        if ("1744-2".equals(codeString))
          return _17442;
        if ("1745-9".equals(codeString))
          return _17459;
        if ("1746-7".equals(codeString))
          return _17467;
        if ("1747-5".equals(codeString))
          return _17475;
        if ("1748-3".equals(codeString))
          return _17483;
        if ("1749-1".equals(codeString))
          return _17491;
        if ("1750-9".equals(codeString))
          return _17509;
        if ("1751-7".equals(codeString))
          return _17517;
        if ("1752-5".equals(codeString))
          return _17525;
        if ("1753-3".equals(codeString))
          return _17533;
        if ("1754-1".equals(codeString))
          return _17541;
        if ("1755-8".equals(codeString))
          return _17558;
        if ("1756-6".equals(codeString))
          return _17566;
        if ("1757-4".equals(codeString))
          return _17574;
        if ("1758-2".equals(codeString))
          return _17582;
        if ("1759-0".equals(codeString))
          return _17590;
        if ("1760-8".equals(codeString))
          return _17608;
        if ("1761-6".equals(codeString))
          return _17616;
        if ("1762-4".equals(codeString))
          return _17624;
        if ("1763-2".equals(codeString))
          return _17632;
        if ("1764-0".equals(codeString))
          return _17640;
        if ("1765-7".equals(codeString))
          return _17657;
        if ("1766-5".equals(codeString))
          return _17665;
        if ("1767-3".equals(codeString))
          return _17673;
        if ("1768-1".equals(codeString))
          return _17681;
        if ("1769-9".equals(codeString))
          return _17699;
        if ("1770-7".equals(codeString))
          return _17707;
        if ("1771-5".equals(codeString))
          return _17715;
        if ("1772-3".equals(codeString))
          return _17723;
        if ("1773-1".equals(codeString))
          return _17731;
        if ("1774-9".equals(codeString))
          return _17749;
        if ("1775-6".equals(codeString))
          return _17756;
        if ("1776-4".equals(codeString))
          return _17764;
        if ("1777-2".equals(codeString))
          return _17772;
        if ("1778-0".equals(codeString))
          return _17780;
        if ("1779-8".equals(codeString))
          return _17798;
        if ("1780-6".equals(codeString))
          return _17806;
        if ("1781-4".equals(codeString))
          return _17814;
        if ("1782-2".equals(codeString))
          return _17822;
        if ("1783-0".equals(codeString))
          return _17830;
        if ("1784-8".equals(codeString))
          return _17848;
        if ("1785-5".equals(codeString))
          return _17855;
        if ("1786-3".equals(codeString))
          return _17863;
        if ("1787-1".equals(codeString))
          return _17871;
        if ("1788-9".equals(codeString))
          return _17889;
        if ("1789-7".equals(codeString))
          return _17897;
        if ("1790-5".equals(codeString))
          return _17905;
        if ("1791-3".equals(codeString))
          return _17913;
        if ("1792-1".equals(codeString))
          return _17921;
        if ("1793-9".equals(codeString))
          return _17939;
        if ("1794-7".equals(codeString))
          return _17947;
        if ("1795-4".equals(codeString))
          return _17954;
        if ("1796-2".equals(codeString))
          return _17962;
        if ("1797-0".equals(codeString))
          return _17970;
        if ("1798-8".equals(codeString))
          return _17988;
        if ("1799-6".equals(codeString))
          return _17996;
        if ("1800-2".equals(codeString))
          return _18002;
        if ("1801-0".equals(codeString))
          return _18010;
        if ("1802-8".equals(codeString))
          return _18028;
        if ("1803-6".equals(codeString))
          return _18036;
        if ("1804-4".equals(codeString))
          return _18044;
        if ("1805-1".equals(codeString))
          return _18051;
        if ("1806-9".equals(codeString))
          return _18069;
        if ("1807-7".equals(codeString))
          return _18077;
        if ("1808-5".equals(codeString))
          return _18085;
        if ("1809-3".equals(codeString))
          return _18093;
        if ("1078-5".equals(codeString))
          return _10785;
        if ("1080-1".equals(codeString))
          return _10801;
        if ("1082-7".equals(codeString))
          return _10827;
        if ("1083-5".equals(codeString))
          return _10835;
        if ("1084-3".equals(codeString))
          return _10843;
        if ("1086-8".equals(codeString))
          return _10868;
        if ("1088-4".equals(codeString))
          return _10884;
        if ("1089-2".equals(codeString))
          return _10892;
        if ("1090-0".equals(codeString))
          return _10900;
        if ("1091-8".equals(codeString))
          return _10918;
        if ("1092-6".equals(codeString))
          return _10926;
        if ("1093-4".equals(codeString))
          return _10934;
        if ("1094-2".equals(codeString))
          return _10942;
        if ("1095-9".equals(codeString))
          return _10959;
        if ("1096-7".equals(codeString))
          return _10967;
        if ("1097-5".equals(codeString))
          return _10975;
        if ("1098-3".equals(codeString))
          return _10983;
        if ("1100-7".equals(codeString))
          return _11007;
        if ("1102-3".equals(codeString))
          return _11023;
        if ("1103-1".equals(codeString))
          return _11031;
        if ("1104-9".equals(codeString))
          return _11049;
        if ("1106-4".equals(codeString))
          return _11064;
        if ("1108-0".equals(codeString))
          return _11080;
        if ("1109-8".equals(codeString))
          return _11098;
        if ("1110-6".equals(codeString))
          return _11106;
        if ("1112-2".equals(codeString))
          return _11122;
        if ("1114-8".equals(codeString))
          return _11148;
        if ("1115-5".equals(codeString))
          return _11155;
        if ("1116-3".equals(codeString))
          return _11163;
        if ("1117-1".equals(codeString))
          return _11171;
        if ("1118-9".equals(codeString))
          return _11189;
        if ("1119-7".equals(codeString))
          return _11197;
        if ("1120-5".equals(codeString))
          return _11205;
        if ("1121-3".equals(codeString))
          return _11213;
        if ("1123-9".equals(codeString))
          return _11239;
        if ("1124-7".equals(codeString))
          return _11247;
        if ("1125-4".equals(codeString))
          return _11254;
        if ("1126-2".equals(codeString))
          return _11262;
        if ("1127-0".equals(codeString))
          return _11270;
        if ("1128-8".equals(codeString))
          return _11288;
        if ("1129-6".equals(codeString))
          return _11296;
        if ("1130-4".equals(codeString))
          return _11304;
        if ("1131-2".equals(codeString))
          return _11312;
        if ("1132-0".equals(codeString))
          return _11320;
        if ("1133-8".equals(codeString))
          return _11338;
        if ("1134-6".equals(codeString))
          return _11346;
        if ("1135-3".equals(codeString))
          return _11353;
        if ("1136-1".equals(codeString))
          return _11361;
        if ("1137-9".equals(codeString))
          return _11379;
        if ("1138-7".equals(codeString))
          return _11387;
        if ("1139-5".equals(codeString))
          return _11395;
        if ("1140-3".equals(codeString))
          return _11403;
        if ("1141-1".equals(codeString))
          return _11411;
        if ("1142-9".equals(codeString))
          return _11429;
        if ("1143-7".equals(codeString))
          return _11437;
        if ("1144-5".equals(codeString))
          return _11445;
        if ("1145-2".equals(codeString))
          return _11452;
        if ("1146-0".equals(codeString))
          return _11460;
        if ("1147-8".equals(codeString))
          return _11478;
        if ("1148-6".equals(codeString))
          return _11486;
        if ("1150-2".equals(codeString))
          return _11502;
        if ("1151-0".equals(codeString))
          return _11510;
        if ("1153-6".equals(codeString))
          return _11536;
        if ("1155-1".equals(codeString))
          return _11551;
        if ("1156-9".equals(codeString))
          return _11569;
        if ("1157-7".equals(codeString))
          return _11577;
        if ("1158-5".equals(codeString))
          return _11585;
        if ("1159-3".equals(codeString))
          return _11593;
        if ("1160-1".equals(codeString))
          return _11601;
        if ("1162-7".equals(codeString))
          return _11627;
        if ("1163-5".equals(codeString))
          return _11635;
        if ("1165-0".equals(codeString))
          return _11650;
        if ("1167-6".equals(codeString))
          return _11676;
        if ("1169-2".equals(codeString))
          return _11692;
        if ("1171-8".equals(codeString))
          return _11718;
        if ("1173-4".equals(codeString))
          return _11734;
        if ("1175-9".equals(codeString))
          return _11759;
        if ("1176-7".equals(codeString))
          return _11767;
        if ("1178-3".equals(codeString))
          return _11783;
        if ("1180-9".equals(codeString))
          return _11809;
        if ("1182-5".equals(codeString))
          return _11825;
        if ("1184-1".equals(codeString))
          return _11841;
        if ("1186-6".equals(codeString))
          return _11866;
        if ("1187-4".equals(codeString))
          return _11874;
        if ("1189-0".equals(codeString))
          return _11890;
        if ("1191-6".equals(codeString))
          return _11916;
        if ("1193-2".equals(codeString))
          return _11932;
        if ("1194-0".equals(codeString))
          return _11940;
        if ("1195-7".equals(codeString))
          return _11957;
        if ("1196-5".equals(codeString))
          return _11965;
        if ("1197-3".equals(codeString))
          return _11973;
        if ("1198-1".equals(codeString))
          return _11981;
        if ("1199-9".equals(codeString))
          return _11999;
        if ("1200-5".equals(codeString))
          return _12005;
        if ("1201-3".equals(codeString))
          return _12013;
        if ("1202-1".equals(codeString))
          return _12021;
        if ("1203-9".equals(codeString))
          return _12039;
        if ("1204-7".equals(codeString))
          return _12047;
        if ("1205-4".equals(codeString))
          return _12054;
        if ("1207-0".equals(codeString))
          return _12070;
        if ("1209-6".equals(codeString))
          return _12096;
        if ("1211-2".equals(codeString))
          return _12112;
        if ("1212-0".equals(codeString))
          return _12120;
        if ("1214-6".equals(codeString))
          return _12146;
        if ("1215-3".equals(codeString))
          return _12153;
        if ("1216-1".equals(codeString))
          return _12161;
        if ("1217-9".equals(codeString))
          return _12179;
        if ("1218-7".equals(codeString))
          return _12187;
        if ("1219-5".equals(codeString))
          return _12195;
        if ("1220-3".equals(codeString))
          return _12203;
        if ("1222-9".equals(codeString))
          return _12229;
        if ("1223-7".equals(codeString))
          return _12237;
        if ("1224-5".equals(codeString))
          return _12245;
        if ("1225-2".equals(codeString))
          return _12252;
        if ("1226-0".equals(codeString))
          return _12260;
        if ("1227-8".equals(codeString))
          return _12278;
        if ("1228-6".equals(codeString))
          return _12286;
        if ("1229-4".equals(codeString))
          return _12294;
        if ("1230-2".equals(codeString))
          return _12302;
        if ("1231-0".equals(codeString))
          return _12310;
        if ("1233-6".equals(codeString))
          return _12336;
        if ("1234-4".equals(codeString))
          return _12344;
        if ("1235-1".equals(codeString))
          return _12351;
        if ("1236-9".equals(codeString))
          return _12369;
        if ("1237-7".equals(codeString))
          return _12377;
        if ("1238-5".equals(codeString))
          return _12385;
        if ("1239-3".equals(codeString))
          return _12393;
        if ("1240-1".equals(codeString))
          return _12401;
        if ("1241-9".equals(codeString))
          return _12419;
        if ("1242-7".equals(codeString))
          return _12427;
        if ("1243-5".equals(codeString))
          return _12435;
        if ("1244-3".equals(codeString))
          return _12443;
        if ("1245-0".equals(codeString))
          return _12450;
        if ("1246-8".equals(codeString))
          return _12468;
        if ("1247-6".equals(codeString))
          return _12476;
        if ("1248-4".equals(codeString))
          return _12484;
        if ("1250-0".equals(codeString))
          return _12500;
        if ("1252-6".equals(codeString))
          return _12526;
        if ("1254-2".equals(codeString))
          return _12542;
        if ("1256-7".equals(codeString))
          return _12567;
        if ("1258-3".equals(codeString))
          return _12583;
        if ("1260-9".equals(codeString))
          return _12609;
        if ("1262-5".equals(codeString))
          return _12625;
        if ("1264-1".equals(codeString))
          return _12641;
        if ("1265-8".equals(codeString))
          return _12658;
        if ("1267-4".equals(codeString))
          return _12674;
        if ("1269-0".equals(codeString))
          return _12690;
        if ("1271-6".equals(codeString))
          return _12716;
        if ("1272-4".equals(codeString))
          return _12724;
        if ("1273-2".equals(codeString))
          return _12732;
        if ("1275-7".equals(codeString))
          return _12757;
        if ("1277-3".equals(codeString))
          return _12773;
        if ("1279-9".equals(codeString))
          return _12799;
        if ("1281-5".equals(codeString))
          return _12815;
        if ("1282-3".equals(codeString))
          return _12823;
        if ("1283-1".equals(codeString))
          return _12831;
        if ("1285-6".equals(codeString))
          return _12856;
        if ("1286-4".equals(codeString))
          return _12864;
        if ("1287-2".equals(codeString))
          return _12872;
        if ("1288-0".equals(codeString))
          return _12880;
        if ("1289-8".equals(codeString))
          return _12898;
        if ("1290-6".equals(codeString))
          return _12906;
        if ("1291-4".equals(codeString))
          return _12914;
        if ("1292-2".equals(codeString))
          return _12922;
        if ("1293-0".equals(codeString))
          return _12930;
        if ("1294-8".equals(codeString))
          return _12948;
        if ("1295-5".equals(codeString))
          return _12955;
        if ("1297-1".equals(codeString))
          return _12971;
        if ("1299-7".equals(codeString))
          return _12997;
        if ("1301-1".equals(codeString))
          return _13011;
        if ("1303-7".equals(codeString))
          return _13037;
        if ("1305-2".equals(codeString))
          return _13052;
        if ("1306-0".equals(codeString))
          return _13060;
        if ("1307-8".equals(codeString))
          return _13078;
        if ("1309-4".equals(codeString))
          return _13094;
        if ("1310-2".equals(codeString))
          return _13102;
        if ("1312-8".equals(codeString))
          return _13128;
        if ("1313-6".equals(codeString))
          return _13136;
        if ("1314-4".equals(codeString))
          return _13144;
        if ("1315-1".equals(codeString))
          return _13151;
        if ("1317-7".equals(codeString))
          return _13177;
        if ("1319-3".equals(codeString))
          return _13193;
        if ("1321-9".equals(codeString))
          return _13219;
        if ("1323-5".equals(codeString))
          return _13235;
        if ("1325-0".equals(codeString))
          return _13250;
        if ("1326-8".equals(codeString))
          return _13268;
        if ("1327-6".equals(codeString))
          return _13276;
        if ("1328-4".equals(codeString))
          return _13284;
        if ("1329-2".equals(codeString))
          return _13292;
        if ("1331-8".equals(codeString))
          return _13318;
        if ("1332-6".equals(codeString))
          return _13326;
        if ("1333-4".equals(codeString))
          return _13334;
        if ("1334-2".equals(codeString))
          return _13342;
        if ("1335-9".equals(codeString))
          return _13359;
        if ("1336-7".equals(codeString))
          return _13367;
        if ("1337-5".equals(codeString))
          return _13375;
        if ("1338-3".equals(codeString))
          return _13383;
        if ("1340-9".equals(codeString))
          return _13409;
        if ("1342-5".equals(codeString))
          return _13425;
        if ("1344-1".equals(codeString))
          return _13441;
        if ("1345-8".equals(codeString))
          return _13458;
        if ("1346-6".equals(codeString))
          return _13466;
        if ("1348-2".equals(codeString))
          return _13482;
        if ("1350-8".equals(codeString))
          return _13508;
        if ("1352-4".equals(codeString))
          return _13524;
        if ("1354-0".equals(codeString))
          return _13540;
        if ("1356-5".equals(codeString))
          return _13565;
        if ("1358-1".equals(codeString))
          return _13581;
        if ("1359-9".equals(codeString))
          return _13599;
        if ("1360-7".equals(codeString))
          return _13607;
        if ("1361-5".equals(codeString))
          return _13615;
        if ("1363-1".equals(codeString))
          return _13631;
        if ("1365-6".equals(codeString))
          return _13656;
        if ("1366-4".equals(codeString))
          return _13664;
        if ("1368-0".equals(codeString))
          return _13680;
        if ("1370-6".equals(codeString))
          return _13706;
        if ("1372-2".equals(codeString))
          return _13722;
        if ("1374-8".equals(codeString))
          return _13748;
        if ("1376-3".equals(codeString))
          return _13763;
        if ("1378-9".equals(codeString))
          return _13789;
        if ("1380-5".equals(codeString))
          return _13805;
        if ("1382-1".equals(codeString))
          return _13821;
        if ("1383-9".equals(codeString))
          return _13839;
        if ("1384-7".equals(codeString))
          return _13847;
        if ("1385-4".equals(codeString))
          return _13854;
        if ("1387-0".equals(codeString))
          return _13870;
        if ("1389-6".equals(codeString))
          return _13896;
        if ("1391-2".equals(codeString))
          return _13912;
        if ("1392-0".equals(codeString))
          return _13920;
        if ("1393-8".equals(codeString))
          return _13938;
        if ("1394-6".equals(codeString))
          return _13946;
        if ("1395-3".equals(codeString))
          return _13953;
        if ("1396-1".equals(codeString))
          return _13961;
        if ("1397-9".equals(codeString))
          return _13979;
        if ("1398-7".equals(codeString))
          return _13987;
        if ("1399-5".equals(codeString))
          return _13995;
        if ("1400-1".equals(codeString))
          return _14001;
        if ("1401-9".equals(codeString))
          return _14019;
        if ("1403-5".equals(codeString))
          return _14035;
        if ("1405-0".equals(codeString))
          return _14050;
        if ("1407-6".equals(codeString))
          return _14076;
        if ("1409-2".equals(codeString))
          return _14092;
        if ("1411-8".equals(codeString))
          return _14118;
        if ("1412-6".equals(codeString))
          return _14126;
        if ("1413-4".equals(codeString))
          return _14134;
        if ("1414-2".equals(codeString))
          return _14142;
        if ("1416-7".equals(codeString))
          return _14167;
        if ("1417-5".equals(codeString))
          return _14175;
        if ("1418-3".equals(codeString))
          return _14183;
        if ("1419-1".equals(codeString))
          return _14191;
        if ("1420-9".equals(codeString))
          return _14209;
        if ("1421-7".equals(codeString))
          return _14217;
        if ("1422-5".equals(codeString))
          return _14225;
        if ("1423-3".equals(codeString))
          return _14233;
        if ("1424-1".equals(codeString))
          return _14241;
        if ("1425-8".equals(codeString))
          return _14258;
        if ("1426-6".equals(codeString))
          return _14266;
        if ("1427-4".equals(codeString))
          return _14274;
        if ("1428-2".equals(codeString))
          return _14282;
        if ("1429-0".equals(codeString))
          return _14290;
        if ("1430-8".equals(codeString))
          return _14308;
        if ("1431-6".equals(codeString))
          return _14316;
        if ("1432-4".equals(codeString))
          return _14324;
        if ("1433-2".equals(codeString))
          return _14332;
        if ("1434-0".equals(codeString))
          return _14340;
        if ("1435-7".equals(codeString))
          return _14357;
        if ("1436-5".equals(codeString))
          return _14365;
        if ("1437-3".equals(codeString))
          return _14373;
        if ("1439-9".equals(codeString))
          return _14399;
        if ("1441-5".equals(codeString))
          return _14415;
        if ("1442-3".equals(codeString))
          return _14423;
        if ("1443-1".equals(codeString))
          return _14431;
        if ("1445-6".equals(codeString))
          return _14456;
        if ("1446-4".equals(codeString))
          return _14464;
        if ("1448-0".equals(codeString))
          return _14480;
        if ("1450-6".equals(codeString))
          return _14506;
        if ("1451-4".equals(codeString))
          return _14514;
        if ("1453-0".equals(codeString))
          return _14530;
        if ("1454-8".equals(codeString))
          return _14548;
        if ("1456-3".equals(codeString))
          return _14563;
        if ("1457-1".equals(codeString))
          return _14571;
        if ("1458-9".equals(codeString))
          return _14589;
        if ("1460-5".equals(codeString))
          return _14605;
        if ("1462-1".equals(codeString))
          return _14621;
        if ("1464-7".equals(codeString))
          return _14647;
        if ("1465-4".equals(codeString))
          return _14654;
        if ("1466-2".equals(codeString))
          return _14662;
        if ("1467-0".equals(codeString))
          return _14670;
        if ("1468-8".equals(codeString))
          return _14688;
        if ("1469-6".equals(codeString))
          return _14696;
        if ("1470-4".equals(codeString))
          return _14704;
        if ("1471-2".equals(codeString))
          return _14712;
        if ("1472-0".equals(codeString))
          return _14720;
        if ("1474-6".equals(codeString))
          return _14746;
        if ("1475-3".equals(codeString))
          return _14753;
        if ("1476-1".equals(codeString))
          return _14761;
        if ("1478-7".equals(codeString))
          return _14787;
        if ("1479-5".equals(codeString))
          return _14795;
        if ("1480-3".equals(codeString))
          return _14803;
        if ("1481-1".equals(codeString))
          return _14811;
        if ("1482-9".equals(codeString))
          return _14829;
        if ("1483-7".equals(codeString))
          return _14837;
        if ("1484-5".equals(codeString))
          return _14845;
        if ("1485-2".equals(codeString))
          return _14852;
        if ("1487-8".equals(codeString))
          return _14878;
        if ("1489-4".equals(codeString))
          return _14894;
        if ("1490-2".equals(codeString))
          return _14902;
        if ("1491-0".equals(codeString))
          return _14910;
        if ("1492-8".equals(codeString))
          return _14928;
        if ("1493-6".equals(codeString))
          return _14936;
        if ("1494-4".equals(codeString))
          return _14944;
        if ("1495-1".equals(codeString))
          return _14951;
        if ("1496-9".equals(codeString))
          return _14969;
        if ("1497-7".equals(codeString))
          return _14977;
        if ("1498-5".equals(codeString))
          return _14985;
        if ("1499-3".equals(codeString))
          return _14993;
        if ("1500-8".equals(codeString))
          return _15008;
        if ("1501-6".equals(codeString))
          return _15016;
        if ("1502-4".equals(codeString))
          return _15024;
        if ("1503-2".equals(codeString))
          return _15032;
        if ("1504-0".equals(codeString))
          return _15040;
        if ("1505-7".equals(codeString))
          return _15057;
        if ("1506-5".equals(codeString))
          return _15065;
        if ("1507-3".equals(codeString))
          return _15073;
        if ("1508-1".equals(codeString))
          return _15081;
        if ("1509-9".equals(codeString))
          return _15099;
        if ("1510-7".equals(codeString))
          return _15107;
        if ("1511-5".equals(codeString))
          return _15115;
        if ("1512-3".equals(codeString))
          return _15123;
        if ("1513-1".equals(codeString))
          return _15131;
        if ("1514-9".equals(codeString))
          return _15149;
        if ("1515-6".equals(codeString))
          return _15156;
        if ("1516-4".equals(codeString))
          return _15164;
        if ("1518-0".equals(codeString))
          return _15180;
        if ("1519-8".equals(codeString))
          return _15198;
        if ("1520-6".equals(codeString))
          return _15206;
        if ("1521-4".equals(codeString))
          return _15214;
        if ("1522-2".equals(codeString))
          return _15222;
        if ("1523-0".equals(codeString))
          return _15230;
        if ("1524-8".equals(codeString))
          return _15248;
        if ("1525-5".equals(codeString))
          return _15255;
        if ("1526-3".equals(codeString))
          return _15263;
        if ("1527-1".equals(codeString))
          return _15271;
        if ("1528-9".equals(codeString))
          return _15289;
        if ("1529-7".equals(codeString))
          return _15297;
        if ("1530-5".equals(codeString))
          return _15305;
        if ("1531-3".equals(codeString))
          return _15313;
        if ("1532-1".equals(codeString))
          return _15321;
        if ("1533-9".equals(codeString))
          return _15339;
        if ("1534-7".equals(codeString))
          return _15347;
        if ("1535-4".equals(codeString))
          return _15354;
        if ("1536-2".equals(codeString))
          return _15362;
        if ("1537-0".equals(codeString))
          return _15370;
        if ("1538-8".equals(codeString))
          return _15388;
        if ("1539-6".equals(codeString))
          return _15396;
        if ("1541-2".equals(codeString))
          return _15412;
        if ("1543-8".equals(codeString))
          return _15438;
        if ("1545-3".equals(codeString))
          return _15453;
        if ("1547-9".equals(codeString))
          return _15479;
        if ("1549-5".equals(codeString))
          return _15495;
        if ("1551-1".equals(codeString))
          return _15511;
        if ("1552-9".equals(codeString))
          return _15529;
        if ("1553-7".equals(codeString))
          return _15537;
        if ("1554-5".equals(codeString))
          return _15545;
        if ("1556-0".equals(codeString))
          return _15560;
        if ("1558-6".equals(codeString))
          return _15586;
        if ("1560-2".equals(codeString))
          return _15602;
        if ("1562-8".equals(codeString))
          return _15628;
        if ("1564-4".equals(codeString))
          return _15644;
        if ("1566-9".equals(codeString))
          return _15669;
        if ("1567-7".equals(codeString))
          return _15677;
        if ("1568-5".equals(codeString))
          return _15685;
        if ("1569-3".equals(codeString))
          return _15693;
        if ("1570-1".equals(codeString))
          return _15701;
        if ("1571-9".equals(codeString))
          return _15719;
        if ("1573-5".equals(codeString))
          return _15735;
        if ("1574-3".equals(codeString))
          return _15743;
        if ("1576-8".equals(codeString))
          return _15768;
        if ("1578-4".equals(codeString))
          return _15784;
        if ("1579-2".equals(codeString))
          return _15792;
        if ("1580-0".equals(codeString))
          return _15800;
        if ("1582-6".equals(codeString))
          return _15826;
        if ("1584-2".equals(codeString))
          return _15842;
        if ("1586-7".equals(codeString))
          return _15867;
        if ("1587-5".equals(codeString))
          return _15875;
        if ("1588-3".equals(codeString))
          return _15883;
        if ("1589-1".equals(codeString))
          return _15891;
        if ("1590-9".equals(codeString))
          return _15909;
        if ("1591-7".equals(codeString))
          return _15917;
        if ("1592-5".equals(codeString))
          return _15925;
        if ("1593-3".equals(codeString))
          return _15933;
        if ("1594-1".equals(codeString))
          return _15941;
        if ("1595-8".equals(codeString))
          return _15958;
        if ("1596-6".equals(codeString))
          return _15966;
        if ("1597-4".equals(codeString))
          return _15974;
        if ("1598-2".equals(codeString))
          return _15982;
        if ("1599-0".equals(codeString))
          return _15990;
        if ("1600-6".equals(codeString))
          return _16006;
        if ("1602-2".equals(codeString))
          return _16022;
        if ("1603-0".equals(codeString))
          return _16030;
        if ("1604-8".equals(codeString))
          return _16048;
        if ("1605-5".equals(codeString))
          return _16055;
        if ("1607-1".equals(codeString))
          return _16071;
        if ("1609-7".equals(codeString))
          return _16097;
        if ("1610-5".equals(codeString))
          return _16105;
        if ("1611-3".equals(codeString))
          return _16113;
        if ("1612-1".equals(codeString))
          return _16121;
        if ("1613-9".equals(codeString))
          return _16139;
        if ("1614-7".equals(codeString))
          return _16147;
        if ("1615-4".equals(codeString))
          return _16154;
        if ("1616-2".equals(codeString))
          return _16162;
        if ("1617-0".equals(codeString))
          return _16170;
        if ("1618-8".equals(codeString))
          return _16188;
        if ("1619-6".equals(codeString))
          return _16196;
        if ("1620-4".equals(codeString))
          return _16204;
        if ("1621-2".equals(codeString))
          return _16212;
        if ("1622-0".equals(codeString))
          return _16220;
        if ("1623-8".equals(codeString))
          return _16238;
        if ("1624-6".equals(codeString))
          return _16246;
        if ("1625-3".equals(codeString))
          return _16253;
        if ("1626-1".equals(codeString))
          return _16261;
        if ("1627-9".equals(codeString))
          return _16279;
        if ("1628-7".equals(codeString))
          return _16287;
        if ("1629-5".equals(codeString))
          return _16295;
        if ("1630-3".equals(codeString))
          return _16303;
        if ("1631-1".equals(codeString))
          return _16311;
        if ("1632-9".equals(codeString))
          return _16329;
        if ("1633-7".equals(codeString))
          return _16337;
        if ("1634-5".equals(codeString))
          return _16345;
        if ("1635-2".equals(codeString))
          return _16352;
        if ("1636-0".equals(codeString))
          return _16360;
        if ("1637-8".equals(codeString))
          return _16378;
        if ("1638-6".equals(codeString))
          return _16386;
        if ("1639-4".equals(codeString))
          return _16394;
        if ("1640-2".equals(codeString))
          return _16402;
        if ("1641-0".equals(codeString))
          return _16410;
        if ("1643-6".equals(codeString))
          return _16436;
        if ("1645-1".equals(codeString))
          return _16451;
        if ("1647-7".equals(codeString))
          return _16477;
        if ("1649-3".equals(codeString))
          return _16493;
        if ("1651-9".equals(codeString))
          return _16519;
        if ("1653-5".equals(codeString))
          return _16535;
        if ("1654-3".equals(codeString))
          return _16543;
        if ("1655-0".equals(codeString))
          return _16550;
        if ("1656-8".equals(codeString))
          return _16568;
        if ("1657-6".equals(codeString))
          return _16576;
        if ("1659-2".equals(codeString))
          return _16592;
        if ("1661-8".equals(codeString))
          return _16618;
        if ("1663-4".equals(codeString))
          return _16634;
        if ("1665-9".equals(codeString))
          return _16659;
        if ("1667-5".equals(codeString))
          return _16675;
        if ("1668-3".equals(codeString))
          return _16683;
        if ("1670-9".equals(codeString))
          return _16709;
        if ("1671-7".equals(codeString))
          return _16717;
        if ("1672-5".equals(codeString))
          return _16725;
        if ("1673-3".equals(codeString))
          return _16733;
        if ("1675-8".equals(codeString))
          return _16758;
        if ("1677-4".equals(codeString))
          return _16774;
        if ("1679-0".equals(codeString))
          return _16790;
        if ("1680-8".equals(codeString))
          return _16808;
        if ("1681-6".equals(codeString))
          return _16816;
        if ("1683-2".equals(codeString))
          return _16832;
        if ("1685-7".equals(codeString))
          return _16857;
        if ("1687-3".equals(codeString))
          return _16873;
        if ("1688-1".equals(codeString))
          return _16881;
        if ("1689-9".equals(codeString))
          return _16899;
        if ("1690-7".equals(codeString))
          return _16907;
        if ("1692-3".equals(codeString))
          return _16923;
        if ("1694-9".equals(codeString))
          return _16949;
        if ("1696-4".equals(codeString))
          return _16964;
        if ("1697-2".equals(codeString))
          return _16972;
        if ("1698-0".equals(codeString))
          return _16980;
        if ("1700-4".equals(codeString))
          return _17004;
        if ("1702-0".equals(codeString))
          return _17020;
        if ("1704-6".equals(codeString))
          return _17046;
        if ("1705-3".equals(codeString))
          return _17053;
        if ("1707-9".equals(codeString))
          return _17079;
        if ("1709-5".equals(codeString))
          return _17095;
        if ("1711-1".equals(codeString))
          return _17111;
        if ("1712-9".equals(codeString))
          return _17129;
        if ("1713-7".equals(codeString))
          return _17137;
        if ("1715-2".equals(codeString))
          return _17152;
        if ("1717-8".equals(codeString))
          return _17178;
        if ("1718-6".equals(codeString))
          return _17186;
        if ("1719-4".equals(codeString))
          return _17194;
        if ("1720-2".equals(codeString))
          return _17202;
        if ("1722-8".equals(codeString))
          return _17228;
        if ("1724-4".equals(codeString))
          return _17244;
        if ("1725-1".equals(codeString))
          return _17251;
        if ("1726-9".equals(codeString))
          return _17269;
        if ("1727-7".equals(codeString))
          return _17277;
        if ("1728-5".equals(codeString))
          return _17285;
        if ("1729-3".equals(codeString))
          return _17293;
        if ("1730-1".equals(codeString))
          return _17301;
        if ("1731-9".equals(codeString))
          return _17319;
        if ("1732-7".equals(codeString))
          return _17327;
        if ("1733-5".equals(codeString))
          return _17335;
        if ("1735-0".equals(codeString))
          return _17350;
        if ("1737-6".equals(codeString))
          return _17376;
        if ("1739-2".equals(codeString))
          return _17392;
        if ("1740-0".equals(codeString))
          return _17400;
        if ("1811-9".equals(codeString))
          return _18119;
        if ("1813-5".equals(codeString))
          return _18135;
        if ("1814-3".equals(codeString))
          return _18143;
        if ("1815-0".equals(codeString))
          return _18150;
        if ("1816-8".equals(codeString))
          return _18168;
        if ("1817-6".equals(codeString))
          return _18176;
        if ("1818-4".equals(codeString))
          return _18184;
        if ("1819-2".equals(codeString))
          return _18192;
        if ("1820-0".equals(codeString))
          return _18200;
        if ("1821-8".equals(codeString))
          return _18218;
        if ("1822-6".equals(codeString))
          return _18226;
        if ("1823-4".equals(codeString))
          return _18234;
        if ("1824-2".equals(codeString))
          return _18242;
        if ("1825-9".equals(codeString))
          return _18259;
        if ("1826-7".equals(codeString))
          return _18267;
        if ("1827-5".equals(codeString))
          return _18275;
        if ("1828-3".equals(codeString))
          return _18283;
        if ("1829-1".equals(codeString))
          return _18291;
        if ("1830-9".equals(codeString))
          return _18309;
        if ("1831-7".equals(codeString))
          return _18317;
        if ("1832-5".equals(codeString))
          return _18325;
        if ("1833-3".equals(codeString))
          return _18333;
        if ("1834-1".equals(codeString))
          return _18341;
        if ("1835-8".equals(codeString))
          return _18358;
        if ("1837-4".equals(codeString))
          return _18374;
        if ("1838-2".equals(codeString))
          return _18382;
        if ("1840-8".equals(codeString))
          return _18408;
        if ("1842-4".equals(codeString))
          return _18424;
        if ("1844-0".equals(codeString))
          return _18440;
        if ("1845-7".equals(codeString))
          return _18457;
        if ("1846-5".equals(codeString))
          return _18465;
        if ("1847-3".equals(codeString))
          return _18473;
        if ("1848-1".equals(codeString))
          return _18481;
        if ("1849-9".equals(codeString))
          return _18499;
        if ("1850-7".equals(codeString))
          return _18507;
        if ("1851-5".equals(codeString))
          return _18515;
        if ("1852-3".equals(codeString))
          return _18523;
        if ("1853-1".equals(codeString))
          return _18531;
        if ("1854-9".equals(codeString))
          return _18549;
        if ("1855-6".equals(codeString))
          return _18556;
        if ("1856-4".equals(codeString))
          return _18564;
        if ("1857-2".equals(codeString))
          return _18572;
        if ("1858-0".equals(codeString))
          return _18580;
        if ("1859-8".equals(codeString))
          return _18598;
        if ("1860-6".equals(codeString))
          return _18606;
        if ("1861-4".equals(codeString))
          return _18614;
        if ("1862-2".equals(codeString))
          return _18622;
        if ("1863-0".equals(codeString))
          return _18630;
        if ("1864-8".equals(codeString))
          return _18648;
        if ("1865-5".equals(codeString))
          return _18655;
        if ("1866-3".equals(codeString))
          return _18663;
        if ("1867-1".equals(codeString))
          return _18671;
        if ("1868-9".equals(codeString))
          return _18689;
        if ("1869-7".equals(codeString))
          return _18697;
        if ("1870-5".equals(codeString))
          return _18705;
        if ("1871-3".equals(codeString))
          return _18713;
        if ("1872-1".equals(codeString))
          return _18721;
        if ("1873-9".equals(codeString))
          return _18739;
        if ("1874-7".equals(codeString))
          return _18747;
        if ("1875-4".equals(codeString))
          return _18754;
        if ("1876-2".equals(codeString))
          return _18762;
        if ("1877-0".equals(codeString))
          return _18770;
        if ("1878-8".equals(codeString))
          return _18788;
        if ("1879-6".equals(codeString))
          return _18796;
        if ("1880-4".equals(codeString))
          return _18804;
        if ("1881-2".equals(codeString))
          return _18812;
        if ("1882-0".equals(codeString))
          return _18820;
        if ("1883-8".equals(codeString))
          return _18838;
        if ("1884-6".equals(codeString))
          return _18846;
        if ("1885-3".equals(codeString))
          return _18853;
        if ("1886-1".equals(codeString))
          return _18861;
        if ("1887-9".equals(codeString))
          return _18879;
        if ("1888-7".equals(codeString))
          return _18887;
        if ("1889-5".equals(codeString))
          return _18895;
        if ("1891-1".equals(codeString))
          return _18911;
        if ("1892-9".equals(codeString))
          return _18929;
        if ("1893-7".equals(codeString))
          return _18937;
        if ("1894-5".equals(codeString))
          return _18945;
        if ("1896-0".equals(codeString))
          return _18960;
        if ("1897-8".equals(codeString))
          return _18978;
        if ("1898-6".equals(codeString))
          return _18986;
        if ("1899-4".equals(codeString))
          return _18994;
        if ("1900-0".equals(codeString))
          return _19000;
        if ("1901-8".equals(codeString))
          return _19018;
        if ("1902-6".equals(codeString))
          return _19026;
        if ("1903-4".equals(codeString))
          return _19034;
        if ("1904-2".equals(codeString))
          return _19042;
        if ("1905-9".equals(codeString))
          return _19059;
        if ("1906-7".equals(codeString))
          return _19067;
        if ("1907-5".equals(codeString))
          return _19075;
        if ("1908-3".equals(codeString))
          return _19083;
        if ("1909-1".equals(codeString))
          return _19091;
        if ("1910-9".equals(codeString))
          return _19109;
        if ("1911-7".equals(codeString))
          return _19117;
        if ("1912-5".equals(codeString))
          return _19125;
        if ("1913-3".equals(codeString))
          return _19133;
        if ("1914-1".equals(codeString))
          return _19141;
        if ("1915-8".equals(codeString))
          return _19158;
        if ("1916-6".equals(codeString))
          return _19166;
        if ("1917-4".equals(codeString))
          return _19174;
        if ("1918-2".equals(codeString))
          return _19182;
        if ("1919-0".equals(codeString))
          return _19190;
        if ("1920-8".equals(codeString))
          return _19208;
        if ("1921-6".equals(codeString))
          return _19216;
        if ("1922-4".equals(codeString))
          return _19224;
        if ("1923-2".equals(codeString))
          return _19232;
        if ("1924-0".equals(codeString))
          return _19240;
        if ("1925-7".equals(codeString))
          return _19257;
        if ("1926-5".equals(codeString))
          return _19265;
        if ("1927-3".equals(codeString))
          return _19273;
        if ("1928-1".equals(codeString))
          return _19281;
        if ("1929-9".equals(codeString))
          return _19299;
        if ("1930-7".equals(codeString))
          return _19307;
        if ("1931-5".equals(codeString))
          return _19315;
        if ("1932-3".equals(codeString))
          return _19323;
        if ("1933-1".equals(codeString))
          return _19331;
        if ("1934-9".equals(codeString))
          return _19349;
        if ("1935-6".equals(codeString))
          return _19356;
        if ("1936-4".equals(codeString))
          return _19364;
        if ("1937-2".equals(codeString))
          return _19372;
        if ("1938-0".equals(codeString))
          return _19380;
        if ("1939-8".equals(codeString))
          return _19398;
        if ("1940-6".equals(codeString))
          return _19406;
        if ("1941-4".equals(codeString))
          return _19414;
        if ("1942-2".equals(codeString))
          return _19422;
        if ("1943-0".equals(codeString))
          return _19430;
        if ("1944-8".equals(codeString))
          return _19448;
        if ("1945-5".equals(codeString))
          return _19455;
        if ("1946-3".equals(codeString))
          return _19463;
        if ("1947-1".equals(codeString))
          return _19471;
        if ("1948-9".equals(codeString))
          return _19489;
        if ("1949-7".equals(codeString))
          return _19497;
        if ("1950-5".equals(codeString))
          return _19505;
        if ("1951-3".equals(codeString))
          return _19513;
        if ("1952-1".equals(codeString))
          return _19521;
        if ("1953-9".equals(codeString))
          return _19539;
        if ("1954-7".equals(codeString))
          return _19547;
        if ("1955-4".equals(codeString))
          return _19554;
        if ("1956-2".equals(codeString))
          return _19562;
        if ("1957-0".equals(codeString))
          return _19570;
        if ("1958-8".equals(codeString))
          return _19588;
        if ("1959-6".equals(codeString))
          return _19596;
        if ("1960-4".equals(codeString))
          return _19604;
        if ("1961-2".equals(codeString))
          return _19612;
        if ("1962-0".equals(codeString))
          return _19620;
        if ("1963-8".equals(codeString))
          return _19638;
        if ("1964-6".equals(codeString))
          return _19646;
        if ("1966-1".equals(codeString))
          return _19661;
        if ("1968-7".equals(codeString))
          return _19687;
        if ("1969-5".equals(codeString))
          return _19695;
        if ("1970-3".equals(codeString))
          return _19703;
        if ("1972-9".equals(codeString))
          return _19729;
        if ("1973-7".equals(codeString))
          return _19737;
        if ("1974-5".equals(codeString))
          return _19745;
        if ("1975-2".equals(codeString))
          return _19752;
        if ("1976-0".equals(codeString))
          return _19760;
        if ("1977-8".equals(codeString))
          return _19778;
        if ("1978-6".equals(codeString))
          return _19786;
        if ("1979-4".equals(codeString))
          return _19794;
        if ("1980-2".equals(codeString))
          return _19802;
        if ("1981-0".equals(codeString))
          return _19810;
        if ("1982-8".equals(codeString))
          return _19828;
        if ("1984-4".equals(codeString))
          return _19844;
        if ("1985-1".equals(codeString))
          return _19851;
        if ("1986-9".equals(codeString))
          return _19869;
        if ("1987-7".equals(codeString))
          return _19877;
        if ("1988-5".equals(codeString))
          return _19885;
        if ("1990-1".equals(codeString))
          return _19901;
        if ("1992-7".equals(codeString))
          return _19927;
        if ("1993-5".equals(codeString))
          return _19935;
        if ("1994-3".equals(codeString))
          return _19943;
        if ("1995-0".equals(codeString))
          return _19950;
        if ("1996-8".equals(codeString))
          return _19968;
        if ("1997-6".equals(codeString))
          return _19976;
        if ("1998-4".equals(codeString))
          return _19984;
        if ("1999-2".equals(codeString))
          return _19992;
        if ("2000-8".equals(codeString))
          return _20008;
        if ("2002-4".equals(codeString))
          return _20024;
        if ("2004-0".equals(codeString))
          return _20040;
        if ("2006-5".equals(codeString))
          return _20065;
        if ("2007-3".equals(codeString))
          return _20073;
        if ("2008-1".equals(codeString))
          return _20081;
        if ("2009-9".equals(codeString))
          return _20099;
        if ("2010-7".equals(codeString))
          return _20107;
        if ("2011-5".equals(codeString))
          return _20115;
        if ("2012-3".equals(codeString))
          return _20123;
        if ("2013-1".equals(codeString))
          return _20131;
        if ("2014-9".equals(codeString))
          return _20149;
        if ("2015-6".equals(codeString))
          return _20156;
        if ("2016-4".equals(codeString))
          return _20164;
        if ("2017-2".equals(codeString))
          return _20172;
        if ("2018-0".equals(codeString))
          return _20180;
        if ("2019-8".equals(codeString))
          return _20198;
        if ("2020-6".equals(codeString))
          return _20206;
        if ("2021-4".equals(codeString))
          return _20214;
        if ("2022-2".equals(codeString))
          return _20222;
        if ("2023-0".equals(codeString))
          return _20230;
        if ("2024-8".equals(codeString))
          return _20248;
        if ("2025-5".equals(codeString))
          return _20255;
        if ("2026-3".equals(codeString))
          return _20263;
        if ("2028-9".equals(codeString))
          return _20289;
        if ("2029-7".equals(codeString))
          return _20297;
        if ("2030-5".equals(codeString))
          return _20305;
        if ("2031-3".equals(codeString))
          return _20313;
        if ("2032-1".equals(codeString))
          return _20321;
        if ("2033-9".equals(codeString))
          return _20339;
        if ("2034-7".equals(codeString))
          return _20347;
        if ("2035-4".equals(codeString))
          return _20354;
        if ("2036-2".equals(codeString))
          return _20362;
        if ("2037-0".equals(codeString))
          return _20370;
        if ("2038-8".equals(codeString))
          return _20388;
        if ("2039-6".equals(codeString))
          return _20396;
        if ("2040-4".equals(codeString))
          return _20404;
        if ("2041-2".equals(codeString))
          return _20412;
        if ("2042-0".equals(codeString))
          return _20420;
        if ("2043-8".equals(codeString))
          return _20438;
        if ("2044-6".equals(codeString))
          return _20446;
        if ("2045-3".equals(codeString))
          return _20453;
        if ("2046-1".equals(codeString))
          return _20461;
        if ("2047-9".equals(codeString))
          return _20479;
        if ("2048-7".equals(codeString))
          return _20487;
        if ("2049-5".equals(codeString))
          return _20495;
        if ("2050-3".equals(codeString))
          return _20503;
        if ("2051-1".equals(codeString))
          return _20511;
        if ("2052-9".equals(codeString))
          return _20529;
        if ("2054-5".equals(codeString))
          return _20545;
        if ("2056-0".equals(codeString))
          return _20560;
        if ("2058-6".equals(codeString))
          return _20586;
        if ("2060-2".equals(codeString))
          return _20602;
        if ("2061-0".equals(codeString))
          return _20610;
        if ("2062-8".equals(codeString))
          return _20628;
        if ("2063-6".equals(codeString))
          return _20636;
        if ("2064-4".equals(codeString))
          return _20644;
        if ("2065-1".equals(codeString))
          return _20651;
        if ("2066-9".equals(codeString))
          return _20669;
        if ("2067-7".equals(codeString))
          return _20677;
        if ("2068-5".equals(codeString))
          return _20685;
        if ("2069-3".equals(codeString))
          return _20693;
        if ("2070-1".equals(codeString))
          return _20701;
        if ("2071-9".equals(codeString))
          return _20719;
        if ("2072-7".equals(codeString))
          return _20727;
        if ("2073-5".equals(codeString))
          return _20735;
        if ("2074-3".equals(codeString))
          return _20743;
        if ("2075-0".equals(codeString))
          return _20750;
        if ("2076-8".equals(codeString))
          return _20768;
        if ("2078-4".equals(codeString))
          return _20784;
        if ("2079-2".equals(codeString))
          return _20792;
        if ("2080-0".equals(codeString))
          return _20800;
        if ("2081-8".equals(codeString))
          return _20818;
        if ("2082-6".equals(codeString))
          return _20826;
        if ("2083-4".equals(codeString))
          return _20834;
        if ("2085-9".equals(codeString))
          return _20859;
        if ("2086-7".equals(codeString))
          return _20867;
        if ("2087-5".equals(codeString))
          return _20875;
        if ("2088-3".equals(codeString))
          return _20883;
        if ("2089-1".equals(codeString))
          return _20891;
        if ("2090-9".equals(codeString))
          return _20909;
        if ("2091-7".equals(codeString))
          return _20917;
        if ("2092-5".equals(codeString))
          return _20925;
        if ("2093-3".equals(codeString))
          return _20933;
        if ("2094-1".equals(codeString))
          return _20941;
        if ("2095-8".equals(codeString))
          return _20958;
        if ("2096-6".equals(codeString))
          return _20966;
        if ("2097-4".equals(codeString))
          return _20974;
        if ("2098-2".equals(codeString))
          return _20982;
        if ("2100-6".equals(codeString))
          return _21006;
        if ("2101-4".equals(codeString))
          return _21014;
        if ("2102-2".equals(codeString))
          return _21022;
        if ("2103-0".equals(codeString))
          return _21030;
        if ("2104-8".equals(codeString))
          return _21048;
        if ("2500-7".equals(codeString))
          return _25007;
        if ("2106-3".equals(codeString))
          return _21063;
        if ("2108-9".equals(codeString))
          return _21089;
        if ("2109-7".equals(codeString))
          return _21097;
        if ("2110-5".equals(codeString))
          return _21105;
        if ("2111-3".equals(codeString))
          return _21113;
        if ("2112-1".equals(codeString))
          return _21121;
        if ("2113-9".equals(codeString))
          return _21139;
        if ("2114-7".equals(codeString))
          return _21147;
        if ("2115-4".equals(codeString))
          return _21154;
        if ("2116-2".equals(codeString))
          return _21162;
        if ("2118-8".equals(codeString))
          return _21188;
        if ("2119-6".equals(codeString))
          return _21196;
        if ("2120-4".equals(codeString))
          return _21204;
        if ("2121-2".equals(codeString))
          return _21212;
        if ("2122-0".equals(codeString))
          return _21220;
        if ("2123-8".equals(codeString))
          return _21238;
        if ("2124-6".equals(codeString))
          return _21246;
        if ("2125-3".equals(codeString))
          return _21253;
        if ("2126-1".equals(codeString))
          return _21261;
        if ("2127-9".equals(codeString))
          return _21279;
        if ("2129-5".equals(codeString))
          return _21295;
        if ("2131-1".equals(codeString))
          return _21311;
        throw new FHIRException("Unknown V3Race code '"+codeString+"'");
        }
        public String toCode() {
          switch (this) {
            case _10025: return "1002-5";
            case _10041: return "1004-1";
            case _10066: return "1006-6";
            case _10082: return "1008-2";
            case _10108: return "1010-8";
            case _10116: return "1011-6";
            case _10124: return "1012-4";
            case _10132: return "1013-2";
            case _10140: return "1014-0";
            case _10157: return "1015-7";
            case _10165: return "1016-5";
            case _10173: return "1017-3";
            case _10181: return "1018-1";
            case _10199: return "1019-9";
            case _10215: return "1021-5";
            case _10223: return "1022-3";
            case _10231: return "1023-1";
            case _10249: return "1024-9";
            case _10264: return "1026-4";
            case _10280: return "1028-0";
            case _10306: return "1030-6";
            case _10314: return "1031-4";
            case _10330: return "1033-0";
            case _10355: return "1035-5";
            case _10371: return "1037-1";
            case _10397: return "1039-7";
            case _10413: return "1041-3";
            case _10421: return "1042-1";
            case _10447: return "1044-7";
            case _10454: return "1045-4";
            case _10462: return "1046-2";
            case _10470: return "1047-0";
            case _10488: return "1048-8";
            case _10496: return "1049-6";
            case _10504: return "1050-4";
            case _10512: return "1051-2";
            case _10538: return "1053-8";
            case _10546: return "1054-6";
            case _10553: return "1055-3";
            case _10561: return "1056-1";
            case _10579: return "1057-9";
            case _10587: return "1058-7";
            case _10595: return "1059-5";
            case _10603: return "1060-3";
            case _10611: return "1061-1";
            case _10629: return "1062-9";
            case _10637: return "1063-7";
            case _10645: return "1064-5";
            case _10652: return "1065-2";
            case _10660: return "1066-0";
            case _10686: return "1068-6";
            case _10694: return "1069-4";
            case _10702: return "1070-2";
            case _10710: return "1071-0";
            case _10728: return "1072-8";
            case _10736: return "1073-6";
            case _10744: return "1074-4";
            case _10769: return "1076-9";
            case _17418: return "1741-8";
            case _17426: return "1742-6";
            case _17434: return "1743-4";
            case _17442: return "1744-2";
            case _17459: return "1745-9";
            case _17467: return "1746-7";
            case _17475: return "1747-5";
            case _17483: return "1748-3";
            case _17491: return "1749-1";
            case _17509: return "1750-9";
            case _17517: return "1751-7";
            case _17525: return "1752-5";
            case _17533: return "1753-3";
            case _17541: return "1754-1";
            case _17558: return "1755-8";
            case _17566: return "1756-6";
            case _17574: return "1757-4";
            case _17582: return "1758-2";
            case _17590: return "1759-0";
            case _17608: return "1760-8";
            case _17616: return "1761-6";
            case _17624: return "1762-4";
            case _17632: return "1763-2";
            case _17640: return "1764-0";
            case _17657: return "1765-7";
            case _17665: return "1766-5";
            case _17673: return "1767-3";
            case _17681: return "1768-1";
            case _17699: return "1769-9";
            case _17707: return "1770-7";
            case _17715: return "1771-5";
            case _17723: return "1772-3";
            case _17731: return "1773-1";
            case _17749: return "1774-9";
            case _17756: return "1775-6";
            case _17764: return "1776-4";
            case _17772: return "1777-2";
            case _17780: return "1778-0";
            case _17798: return "1779-8";
            case _17806: return "1780-6";
            case _17814: return "1781-4";
            case _17822: return "1782-2";
            case _17830: return "1783-0";
            case _17848: return "1784-8";
            case _17855: return "1785-5";
            case _17863: return "1786-3";
            case _17871: return "1787-1";
            case _17889: return "1788-9";
            case _17897: return "1789-7";
            case _17905: return "1790-5";
            case _17913: return "1791-3";
            case _17921: return "1792-1";
            case _17939: return "1793-9";
            case _17947: return "1794-7";
            case _17954: return "1795-4";
            case _17962: return "1796-2";
            case _17970: return "1797-0";
            case _17988: return "1798-8";
            case _17996: return "1799-6";
            case _18002: return "1800-2";
            case _18010: return "1801-0";
            case _18028: return "1802-8";
            case _18036: return "1803-6";
            case _18044: return "1804-4";
            case _18051: return "1805-1";
            case _18069: return "1806-9";
            case _18077: return "1807-7";
            case _18085: return "1808-5";
            case _18093: return "1809-3";
            case _10785: return "1078-5";
            case _10801: return "1080-1";
            case _10827: return "1082-7";
            case _10835: return "1083-5";
            case _10843: return "1084-3";
            case _10868: return "1086-8";
            case _10884: return "1088-4";
            case _10892: return "1089-2";
            case _10900: return "1090-0";
            case _10918: return "1091-8";
            case _10926: return "1092-6";
            case _10934: return "1093-4";
            case _10942: return "1094-2";
            case _10959: return "1095-9";
            case _10967: return "1096-7";
            case _10975: return "1097-5";
            case _10983: return "1098-3";
            case _11007: return "1100-7";
            case _11023: return "1102-3";
            case _11031: return "1103-1";
            case _11049: return "1104-9";
            case _11064: return "1106-4";
            case _11080: return "1108-0";
            case _11098: return "1109-8";
            case _11106: return "1110-6";
            case _11122: return "1112-2";
            case _11148: return "1114-8";
            case _11155: return "1115-5";
            case _11163: return "1116-3";
            case _11171: return "1117-1";
            case _11189: return "1118-9";
            case _11197: return "1119-7";
            case _11205: return "1120-5";
            case _11213: return "1121-3";
            case _11239: return "1123-9";
            case _11247: return "1124-7";
            case _11254: return "1125-4";
            case _11262: return "1126-2";
            case _11270: return "1127-0";
            case _11288: return "1128-8";
            case _11296: return "1129-6";
            case _11304: return "1130-4";
            case _11312: return "1131-2";
            case _11320: return "1132-0";
            case _11338: return "1133-8";
            case _11346: return "1134-6";
            case _11353: return "1135-3";
            case _11361: return "1136-1";
            case _11379: return "1137-9";
            case _11387: return "1138-7";
            case _11395: return "1139-5";
            case _11403: return "1140-3";
            case _11411: return "1141-1";
            case _11429: return "1142-9";
            case _11437: return "1143-7";
            case _11445: return "1144-5";
            case _11452: return "1145-2";
            case _11460: return "1146-0";
            case _11478: return "1147-8";
            case _11486: return "1148-6";
            case _11502: return "1150-2";
            case _11510: return "1151-0";
            case _11536: return "1153-6";
            case _11551: return "1155-1";
            case _11569: return "1156-9";
            case _11577: return "1157-7";
            case _11585: return "1158-5";
            case _11593: return "1159-3";
            case _11601: return "1160-1";
            case _11627: return "1162-7";
            case _11635: return "1163-5";
            case _11650: return "1165-0";
            case _11676: return "1167-6";
            case _11692: return "1169-2";
            case _11718: return "1171-8";
            case _11734: return "1173-4";
            case _11759: return "1175-9";
            case _11767: return "1176-7";
            case _11783: return "1178-3";
            case _11809: return "1180-9";
            case _11825: return "1182-5";
            case _11841: return "1184-1";
            case _11866: return "1186-6";
            case _11874: return "1187-4";
            case _11890: return "1189-0";
            case _11916: return "1191-6";
            case _11932: return "1193-2";
            case _11940: return "1194-0";
            case _11957: return "1195-7";
            case _11965: return "1196-5";
            case _11973: return "1197-3";
            case _11981: return "1198-1";
            case _11999: return "1199-9";
            case _12005: return "1200-5";
            case _12013: return "1201-3";
            case _12021: return "1202-1";
            case _12039: return "1203-9";
            case _12047: return "1204-7";
            case _12054: return "1205-4";
            case _12070: return "1207-0";
            case _12096: return "1209-6";
            case _12112: return "1211-2";
            case _12120: return "1212-0";
            case _12146: return "1214-6";
            case _12153: return "1215-3";
            case _12161: return "1216-1";
            case _12179: return "1217-9";
            case _12187: return "1218-7";
            case _12195: return "1219-5";
            case _12203: return "1220-3";
            case _12229: return "1222-9";
            case _12237: return "1223-7";
            case _12245: return "1224-5";
            case _12252: return "1225-2";
            case _12260: return "1226-0";
            case _12278: return "1227-8";
            case _12286: return "1228-6";
            case _12294: return "1229-4";
            case _12302: return "1230-2";
            case _12310: return "1231-0";
            case _12336: return "1233-6";
            case _12344: return "1234-4";
            case _12351: return "1235-1";
            case _12369: return "1236-9";
            case _12377: return "1237-7";
            case _12385: return "1238-5";
            case _12393: return "1239-3";
            case _12401: return "1240-1";
            case _12419: return "1241-9";
            case _12427: return "1242-7";
            case _12435: return "1243-5";
            case _12443: return "1244-3";
            case _12450: return "1245-0";
            case _12468: return "1246-8";
            case _12476: return "1247-6";
            case _12484: return "1248-4";
            case _12500: return "1250-0";
            case _12526: return "1252-6";
            case _12542: return "1254-2";
            case _12567: return "1256-7";
            case _12583: return "1258-3";
            case _12609: return "1260-9";
            case _12625: return "1262-5";
            case _12641: return "1264-1";
            case _12658: return "1265-8";
            case _12674: return "1267-4";
            case _12690: return "1269-0";
            case _12716: return "1271-6";
            case _12724: return "1272-4";
            case _12732: return "1273-2";
            case _12757: return "1275-7";
            case _12773: return "1277-3";
            case _12799: return "1279-9";
            case _12815: return "1281-5";
            case _12823: return "1282-3";
            case _12831: return "1283-1";
            case _12856: return "1285-6";
            case _12864: return "1286-4";
            case _12872: return "1287-2";
            case _12880: return "1288-0";
            case _12898: return "1289-8";
            case _12906: return "1290-6";
            case _12914: return "1291-4";
            case _12922: return "1292-2";
            case _12930: return "1293-0";
            case _12948: return "1294-8";
            case _12955: return "1295-5";
            case _12971: return "1297-1";
            case _12997: return "1299-7";
            case _13011: return "1301-1";
            case _13037: return "1303-7";
            case _13052: return "1305-2";
            case _13060: return "1306-0";
            case _13078: return "1307-8";
            case _13094: return "1309-4";
            case _13102: return "1310-2";
            case _13128: return "1312-8";
            case _13136: return "1313-6";
            case _13144: return "1314-4";
            case _13151: return "1315-1";
            case _13177: return "1317-7";
            case _13193: return "1319-3";
            case _13219: return "1321-9";
            case _13235: return "1323-5";
            case _13250: return "1325-0";
            case _13268: return "1326-8";
            case _13276: return "1327-6";
            case _13284: return "1328-4";
            case _13292: return "1329-2";
            case _13318: return "1331-8";
            case _13326: return "1332-6";
            case _13334: return "1333-4";
            case _13342: return "1334-2";
            case _13359: return "1335-9";
            case _13367: return "1336-7";
            case _13375: return "1337-5";
            case _13383: return "1338-3";
            case _13409: return "1340-9";
            case _13425: return "1342-5";
            case _13441: return "1344-1";
            case _13458: return "1345-8";
            case _13466: return "1346-6";
            case _13482: return "1348-2";
            case _13508: return "1350-8";
            case _13524: return "1352-4";
            case _13540: return "1354-0";
            case _13565: return "1356-5";
            case _13581: return "1358-1";
            case _13599: return "1359-9";
            case _13607: return "1360-7";
            case _13615: return "1361-5";
            case _13631: return "1363-1";
            case _13656: return "1365-6";
            case _13664: return "1366-4";
            case _13680: return "1368-0";
            case _13706: return "1370-6";
            case _13722: return "1372-2";
            case _13748: return "1374-8";
            case _13763: return "1376-3";
            case _13789: return "1378-9";
            case _13805: return "1380-5";
            case _13821: return "1382-1";
            case _13839: return "1383-9";
            case _13847: return "1384-7";
            case _13854: return "1385-4";
            case _13870: return "1387-0";
            case _13896: return "1389-6";
            case _13912: return "1391-2";
            case _13920: return "1392-0";
            case _13938: return "1393-8";
            case _13946: return "1394-6";
            case _13953: return "1395-3";
            case _13961: return "1396-1";
            case _13979: return "1397-9";
            case _13987: return "1398-7";
            case _13995: return "1399-5";
            case _14001: return "1400-1";
            case _14019: return "1401-9";
            case _14035: return "1403-5";
            case _14050: return "1405-0";
            case _14076: return "1407-6";
            case _14092: return "1409-2";
            case _14118: return "1411-8";
            case _14126: return "1412-6";
            case _14134: return "1413-4";
            case _14142: return "1414-2";
            case _14167: return "1416-7";
            case _14175: return "1417-5";
            case _14183: return "1418-3";
            case _14191: return "1419-1";
            case _14209: return "1420-9";
            case _14217: return "1421-7";
            case _14225: return "1422-5";
            case _14233: return "1423-3";
            case _14241: return "1424-1";
            case _14258: return "1425-8";
            case _14266: return "1426-6";
            case _14274: return "1427-4";
            case _14282: return "1428-2";
            case _14290: return "1429-0";
            case _14308: return "1430-8";
            case _14316: return "1431-6";
            case _14324: return "1432-4";
            case _14332: return "1433-2";
            case _14340: return "1434-0";
            case _14357: return "1435-7";
            case _14365: return "1436-5";
            case _14373: return "1437-3";
            case _14399: return "1439-9";
            case _14415: return "1441-5";
            case _14423: return "1442-3";
            case _14431: return "1443-1";
            case _14456: return "1445-6";
            case _14464: return "1446-4";
            case _14480: return "1448-0";
            case _14506: return "1450-6";
            case _14514: return "1451-4";
            case _14530: return "1453-0";
            case _14548: return "1454-8";
            case _14563: return "1456-3";
            case _14571: return "1457-1";
            case _14589: return "1458-9";
            case _14605: return "1460-5";
            case _14621: return "1462-1";
            case _14647: return "1464-7";
            case _14654: return "1465-4";
            case _14662: return "1466-2";
            case _14670: return "1467-0";
            case _14688: return "1468-8";
            case _14696: return "1469-6";
            case _14704: return "1470-4";
            case _14712: return "1471-2";
            case _14720: return "1472-0";
            case _14746: return "1474-6";
            case _14753: return "1475-3";
            case _14761: return "1476-1";
            case _14787: return "1478-7";
            case _14795: return "1479-5";
            case _14803: return "1480-3";
            case _14811: return "1481-1";
            case _14829: return "1482-9";
            case _14837: return "1483-7";
            case _14845: return "1484-5";
            case _14852: return "1485-2";
            case _14878: return "1487-8";
            case _14894: return "1489-4";
            case _14902: return "1490-2";
            case _14910: return "1491-0";
            case _14928: return "1492-8";
            case _14936: return "1493-6";
            case _14944: return "1494-4";
            case _14951: return "1495-1";
            case _14969: return "1496-9";
            case _14977: return "1497-7";
            case _14985: return "1498-5";
            case _14993: return "1499-3";
            case _15008: return "1500-8";
            case _15016: return "1501-6";
            case _15024: return "1502-4";
            case _15032: return "1503-2";
            case _15040: return "1504-0";
            case _15057: return "1505-7";
            case _15065: return "1506-5";
            case _15073: return "1507-3";
            case _15081: return "1508-1";
            case _15099: return "1509-9";
            case _15107: return "1510-7";
            case _15115: return "1511-5";
            case _15123: return "1512-3";
            case _15131: return "1513-1";
            case _15149: return "1514-9";
            case _15156: return "1515-6";
            case _15164: return "1516-4";
            case _15180: return "1518-0";
            case _15198: return "1519-8";
            case _15206: return "1520-6";
            case _15214: return "1521-4";
            case _15222: return "1522-2";
            case _15230: return "1523-0";
            case _15248: return "1524-8";
            case _15255: return "1525-5";
            case _15263: return "1526-3";
            case _15271: return "1527-1";
            case _15289: return "1528-9";
            case _15297: return "1529-7";
            case _15305: return "1530-5";
            case _15313: return "1531-3";
            case _15321: return "1532-1";
            case _15339: return "1533-9";
            case _15347: return "1534-7";
            case _15354: return "1535-4";
            case _15362: return "1536-2";
            case _15370: return "1537-0";
            case _15388: return "1538-8";
            case _15396: return "1539-6";
            case _15412: return "1541-2";
            case _15438: return "1543-8";
            case _15453: return "1545-3";
            case _15479: return "1547-9";
            case _15495: return "1549-5";
            case _15511: return "1551-1";
            case _15529: return "1552-9";
            case _15537: return "1553-7";
            case _15545: return "1554-5";
            case _15560: return "1556-0";
            case _15586: return "1558-6";
            case _15602: return "1560-2";
            case _15628: return "1562-8";
            case _15644: return "1564-4";
            case _15669: return "1566-9";
            case _15677: return "1567-7";
            case _15685: return "1568-5";
            case _15693: return "1569-3";
            case _15701: return "1570-1";
            case _15719: return "1571-9";
            case _15735: return "1573-5";
            case _15743: return "1574-3";
            case _15768: return "1576-8";
            case _15784: return "1578-4";
            case _15792: return "1579-2";
            case _15800: return "1580-0";
            case _15826: return "1582-6";
            case _15842: return "1584-2";
            case _15867: return "1586-7";
            case _15875: return "1587-5";
            case _15883: return "1588-3";
            case _15891: return "1589-1";
            case _15909: return "1590-9";
            case _15917: return "1591-7";
            case _15925: return "1592-5";
            case _15933: return "1593-3";
            case _15941: return "1594-1";
            case _15958: return "1595-8";
            case _15966: return "1596-6";
            case _15974: return "1597-4";
            case _15982: return "1598-2";
            case _15990: return "1599-0";
            case _16006: return "1600-6";
            case _16022: return "1602-2";
            case _16030: return "1603-0";
            case _16048: return "1604-8";
            case _16055: return "1605-5";
            case _16071: return "1607-1";
            case _16097: return "1609-7";
            case _16105: return "1610-5";
            case _16113: return "1611-3";
            case _16121: return "1612-1";
            case _16139: return "1613-9";
            case _16147: return "1614-7";
            case _16154: return "1615-4";
            case _16162: return "1616-2";
            case _16170: return "1617-0";
            case _16188: return "1618-8";
            case _16196: return "1619-6";
            case _16204: return "1620-4";
            case _16212: return "1621-2";
            case _16220: return "1622-0";
            case _16238: return "1623-8";
            case _16246: return "1624-6";
            case _16253: return "1625-3";
            case _16261: return "1626-1";
            case _16279: return "1627-9";
            case _16287: return "1628-7";
            case _16295: return "1629-5";
            case _16303: return "1630-3";
            case _16311: return "1631-1";
            case _16329: return "1632-9";
            case _16337: return "1633-7";
            case _16345: return "1634-5";
            case _16352: return "1635-2";
            case _16360: return "1636-0";
            case _16378: return "1637-8";
            case _16386: return "1638-6";
            case _16394: return "1639-4";
            case _16402: return "1640-2";
            case _16410: return "1641-0";
            case _16436: return "1643-6";
            case _16451: return "1645-1";
            case _16477: return "1647-7";
            case _16493: return "1649-3";
            case _16519: return "1651-9";
            case _16535: return "1653-5";
            case _16543: return "1654-3";
            case _16550: return "1655-0";
            case _16568: return "1656-8";
            case _16576: return "1657-6";
            case _16592: return "1659-2";
            case _16618: return "1661-8";
            case _16634: return "1663-4";
            case _16659: return "1665-9";
            case _16675: return "1667-5";
            case _16683: return "1668-3";
            case _16709: return "1670-9";
            case _16717: return "1671-7";
            case _16725: return "1672-5";
            case _16733: return "1673-3";
            case _16758: return "1675-8";
            case _16774: return "1677-4";
            case _16790: return "1679-0";
            case _16808: return "1680-8";
            case _16816: return "1681-6";
            case _16832: return "1683-2";
            case _16857: return "1685-7";
            case _16873: return "1687-3";
            case _16881: return "1688-1";
            case _16899: return "1689-9";
            case _16907: return "1690-7";
            case _16923: return "1692-3";
            case _16949: return "1694-9";
            case _16964: return "1696-4";
            case _16972: return "1697-2";
            case _16980: return "1698-0";
            case _17004: return "1700-4";
            case _17020: return "1702-0";
            case _17046: return "1704-6";
            case _17053: return "1705-3";
            case _17079: return "1707-9";
            case _17095: return "1709-5";
            case _17111: return "1711-1";
            case _17129: return "1712-9";
            case _17137: return "1713-7";
            case _17152: return "1715-2";
            case _17178: return "1717-8";
            case _17186: return "1718-6";
            case _17194: return "1719-4";
            case _17202: return "1720-2";
            case _17228: return "1722-8";
            case _17244: return "1724-4";
            case _17251: return "1725-1";
            case _17269: return "1726-9";
            case _17277: return "1727-7";
            case _17285: return "1728-5";
            case _17293: return "1729-3";
            case _17301: return "1730-1";
            case _17319: return "1731-9";
            case _17327: return "1732-7";
            case _17335: return "1733-5";
            case _17350: return "1735-0";
            case _17376: return "1737-6";
            case _17392: return "1739-2";
            case _17400: return "1740-0";
            case _18119: return "1811-9";
            case _18135: return "1813-5";
            case _18143: return "1814-3";
            case _18150: return "1815-0";
            case _18168: return "1816-8";
            case _18176: return "1817-6";
            case _18184: return "1818-4";
            case _18192: return "1819-2";
            case _18200: return "1820-0";
            case _18218: return "1821-8";
            case _18226: return "1822-6";
            case _18234: return "1823-4";
            case _18242: return "1824-2";
            case _18259: return "1825-9";
            case _18267: return "1826-7";
            case _18275: return "1827-5";
            case _18283: return "1828-3";
            case _18291: return "1829-1";
            case _18309: return "1830-9";
            case _18317: return "1831-7";
            case _18325: return "1832-5";
            case _18333: return "1833-3";
            case _18341: return "1834-1";
            case _18358: return "1835-8";
            case _18374: return "1837-4";
            case _18382: return "1838-2";
            case _18408: return "1840-8";
            case _18424: return "1842-4";
            case _18440: return "1844-0";
            case _18457: return "1845-7";
            case _18465: return "1846-5";
            case _18473: return "1847-3";
            case _18481: return "1848-1";
            case _18499: return "1849-9";
            case _18507: return "1850-7";
            case _18515: return "1851-5";
            case _18523: return "1852-3";
            case _18531: return "1853-1";
            case _18549: return "1854-9";
            case _18556: return "1855-6";
            case _18564: return "1856-4";
            case _18572: return "1857-2";
            case _18580: return "1858-0";
            case _18598: return "1859-8";
            case _18606: return "1860-6";
            case _18614: return "1861-4";
            case _18622: return "1862-2";
            case _18630: return "1863-0";
            case _18648: return "1864-8";
            case _18655: return "1865-5";
            case _18663: return "1866-3";
            case _18671: return "1867-1";
            case _18689: return "1868-9";
            case _18697: return "1869-7";
            case _18705: return "1870-5";
            case _18713: return "1871-3";
            case _18721: return "1872-1";
            case _18739: return "1873-9";
            case _18747: return "1874-7";
            case _18754: return "1875-4";
            case _18762: return "1876-2";
            case _18770: return "1877-0";
            case _18788: return "1878-8";
            case _18796: return "1879-6";
            case _18804: return "1880-4";
            case _18812: return "1881-2";
            case _18820: return "1882-0";
            case _18838: return "1883-8";
            case _18846: return "1884-6";
            case _18853: return "1885-3";
            case _18861: return "1886-1";
            case _18879: return "1887-9";
            case _18887: return "1888-7";
            case _18895: return "1889-5";
            case _18911: return "1891-1";
            case _18929: return "1892-9";
            case _18937: return "1893-7";
            case _18945: return "1894-5";
            case _18960: return "1896-0";
            case _18978: return "1897-8";
            case _18986: return "1898-6";
            case _18994: return "1899-4";
            case _19000: return "1900-0";
            case _19018: return "1901-8";
            case _19026: return "1902-6";
            case _19034: return "1903-4";
            case _19042: return "1904-2";
            case _19059: return "1905-9";
            case _19067: return "1906-7";
            case _19075: return "1907-5";
            case _19083: return "1908-3";
            case _19091: return "1909-1";
            case _19109: return "1910-9";
            case _19117: return "1911-7";
            case _19125: return "1912-5";
            case _19133: return "1913-3";
            case _19141: return "1914-1";
            case _19158: return "1915-8";
            case _19166: return "1916-6";
            case _19174: return "1917-4";
            case _19182: return "1918-2";
            case _19190: return "1919-0";
            case _19208: return "1920-8";
            case _19216: return "1921-6";
            case _19224: return "1922-4";
            case _19232: return "1923-2";
            case _19240: return "1924-0";
            case _19257: return "1925-7";
            case _19265: return "1926-5";
            case _19273: return "1927-3";
            case _19281: return "1928-1";
            case _19299: return "1929-9";
            case _19307: return "1930-7";
            case _19315: return "1931-5";
            case _19323: return "1932-3";
            case _19331: return "1933-1";
            case _19349: return "1934-9";
            case _19356: return "1935-6";
            case _19364: return "1936-4";
            case _19372: return "1937-2";
            case _19380: return "1938-0";
            case _19398: return "1939-8";
            case _19406: return "1940-6";
            case _19414: return "1941-4";
            case _19422: return "1942-2";
            case _19430: return "1943-0";
            case _19448: return "1944-8";
            case _19455: return "1945-5";
            case _19463: return "1946-3";
            case _19471: return "1947-1";
            case _19489: return "1948-9";
            case _19497: return "1949-7";
            case _19505: return "1950-5";
            case _19513: return "1951-3";
            case _19521: return "1952-1";
            case _19539: return "1953-9";
            case _19547: return "1954-7";
            case _19554: return "1955-4";
            case _19562: return "1956-2";
            case _19570: return "1957-0";
            case _19588: return "1958-8";
            case _19596: return "1959-6";
            case _19604: return "1960-4";
            case _19612: return "1961-2";
            case _19620: return "1962-0";
            case _19638: return "1963-8";
            case _19646: return "1964-6";
            case _19661: return "1966-1";
            case _19687: return "1968-7";
            case _19695: return "1969-5";
            case _19703: return "1970-3";
            case _19729: return "1972-9";
            case _19737: return "1973-7";
            case _19745: return "1974-5";
            case _19752: return "1975-2";
            case _19760: return "1976-0";
            case _19778: return "1977-8";
            case _19786: return "1978-6";
            case _19794: return "1979-4";
            case _19802: return "1980-2";
            case _19810: return "1981-0";
            case _19828: return "1982-8";
            case _19844: return "1984-4";
            case _19851: return "1985-1";
            case _19869: return "1986-9";
            case _19877: return "1987-7";
            case _19885: return "1988-5";
            case _19901: return "1990-1";
            case _19927: return "1992-7";
            case _19935: return "1993-5";
            case _19943: return "1994-3";
            case _19950: return "1995-0";
            case _19968: return "1996-8";
            case _19976: return "1997-6";
            case _19984: return "1998-4";
            case _19992: return "1999-2";
            case _20008: return "2000-8";
            case _20024: return "2002-4";
            case _20040: return "2004-0";
            case _20065: return "2006-5";
            case _20073: return "2007-3";
            case _20081: return "2008-1";
            case _20099: return "2009-9";
            case _20107: return "2010-7";
            case _20115: return "2011-5";
            case _20123: return "2012-3";
            case _20131: return "2013-1";
            case _20149: return "2014-9";
            case _20156: return "2015-6";
            case _20164: return "2016-4";
            case _20172: return "2017-2";
            case _20180: return "2018-0";
            case _20198: return "2019-8";
            case _20206: return "2020-6";
            case _20214: return "2021-4";
            case _20222: return "2022-2";
            case _20230: return "2023-0";
            case _20248: return "2024-8";
            case _20255: return "2025-5";
            case _20263: return "2026-3";
            case _20289: return "2028-9";
            case _20297: return "2029-7";
            case _20305: return "2030-5";
            case _20313: return "2031-3";
            case _20321: return "2032-1";
            case _20339: return "2033-9";
            case _20347: return "2034-7";
            case _20354: return "2035-4";
            case _20362: return "2036-2";
            case _20370: return "2037-0";
            case _20388: return "2038-8";
            case _20396: return "2039-6";
            case _20404: return "2040-4";
            case _20412: return "2041-2";
            case _20420: return "2042-0";
            case _20438: return "2043-8";
            case _20446: return "2044-6";
            case _20453: return "2045-3";
            case _20461: return "2046-1";
            case _20479: return "2047-9";
            case _20487: return "2048-7";
            case _20495: return "2049-5";
            case _20503: return "2050-3";
            case _20511: return "2051-1";
            case _20529: return "2052-9";
            case _20545: return "2054-5";
            case _20560: return "2056-0";
            case _20586: return "2058-6";
            case _20602: return "2060-2";
            case _20610: return "2061-0";
            case _20628: return "2062-8";
            case _20636: return "2063-6";
            case _20644: return "2064-4";
            case _20651: return "2065-1";
            case _20669: return "2066-9";
            case _20677: return "2067-7";
            case _20685: return "2068-5";
            case _20693: return "2069-3";
            case _20701: return "2070-1";
            case _20719: return "2071-9";
            case _20727: return "2072-7";
            case _20735: return "2073-5";
            case _20743: return "2074-3";
            case _20750: return "2075-0";
            case _20768: return "2076-8";
            case _20784: return "2078-4";
            case _20792: return "2079-2";
            case _20800: return "2080-0";
            case _20818: return "2081-8";
            case _20826: return "2082-6";
            case _20834: return "2083-4";
            case _20859: return "2085-9";
            case _20867: return "2086-7";
            case _20875: return "2087-5";
            case _20883: return "2088-3";
            case _20891: return "2089-1";
            case _20909: return "2090-9";
            case _20917: return "2091-7";
            case _20925: return "2092-5";
            case _20933: return "2093-3";
            case _20941: return "2094-1";
            case _20958: return "2095-8";
            case _20966: return "2096-6";
            case _20974: return "2097-4";
            case _20982: return "2098-2";
            case _21006: return "2100-6";
            case _21014: return "2101-4";
            case _21022: return "2102-2";
            case _21030: return "2103-0";
            case _21048: return "2104-8";
            case _25007: return "2500-7";
            case _21063: return "2106-3";
            case _21089: return "2108-9";
            case _21097: return "2109-7";
            case _21105: return "2110-5";
            case _21113: return "2111-3";
            case _21121: return "2112-1";
            case _21139: return "2113-9";
            case _21147: return "2114-7";
            case _21154: return "2115-4";
            case _21162: return "2116-2";
            case _21188: return "2118-8";
            case _21196: return "2119-6";
            case _21204: return "2120-4";
            case _21212: return "2121-2";
            case _21220: return "2122-0";
            case _21238: return "2123-8";
            case _21246: return "2124-6";
            case _21253: return "2125-3";
            case _21261: return "2126-1";
            case _21279: return "2127-9";
            case _21295: return "2129-5";
            case _21311: return "2131-1";
            default: return "?";
          }
        }
        public String getSystem() {
          return "http://hl7.org/fhir/v3/Race";
        }
        public String getDefinition() {
          switch (this) {
            case _10025: return "American Indian or Alaska Native";
            case _10041: return "American Indian";
            case _10066: return "Abenaki";
            case _10082: return "Algonquian";
            case _10108: return "Apache";
            case _10116: return "Chiricahua";
            case _10124: return "Fort Sill Apache";
            case _10132: return "Jicarilla Apache";
            case _10140: return "Lipan Apache";
            case _10157: return "Mescalero Apache";
            case _10165: return "Oklahoma Apache";
            case _10173: return "Payson Apache";
            case _10181: return "San Carlos Apache";
            case _10199: return "White Mountain Apache";
            case _10215: return "Arapaho";
            case _10223: return "Northern Arapaho";
            case _10231: return "Southern Arapaho";
            case _10249: return "Wind River Arapaho";
            case _10264: return "Arikara";
            case _10280: return "Assiniboine";
            case _10306: return "Assiniboine Sioux";
            case _10314: return "Fort Peck Assiniboine Sioux";
            case _10330: return "Bannock";
            case _10355: return "Blackfeet";
            case _10371: return "Brotherton";
            case _10397: return "Burt Lake Band";
            case _10413: return "Caddo";
            case _10421: return "Oklahoma Cado";
            case _10447: return "Cahuilla";
            case _10454: return "Agua Caliente Cahuilla";
            case _10462: return "Augustine";
            case _10470: return "Cabazon";
            case _10488: return "Los Coyotes";
            case _10496: return "Morongo";
            case _10504: return "Santa Rosa Cahuilla";
            case _10512: return "Torres-Martinez";
            case _10538: return "California Tribes";
            case _10546: return "Cahto";
            case _10553: return "Chimariko";
            case _10561: return "Coast Miwok";
            case _10579: return "Digger";
            case _10587: return "Kawaiisu";
            case _10595: return "Kern River";
            case _10603: return "Mattole";
            case _10611: return "Red Wood";
            case _10629: return "Santa Rosa";
            case _10637: return "Takelma";
            case _10645: return "Wappo";
            case _10652: return "Yana";
            case _10660: return "Yuki";
            case _10686: return "Canadian and Latin American Indian";
            case _10694: return "Canadian Indian";
            case _10702: return "Central American Indian";
            case _10710: return "French American Indian";
            case _10728: return "Mexican American Indian";
            case _10736: return "South American Indian";
            case _10744: return "Spanish American Indian";
            case _10769: return "Catawba";
            case _17418: return "Alatna";
            case _17426: return "Alexander";
            case _17434: return "Allakaket";
            case _17442: return "Alanvik";
            case _17459: return "Anvik";
            case _17467: return "Arctic";
            case _17475: return "Beaver";
            case _17483: return "Birch Creek";
            case _17491: return "Cantwell";
            case _17509: return "Chalkyitsik";
            case _17517: return "Chickaloon";
            case _17525: return "Chistochina";
            case _17533: return "Chitina";
            case _17541: return "Circle";
            case _17558: return "Cook Inlet";
            case _17566: return "Copper Center";
            case _17574: return "Copper River";
            case _17582: return "Dot Lake";
            case _17590: return "Doyon";
            case _17608: return "Eagle";
            case _17616: return "Eklutna";
            case _17624: return "Evansville";
            case _17632: return "Fort Yukon";
            case _17640: return "Gakona";
            case _17657: return "Galena";
            case _17665: return "Grayling";
            case _17673: return "Gulkana";
            case _17681: return "Healy Lake";
            case _17699: return "Holy Cross";
            case _17707: return "Hughes";
            case _17715: return "Huslia";
            case _17723: return "Iliamna";
            case _17731: return "Kaltag";
            case _17749: return "Kluti Kaah";
            case _17756: return "Knik";
            case _17764: return "Koyukuk";
            case _17772: return "Lake Minchumina";
            case _17780: return "Lime";
            case _17798: return "Mcgrath";
            case _17806: return "Manley Hot Springs";
            case _17814: return "Mentasta Lake";
            case _17822: return "Minto";
            case _17830: return "Nenana";
            case _17848: return "Nikolai";
            case _17855: return "Ninilchik";
            case _17863: return "Nondalton";
            case _17871: return "Northway";
            case _17889: return "Nulato";
            case _17897: return "Pedro Bay";
            case _17905: return "Rampart";
            case _17913: return "Ruby";
            case _17921: return "Salamatof";
            case _17939: return "Seldovia";
            case _17947: return "Slana";
            case _17954: return "Shageluk";
            case _17962: return "Stevens";
            case _17970: return "Stony River";
            case _17988: return "Takotna";
            case _17996: return "Tanacross";
            case _18002: return "Tanaina";
            case _18010: return "Tanana";
            case _18028: return "Tanana Chiefs";
            case _18036: return "Tazlina";
            case _18044: return "Telida";
            case _18051: return "Tetlin";
            case _18069: return "Tok";
            case _18077: return "Tyonek";
            case _18085: return "Venetie";
            case _18093: return "Wiseman";
            case _10785: return "Cayuse";
            case _10801: return "Chehalis";
            case _10827: return "Chemakuan";
            case _10835: return "Hoh";
            case _10843: return "Quileute";
            case _10868: return "Chemehuevi";
            case _10884: return "Cherokee";
            case _10892: return "Cherokee Alabama";
            case _10900: return "Cherokees of Northeast Alabama";
            case _10918: return "Cherokees of Southeast Alabama";
            case _10926: return "Eastern Cherokee";
            case _10934: return "Echota Cherokee";
            case _10942: return "Etowah Cherokee";
            case _10959: return "Northern Cherokee";
            case _10967: return "Tuscola";
            case _10975: return "United Keetowah Band of Cherokee";
            case _10983: return "Western Cherokee";
            case _11007: return "Cherokee Shawnee";
            case _11023: return "Cheyenne";
            case _11031: return "Northern Cheyenne";
            case _11049: return "Southern Cheyenne";
            case _11064: return "Cheyenne-Arapaho";
            case _11080: return "Chickahominy";
            case _11098: return "Eastern Chickahominy";
            case _11106: return "Western Chickahominy";
            case _11122: return "Chickasaw";
            case _11148: return "Chinook";
            case _11155: return "Clatsop";
            case _11163: return "Columbia River Chinook";
            case _11171: return "Kathlamet";
            case _11189: return "Upper Chinook";
            case _11197: return "Wakiakum Chinook";
            case _11205: return "Willapa Chinook";
            case _11213: return "Wishram";
            case _11239: return "Chippewa";
            case _11247: return "Bad River";
            case _11254: return "Bay Mills Chippewa";
            case _11262: return "Bois Forte";
            case _11270: return "Burt Lake Chippewa";
            case _11288: return "Fond du Lac";
            case _11296: return "Grand Portage";
            case _11304: return "Grand Traverse Band of Ottawa-Chippewa";
            case _11312: return "Keweenaw";
            case _11320: return "Lac Courte Oreilles";
            case _11338: return "Lac du Flambeau";
            case _11346: return "Lac Vieux Desert Chippewa";
            case _11353: return "Lake Superior";
            case _11361: return "Leech Lake";
            case _11379: return "Little Shell Chippewa";
            case _11387: return "Mille Lacs";
            case _11395: return "Minnesota Chippewa";
            case _11403: return "Ontonagon";
            case _11411: return "Red Cliff Chippewa";
            case _11429: return "Red Lake Chippewa";
            case _11437: return "Saginaw Chippewa";
            case _11445: return "St. Croix Chippewa";
            case _11452: return "Sault Ste. Marie Chippewa";
            case _11460: return "Sokoagon Chippewa";
            case _11478: return "Turtle Mountain";
            case _11486: return "White Earth";
            case _11502: return "Chippewa Cree";
            case _11510: return "Rocky Boy's Chippewa Cree";
            case _11536: return "Chitimacha";
            case _11551: return "Choctaw";
            case _11569: return "Clifton Choctaw";
            case _11577: return "Jena Choctaw";
            case _11585: return "Mississippi Choctaw";
            case _11593: return "Mowa Band of Choctaw";
            case _11601: return "Oklahoma Choctaw";
            case _11627: return "Chumash";
            case _11635: return "Santa Ynez";
            case _11650: return "Clear Lake";
            case _11676: return "Coeur D'Alene";
            case _11692: return "Coharie";
            case _11718: return "Colorado River";
            case _11734: return "Colville";
            case _11759: return "Comanche";
            case _11767: return "Oklahoma Comanche";
            case _11783: return "Coos, Lower Umpqua, Siuslaw";
            case _11809: return "Coos";
            case _11825: return "Coquilles";
            case _11841: return "Costanoan";
            case _11866: return "Coushatta";
            case _11874: return "Alabama Coushatta";
            case _11890: return "Cowlitz";
            case _11916: return "Cree";
            case _11932: return "Creek";
            case _11940: return "Alabama Creek";
            case _11957: return "Alabama Quassarte";
            case _11965: return "Eastern Creek";
            case _11973: return "Eastern Muscogee";
            case _11981: return "Kialegee";
            case _11999: return "Lower Muscogee";
            case _12005: return "Machis Lower Creek Indian";
            case _12013: return "Poarch Band";
            case _12021: return "Principal Creek Indian Nation";
            case _12039: return "Star Clan of Muscogee Creeks";
            case _12047: return "Thlopthlocco";
            case _12054: return "Tuckabachee";
            case _12070: return "Croatan";
            case _12096: return "Crow";
            case _12112: return "Cupeno";
            case _12120: return "Agua Caliente";
            case _12146: return "Delaware";
            case _12153: return "Eastern Delaware";
            case _12161: return "Lenni-Lenape";
            case _12179: return "Munsee";
            case _12187: return "Oklahoma Delaware";
            case _12195: return "Rampough Mountain";
            case _12203: return "Sand Hill";
            case _12229: return "Diegueno";
            case _12237: return "Campo";
            case _12245: return "Capitan Grande";
            case _12252: return "Cuyapaipe";
            case _12260: return "La Posta";
            case _12278: return "Manzanita";
            case _12286: return "Mesa Grande";
            case _12294: return "San Pasqual";
            case _12302: return "Santa Ysabel";
            case _12310: return "Sycuan";
            case _12336: return "Eastern Tribes";
            case _12344: return "Attacapa";
            case _12351: return "Biloxi";
            case _12369: return "Georgetown";
            case _12377: return "Moor";
            case _12385: return "Nansemond";
            case _12393: return "Natchez";
            case _12401: return "Nausu Waiwash";
            case _12419: return "Nipmuc";
            case _12427: return "Paugussett";
            case _12435: return "Pocomoke Acohonock";
            case _12443: return "Southeastern Indians";
            case _12450: return "Susquehanock";
            case _12468: return "Tunica Biloxi";
            case _12476: return "Waccamaw-Siousan";
            case _12484: return "Wicomico";
            case _12500: return "Esselen";
            case _12526: return "Fort Belknap";
            case _12542: return "Fort Berthold";
            case _12567: return "Fort Mcdowell";
            case _12583: return "Fort Hall";
            case _12609: return "Gabrieleno";
            case _12625: return "Grand Ronde";
            case _12641: return "Gros Ventres";
            case _12658: return "Atsina";
            case _12674: return "Haliwa";
            case _12690: return "Hidatsa";
            case _12716: return "Hoopa";
            case _12724: return "Trinity";
            case _12732: return "Whilkut";
            case _12757: return "Hoopa Extension";
            case _12773: return "Houma";
            case _12799: return "Inaja-Cosmit";
            case _12815: return "Iowa";
            case _12823: return "Iowa of Kansas-Nebraska";
            case _12831: return "Iowa of Oklahoma";
            case _12856: return "Iroquois";
            case _12864: return "Cayuga";
            case _12872: return "Mohawk";
            case _12880: return "Oneida";
            case _12898: return "Onondaga";
            case _12906: return "Seneca";
            case _12914: return "Seneca Nation";
            case _12922: return "Seneca-Cayuga";
            case _12930: return "Tonawanda Seneca";
            case _12948: return "Tuscarora";
            case _12955: return "Wyandotte";
            case _12971: return "Juaneno";
            case _12997: return "Kalispel";
            case _13011: return "Karuk";
            case _13037: return "Kaw";
            case _13052: return "Kickapoo";
            case _13060: return "Oklahoma Kickapoo";
            case _13078: return "Texas Kickapoo";
            case _13094: return "Kiowa";
            case _13102: return "Oklahoma Kiowa";
            case _13128: return "Klallam";
            case _13136: return "Jamestown";
            case _13144: return "Lower Elwha";
            case _13151: return "Port Gamble Klallam";
            case _13177: return "Klamath";
            case _13193: return "Konkow";
            case _13219: return "Kootenai";
            case _13235: return "Lassik";
            case _13250: return "Long Island";
            case _13268: return "Matinecock";
            case _13276: return "Montauk";
            case _13284: return "Poospatuck";
            case _13292: return "Setauket";
            case _13318: return "Luiseno";
            case _13326: return "La Jolla";
            case _13334: return "Pala";
            case _13342: return "Pauma";
            case _13359: return "Pechanga";
            case _13367: return "Soboba";
            case _13375: return "Twenty-Nine Palms";
            case _13383: return "Temecula";
            case _13409: return "Lumbee";
            case _13425: return "Lummi";
            case _13441: return "Maidu";
            case _13458: return "Mountain Maidu";
            case _13466: return "Nishinam";
            case _13482: return "Makah";
            case _13508: return "Maliseet";
            case _13524: return "Mandan";
            case _13540: return "Mattaponi";
            case _13565: return "Menominee";
            case _13581: return "Miami";
            case _13599: return "Illinois Miami";
            case _13607: return "Indiana Miami";
            case _13615: return "Oklahoma Miami";
            case _13631: return "Miccosukee";
            case _13656: return "Micmac";
            case _13664: return "Aroostook";
            case _13680: return "Mission Indians";
            case _13706: return "Miwok";
            case _13722: return "Modoc";
            case _13748: return "Mohegan";
            case _13763: return "Mono";
            case _13789: return "Nanticoke";
            case _13805: return "Narragansett";
            case _13821: return "Navajo";
            case _13839: return "Alamo Navajo";
            case _13847: return "Canoncito Navajo";
            case _13854: return "Ramah Navajo";
            case _13870: return "Nez Perce";
            case _13896: return "Nomalaki";
            case _13912: return "Northwest Tribes";
            case _13920: return "Alsea";
            case _13938: return "Celilo";
            case _13946: return "Columbia";
            case _13953: return "Kalapuya";
            case _13961: return "Molala";
            case _13979: return "Talakamish";
            case _13987: return "Tenino";
            case _13995: return "Tillamook";
            case _14001: return "Wenatchee";
            case _14019: return "Yahooskin";
            case _14035: return "Omaha";
            case _14050: return "Oregon Athabaskan";
            case _14076: return "Osage";
            case _14092: return "Otoe-Missouria";
            case _14118: return "Ottawa";
            case _14126: return "Burt Lake Ottawa";
            case _14134: return "Michigan Ottawa";
            case _14142: return "Oklahoma Ottawa";
            case _14167: return "Paiute";
            case _14175: return "Bishop";
            case _14183: return "Bridgeport";
            case _14191: return "Burns Paiute";
            case _14209: return "Cedarville";
            case _14217: return "Fort Bidwell";
            case _14225: return "Fort Independence";
            case _14233: return "Kaibab";
            case _14241: return "Las Vegas";
            case _14258: return "Lone Pine";
            case _14266: return "Lovelock";
            case _14274: return "Malheur Paiute";
            case _14282: return "Moapa";
            case _14290: return "Northern Paiute";
            case _14308: return "Owens Valley";
            case _14316: return "Pyramid Lake";
            case _14324: return "San Juan Southern Paiute";
            case _14332: return "Southern Paiute";
            case _14340: return "Summit Lake";
            case _14357: return "Utu Utu Gwaitu Paiute";
            case _14365: return "Walker River";
            case _14373: return "Yerington Paiute";
            case _14399: return "Pamunkey";
            case _14415: return "Passamaquoddy";
            case _14423: return "Indian Township";
            case _14431: return "Pleasant Point Passamaquoddy";
            case _14456: return "Pawnee";
            case _14464: return "Oklahoma Pawnee";
            case _14480: return "Penobscot";
            case _14506: return "Peoria";
            case _14514: return "Oklahoma Peoria";
            case _14530: return "Pequot";
            case _14548: return "Marshantucket Pequot";
            case _14563: return "Pima";
            case _14571: return "Gila River Pima-Maricopa";
            case _14589: return "Salt River Pima-Maricopa";
            case _14605: return "Piscataway";
            case _14621: return "Pit River";
            case _14647: return "Pomo";
            case _14654: return "Central Pomo";
            case _14662: return "Dry Creek";
            case _14670: return "Eastern Pomo";
            case _14688: return "Kashia";
            case _14696: return "Northern Pomo";
            case _14704: return "Scotts Valley";
            case _14712: return "Stonyford";
            case _14720: return "Sulphur Bank";
            case _14746: return "Ponca";
            case _14753: return "Nebraska Ponca";
            case _14761: return "Oklahoma Ponca";
            case _14787: return "Potawatomi";
            case _14795: return "Citizen Band Potawatomi";
            case _14803: return "Forest County";
            case _14811: return "Hannahville";
            case _14829: return "Huron Potawatomi";
            case _14837: return "Pokagon Potawatomi";
            case _14845: return "Prairie Band";
            case _14852: return "Wisconsin Potawatomi";
            case _14878: return "Powhatan";
            case _14894: return "Pueblo";
            case _14902: return "Acoma";
            case _14910: return "Arizona Tewa";
            case _14928: return "Cochiti";
            case _14936: return "Hopi";
            case _14944: return "Isleta";
            case _14951: return "Jemez";
            case _14969: return "Keres";
            case _14977: return "Laguna";
            case _14985: return "Nambe";
            case _14993: return "Picuris";
            case _15008: return "Piro";
            case _15016: return "Pojoaque";
            case _15024: return "San Felipe";
            case _15032: return "San Ildefonso";
            case _15040: return "San Juan Pueblo";
            case _15057: return "San Juan De";
            case _15065: return "San Juan";
            case _15073: return "Sandia";
            case _15081: return "Santa Ana";
            case _15099: return "Santa Clara";
            case _15107: return "Santo Domingo";
            case _15115: return "Taos";
            case _15123: return "Tesuque";
            case _15131: return "Tewa";
            case _15149: return "Tigua";
            case _15156: return "Zia";
            case _15164: return "Zuni";
            case _15180: return "Puget Sound Salish";
            case _15198: return "Duwamish";
            case _15206: return "Kikiallus";
            case _15214: return "Lower Skagit";
            case _15222: return "Muckleshoot";
            case _15230: return "Nisqually";
            case _15248: return "Nooksack";
            case _15255: return "Port Madison";
            case _15263: return "Puyallup";
            case _15271: return "Samish";
            case _15289: return "Sauk-Suiattle";
            case _15297: return "Skokomish";
            case _15305: return "Skykomish";
            case _15313: return "Snohomish";
            case _15321: return "Snoqualmie";
            case _15339: return "Squaxin Island";
            case _15347: return "Steilacoom";
            case _15354: return "Stillaguamish";
            case _15362: return "Suquamish";
            case _15370: return "Swinomish";
            case _15388: return "Tulalip";
            case _15396: return "Upper Skagit";
            case _15412: return "Quapaw";
            case _15438: return "Quinault";
            case _15453: return "Rappahannock";
            case _15479: return "Reno-Sparks";
            case _15495: return "Round Valley";
            case _15511: return "Sac and Fox";
            case _15529: return "Iowa Sac and Fox";
            case _15537: return "Missouri Sac and Fox";
            case _15545: return "Oklahoma Sac and Fox";
            case _15560: return "Salinan";
            case _15586: return "Salish";
            case _15602: return "Salish and Kootenai";
            case _15628: return "Schaghticoke";
            case _15644: return "Scott Valley";
            case _15669: return "Seminole";
            case _15677: return "Big Cypress";
            case _15685: return "Brighton";
            case _15693: return "Florida Seminole";
            case _15701: return "Hollywood Seminole";
            case _15719: return "Oklahoma Seminole";
            case _15735: return "Serrano";
            case _15743: return "San Manual";
            case _15768: return "Shasta";
            case _15784: return "Shawnee";
            case _15792: return "Absentee Shawnee";
            case _15800: return "Eastern Shawnee";
            case _15826: return "Shinnecock";
            case _15842: return "Shoalwater Bay";
            case _15867: return "Shoshone";
            case _15875: return "Battle Mountain";
            case _15883: return "Duckwater";
            case _15891: return "Elko";
            case _15909: return "Ely";
            case _15917: return "Goshute";
            case _15925: return "Panamint";
            case _15933: return "Ruby Valley";
            case _15941: return "Skull Valley";
            case _15958: return "South Fork Shoshone";
            case _15966: return "Te-Moak Western Shoshone";
            case _15974: return "Timbi-Sha Shoshone";
            case _15982: return "Washakie";
            case _15990: return "Wind River Shoshone";
            case _16006: return "Yomba";
            case _16022: return "Shoshone Paiute";
            case _16030: return "Duck Valley";
            case _16048: return "Fallon";
            case _16055: return "Fort McDermitt";
            case _16071: return "Siletz";
            case _16097: return "Sioux";
            case _16105: return "Blackfoot Sioux";
            case _16113: return "Brule Sioux";
            case _16121: return "Cheyenne River Sioux";
            case _16139: return "Crow Creek Sioux";
            case _16147: return "Dakota Sioux";
            case _16154: return "Flandreau Santee";
            case _16162: return "Fort Peck";
            case _16170: return "Lake Traverse Sioux";
            case _16188: return "Lower Brule Sioux";
            case _16196: return "Lower Sioux";
            case _16204: return "Mdewakanton Sioux";
            case _16212: return "Miniconjou";
            case _16220: return "Oglala Sioux";
            case _16238: return "Pine Ridge Sioux";
            case _16246: return "Pipestone Sioux";
            case _16253: return "Prairie Island Sioux";
            case _16261: return "Prior Lake Sioux";
            case _16279: return "Rosebud Sioux";
            case _16287: return "Sans Arc Sioux";
            case _16295: return "Santee Sioux";
            case _16303: return "Sisseton-Wahpeton";
            case _16311: return "Sisseton Sioux";
            case _16329: return "Spirit Lake Sioux";
            case _16337: return "Standing Rock Sioux";
            case _16345: return "Teton Sioux";
            case _16352: return "Two Kettle Sioux";
            case _16360: return "Upper Sioux";
            case _16378: return "Wahpekute Sioux";
            case _16386: return "Wahpeton Sioux";
            case _16394: return "Wazhaza Sioux";
            case _16402: return "Yankton Sioux";
            case _16410: return "Yanktonai Sioux";
            case _16436: return "Siuslaw";
            case _16451: return "Spokane";
            case _16477: return "Stewart";
            case _16493: return "Stockbridge";
            case _16519: return "Susanville";
            case _16535: return "Tohono O'Odham";
            case _16543: return "Ak-Chin";
            case _16550: return "Gila Bend";
            case _16568: return "San Xavier";
            case _16576: return "Sells";
            case _16592: return "Tolowa";
            case _16618: return "Tonkawa";
            case _16634: return "Tygh";
            case _16659: return "Umatilla";
            case _16675: return "Umpqua";
            case _16683: return "Cow Creek Umpqua";
            case _16709: return "Ute";
            case _16717: return "Allen Canyon";
            case _16725: return "Uintah Ute";
            case _16733: return "Ute Mountain Ute";
            case _16758: return "Wailaki";
            case _16774: return "Walla-Walla";
            case _16790: return "Wampanoag";
            case _16808: return "Gay Head Wampanoag";
            case _16816: return "Mashpee Wampanoag";
            case _16832: return "Warm Springs";
            case _16857: return "Wascopum";
            case _16873: return "Washoe";
            case _16881: return "Alpine";
            case _16899: return "Carson";
            case _16907: return "Dresslerville";
            case _16923: return "Wichita";
            case _16949: return "Wind River";
            case _16964: return "Winnebago";
            case _16972: return "Ho-chunk";
            case _16980: return "Nebraska Winnebago";
            case _17004: return "Winnemucca";
            case _17020: return "Wintun";
            case _17046: return "Wiyot";
            case _17053: return "Table Bluff";
            case _17079: return "Yakama";
            case _17095: return "Yakama Cowlitz";
            case _17111: return "Yaqui";
            case _17129: return "Barrio Libre";
            case _17137: return "Pascua Yaqui";
            case _17152: return "Yavapai Apache";
            case _17178: return "Yokuts";
            case _17186: return "Chukchansi";
            case _17194: return "Tachi";
            case _17202: return "Tule River";
            case _17228: return "Yuchi";
            case _17244: return "Yuman";
            case _17251: return "Cocopah";
            case _17269: return "Havasupai";
            case _17277: return "Hualapai";
            case _17285: return "Maricopa";
            case _17293: return "Mohave";
            case _17301: return "Quechan";
            case _17319: return "Yavapai";
            case _17327: return "Yurok";
            case _17335: return "Coast Yurok";
            case _17350: return "Alaska Native";
            case _17376: return "Alaska Indian";
            case _17392: return "Alaskan Athabascan";
            case _17400: return "Ahtna";
            case _18119: return "Southeast Alaska";
            case _18135: return "Tlingit-Haida";
            case _18143: return "Angoon";
            case _18150: return "Central Council of Tlingit and Haida Tribes";
            case _18168: return "Chilkat";
            case _18176: return "Chilkoot";
            case _18184: return "Craig";
            case _18192: return "Douglas";
            case _18200: return "Haida";
            case _18218: return "Hoonah";
            case _18226: return "Hydaburg";
            case _18234: return "Kake";
            case _18242: return "Kasaan";
            case _18259: return "Kenaitze";
            case _18267: return "Ketchikan";
            case _18275: return "Klawock";
            case _18283: return "Pelican";
            case _18291: return "Petersburg";
            case _18309: return "Saxman";
            case _18317: return "Sitka";
            case _18325: return "Tenakee Springs";
            case _18333: return "Tlingit";
            case _18341: return "Wrangell";
            case _18358: return "Yakutat";
            case _18374: return "Tsimshian";
            case _18382: return "Metlakatla";
            case _18408: return "Eskimo";
            case _18424: return "Greenland Eskimo";
            case _18440: return "Inupiat Eskimo";
            case _18457: return "Ambler";
            case _18465: return "Anaktuvuk";
            case _18473: return "Anaktuvuk Pass";
            case _18481: return "Arctic Slope Inupiat";
            case _18499: return "Arctic Slope Corporation";
            case _18507: return "Atqasuk";
            case _18515: return "Barrow";
            case _18523: return "Bering Straits Inupiat";
            case _18531: return "Brevig Mission";
            case _18549: return "Buckland";
            case _18556: return "Chinik";
            case _18564: return "Council";
            case _18572: return "Deering";
            case _18580: return "Elim";
            case _18598: return "Golovin";
            case _18606: return "Inalik Diomede";
            case _18614: return "Inupiaq";
            case _18622: return "Kaktovik";
            case _18630: return "Kawerak";
            case _18648: return "Kiana";
            case _18655: return "Kivalina";
            case _18663: return "Kobuk";
            case _18671: return "Kotzebue";
            case _18689: return "Koyuk";
            case _18697: return "Kwiguk";
            case _18705: return "Mauneluk Inupiat";
            case _18713: return "Nana Inupiat";
            case _18721: return "Noatak";
            case _18739: return "Nome";
            case _18747: return "Noorvik";
            case _18754: return "Nuiqsut";
            case _18762: return "Point Hope";
            case _18770: return "Point Lay";
            case _18788: return "Selawik";
            case _18796: return "Shaktoolik";
            case _18804: return "Shishmaref";
            case _18812: return "Shungnak";
            case _18820: return "Solomon";
            case _18838: return "Teller";
            case _18846: return "Unalakleet";
            case _18853: return "Wainwright";
            case _18861: return "Wales";
            case _18879: return "White Mountain";
            case _18887: return "White Mountain Inupiat";
            case _18895: return "Mary's Igloo";
            case _18911: return "Siberian Eskimo";
            case _18929: return "Gambell";
            case _18937: return "Savoonga";
            case _18945: return "Siberian Yupik";
            case _18960: return "Yupik Eskimo";
            case _18978: return "Akiachak";
            case _18986: return "Akiak";
            case _18994: return "Alakanuk";
            case _19000: return "Aleknagik";
            case _19018: return "Andreafsky";
            case _19026: return "Aniak";
            case _19034: return "Atmautluak";
            case _19042: return "Bethel";
            case _19059: return "Bill Moore's Slough";
            case _19067: return "Bristol Bay Yupik";
            case _19075: return "Calista Yupik";
            case _19083: return "Chefornak";
            case _19091: return "Chevak";
            case _19109: return "Chuathbaluk";
            case _19117: return "Clark's Point";
            case _19125: return "Crooked Creek";
            case _19133: return "Dillingham";
            case _19141: return "Eek";
            case _19158: return "Ekuk";
            case _19166: return "Ekwok";
            case _19174: return "Emmonak";
            case _19182: return "Goodnews Bay";
            case _19190: return "Hooper Bay";
            case _19208: return "Iqurmuit (Russian Mission)";
            case _19216: return "Kalskag";
            case _19224: return "Kasigluk";
            case _19232: return "Kipnuk";
            case _19240: return "Koliganek";
            case _19257: return "Kongiganak";
            case _19265: return "Kotlik";
            case _19273: return "Kwethluk";
            case _19281: return "Kwigillingok";
            case _19299: return "Levelock";
            case _19307: return "Lower Kalskag";
            case _19315: return "Manokotak";
            case _19323: return "Marshall";
            case _19331: return "Mekoryuk";
            case _19349: return "Mountain Village";
            case _19356: return "Naknek";
            case _19364: return "Napaumute";
            case _19372: return "Napakiak";
            case _19380: return "Napaskiak";
            case _19398: return "Newhalen";
            case _19406: return "New Stuyahok";
            case _19414: return "Newtok";
            case _19422: return "Nightmute";
            case _19430: return "Nunapitchukv";
            case _19448: return "Oscarville";
            case _19455: return "Pilot Station";
            case _19463: return "Pitkas Point";
            case _19471: return "Platinum";
            case _19489: return "Portage Creek";
            case _19497: return "Quinhagak";
            case _19505: return "Red Devil";
            case _19513: return "St. Michael";
            case _19521: return "Scammon Bay";
            case _19539: return "Sheldon's Point";
            case _19547: return "Sleetmute";
            case _19554: return "Stebbins";
            case _19562: return "Togiak";
            case _19570: return "Toksook";
            case _19588: return "Tulukskak";
            case _19596: return "Tuntutuliak";
            case _19604: return "Tununak";
            case _19612: return "Twin Hills";
            case _19620: return "Georgetown";
            case _19638: return "St. Mary's";
            case _19646: return "Umkumiate";
            case _19661: return "Aleut";
            case _19687: return "Alutiiq Aleut";
            case _19695: return "Tatitlek";
            case _19703: return "Ugashik";
            case _19729: return "Bristol Bay Aleut";
            case _19737: return "Chignik";
            case _19745: return "Chignik Lake";
            case _19752: return "Egegik";
            case _19760: return "Igiugig";
            case _19778: return "Ivanof Bay";
            case _19786: return "King Salmon";
            case _19794: return "Kokhanok";
            case _19802: return "Perryville";
            case _19810: return "Pilot Point";
            case _19828: return "Port Heiden";
            case _19844: return "Chugach Aleut";
            case _19851: return "Chenega";
            case _19869: return "Chugach Corporation";
            case _19877: return "English Bay";
            case _19885: return "Port Graham";
            case _19901: return "Eyak";
            case _19927: return "Koniag Aleut";
            case _19935: return "Akhiok";
            case _19943: return "Agdaagux";
            case _19950: return "Karluk";
            case _19968: return "Kodiak";
            case _19976: return "Larsen Bay";
            case _19984: return "Old Harbor";
            case _19992: return "Ouzinkie";
            case _20008: return "Port Lions";
            case _20024: return "Sugpiaq";
            case _20040: return "Suqpigaq";
            case _20065: return "Unangan Aleut";
            case _20073: return "Akutan";
            case _20081: return "Aleut Corporation";
            case _20099: return "Aleutian";
            case _20107: return "Aleutian Islander";
            case _20115: return "Atka";
            case _20123: return "Belkofski";
            case _20131: return "Chignik Lagoon";
            case _20149: return "King Cove";
            case _20156: return "False Pass";
            case _20164: return "Nelson Lagoon";
            case _20172: return "Nikolski";
            case _20180: return "Pauloff Harbor";
            case _20198: return "Qagan Toyagungin";
            case _20206: return "Qawalangin";
            case _20214: return "St. George";
            case _20222: return "St. Paul";
            case _20230: return "Sand Point";
            case _20248: return "South Naknek";
            case _20255: return "Unalaska";
            case _20263: return "Unga";
            case _20289: return "Asian";
            case _20297: return "Asian Indian";
            case _20305: return "Bangladeshi";
            case _20313: return "Bhutanese";
            case _20321: return "Burmese";
            case _20339: return "Cambodian";
            case _20347: return "Chinese";
            case _20354: return "Taiwanese";
            case _20362: return "Filipino";
            case _20370: return "Hmong";
            case _20388: return "Indonesian";
            case _20396: return "Japanese";
            case _20404: return "Korean";
            case _20412: return "Laotian";
            case _20420: return "Malaysian";
            case _20438: return "Okinawan";
            case _20446: return "Pakistani";
            case _20453: return "Sri Lankan";
            case _20461: return "Thai";
            case _20479: return "Vietnamese";
            case _20487: return "Iwo Jiman";
            case _20495: return "Maldivian";
            case _20503: return "Nepalese";
            case _20511: return "Singaporean";
            case _20529: return "Madagascar";
            case _20545: return "Black or African American";
            case _20560: return "Black";
            case _20586: return "African American";
            case _20602: return "African";
            case _20610: return "Botswanan";
            case _20628: return "Ethiopian";
            case _20636: return "Liberian";
            case _20644: return "Namibian";
            case _20651: return "Nigerian";
            case _20669: return "Zairean";
            case _20677: return "Bahamian";
            case _20685: return "Barbadian";
            case _20693: return "Dominican";
            case _20701: return "Dominica Islander";
            case _20719: return "Haitian";
            case _20727: return "Jamaican";
            case _20735: return "Tobagoan";
            case _20743: return "Trinidadian";
            case _20750: return "West Indian";
            case _20768: return "Native Hawaiian or Other Pacific Islander";
            case _20784: return "Polynesian";
            case _20792: return "Native Hawaiian";
            case _20800: return "Samoan";
            case _20818: return "Tahitian";
            case _20826: return "Tongan";
            case _20834: return "Tokelauan";
            case _20859: return "Micronesian";
            case _20867: return "Guamanian or Chamorro";
            case _20875: return "Guamanian";
            case _20883: return "Chamorro";
            case _20891: return "Mariana Islander";
            case _20909: return "Marshallese";
            case _20917: return "Palauan";
            case _20925: return "Carolinian";
            case _20933: return "Kosraean";
            case _20941: return "Pohnpeian";
            case _20958: return "Saipanese";
            case _20966: return "Kiribati";
            case _20974: return "Chuukese";
            case _20982: return "Yapese";
            case _21006: return "Melanesian";
            case _21014: return "Fijian";
            case _21022: return "Papua New Guinean";
            case _21030: return "Solomon Islander";
            case _21048: return "New Hebrides";
            case _25007: return "Note that this term remains in the table for completeness, even though within HL7, the notion of Other code is deprecated.";
            case _21063: return "White";
            case _21089: return "European";
            case _21097: return "Armenian";
            case _21105: return "English";
            case _21113: return "French";
            case _21121: return "German";
            case _21139: return "Irish";
            case _21147: return "Italian";
            case _21154: return "Polish";
            case _21162: return "Scottish";
            case _21188: return "Middle Eastern or North African";
            case _21196: return "Assyrian";
            case _21204: return "Egyptian";
            case _21212: return "Iranian";
            case _21220: return "Iraqi";
            case _21238: return "Lebanese";
            case _21246: return "Palestinian";
            case _21253: return "Syrian";
            case _21261: return "Afghanistani";
            case _21279: return "Israeili";
            case _21295: return "Arab";
            case _21311: return "Note that this term remains in the table for completeness, even though within HL7, the notion of Other code is deprecated.";
            default: return "?";
          }
        }
        public String getDisplay() {
          switch (this) {
            case _10025: return "American Indian or Alaska Native";
            case _10041: return "American Indian";
            case _10066: return "Abenaki";
            case _10082: return "Algonquian";
            case _10108: return "Apache";
            case _10116: return "Chiricahua";
            case _10124: return "Fort Sill Apache";
            case _10132: return "Jicarilla Apache";
            case _10140: return "Lipan Apache";
            case _10157: return "Mescalero Apache";
            case _10165: return "Oklahoma Apache";
            case _10173: return "Payson Apache";
            case _10181: return "San Carlos Apache";
            case _10199: return "White Mountain Apache";
            case _10215: return "Arapaho";
            case _10223: return "Northern Arapaho";
            case _10231: return "Southern Arapaho";
            case _10249: return "Wind River Arapaho";
            case _10264: return "Arikara";
            case _10280: return "Assiniboine";
            case _10306: return "Assiniboine Sioux";
            case _10314: return "Fort Peck Assiniboine Sioux";
            case _10330: return "Bannock";
            case _10355: return "Blackfeet";
            case _10371: return "Brotherton";
            case _10397: return "Burt Lake Band";
            case _10413: return "Caddo";
            case _10421: return "Oklahoma Cado";
            case _10447: return "Cahuilla";
            case _10454: return "Agua Caliente Cahuilla";
            case _10462: return "Augustine";
            case _10470: return "Cabazon";
            case _10488: return "Los Coyotes";
            case _10496: return "Morongo";
            case _10504: return "Santa Rosa Cahuilla";
            case _10512: return "Torres-Martinez";
            case _10538: return "California Tribes";
            case _10546: return "Cahto";
            case _10553: return "Chimariko";
            case _10561: return "Coast Miwok";
            case _10579: return "Digger";
            case _10587: return "Kawaiisu";
            case _10595: return "Kern River";
            case _10603: return "Mattole";
            case _10611: return "Red Wood";
            case _10629: return "Santa Rosa";
            case _10637: return "Takelma";
            case _10645: return "Wappo";
            case _10652: return "Yana";
            case _10660: return "Yuki";
            case _10686: return "Canadian and Latin American Indian";
            case _10694: return "Canadian Indian";
            case _10702: return "Central American Indian";
            case _10710: return "French American Indian";
            case _10728: return "Mexican American Indian";
            case _10736: return "South American Indian";
            case _10744: return "Spanish American Indian";
            case _10769: return "Catawba";
            case _17418: return "Alatna";
            case _17426: return "Alexander";
            case _17434: return "Allakaket";
            case _17442: return "Alanvik";
            case _17459: return "Anvik";
            case _17467: return "Arctic";
            case _17475: return "Beaver";
            case _17483: return "Birch Creek";
            case _17491: return "Cantwell";
            case _17509: return "Chalkyitsik";
            case _17517: return "Chickaloon";
            case _17525: return "Chistochina";
            case _17533: return "Chitina";
            case _17541: return "Circle";
            case _17558: return "Cook Inlet";
            case _17566: return "Copper Center";
            case _17574: return "Copper River";
            case _17582: return "Dot Lake";
            case _17590: return "Doyon";
            case _17608: return "Eagle";
            case _17616: return "Eklutna";
            case _17624: return "Evansville";
            case _17632: return "Fort Yukon";
            case _17640: return "Gakona";
            case _17657: return "Galena";
            case _17665: return "Grayling";
            case _17673: return "Gulkana";
            case _17681: return "Healy Lake";
            case _17699: return "Holy Cross";
            case _17707: return "Hughes";
            case _17715: return "Huslia";
            case _17723: return "Iliamna";
            case _17731: return "Kaltag";
            case _17749: return "Kluti Kaah";
            case _17756: return "Knik";
            case _17764: return "Koyukuk";
            case _17772: return "Lake Minchumina";
            case _17780: return "Lime";
            case _17798: return "Mcgrath";
            case _17806: return "Manley Hot Springs";
            case _17814: return "Mentasta Lake";
            case _17822: return "Minto";
            case _17830: return "Nenana";
            case _17848: return "Nikolai";
            case _17855: return "Ninilchik";
            case _17863: return "Nondalton";
            case _17871: return "Northway";
            case _17889: return "Nulato";
            case _17897: return "Pedro Bay";
            case _17905: return "Rampart";
            case _17913: return "Ruby";
            case _17921: return "Salamatof";
            case _17939: return "Seldovia";
            case _17947: return "Slana";
            case _17954: return "Shageluk";
            case _17962: return "Stevens";
            case _17970: return "Stony River";
            case _17988: return "Takotna";
            case _17996: return "Tanacross";
            case _18002: return "Tanaina";
            case _18010: return "Tanana";
            case _18028: return "Tanana Chiefs";
            case _18036: return "Tazlina";
            case _18044: return "Telida";
            case _18051: return "Tetlin";
            case _18069: return "Tok";
            case _18077: return "Tyonek";
            case _18085: return "Venetie";
            case _18093: return "Wiseman";
            case _10785: return "Cayuse";
            case _10801: return "Chehalis";
            case _10827: return "Chemakuan";
            case _10835: return "Hoh";
            case _10843: return "Quileute";
            case _10868: return "Chemehuevi";
            case _10884: return "Cherokee";
            case _10892: return "Cherokee Alabama";
            case _10900: return "Cherokees of Northeast Alabama";
            case _10918: return "Cherokees of Southeast Alabama";
            case _10926: return "Eastern Cherokee";
            case _10934: return "Echota Cherokee";
            case _10942: return "Etowah Cherokee";
            case _10959: return "Northern Cherokee";
            case _10967: return "Tuscola";
            case _10975: return "United Keetowah Band of Cherokee";
            case _10983: return "Western Cherokee";
            case _11007: return "Cherokee Shawnee";
            case _11023: return "Cheyenne";
            case _11031: return "Northern Cheyenne";
            case _11049: return "Southern Cheyenne";
            case _11064: return "Cheyenne-Arapaho";
            case _11080: return "Chickahominy";
            case _11098: return "Eastern Chickahominy";
            case _11106: return "Western Chickahominy";
            case _11122: return "Chickasaw";
            case _11148: return "Chinook";
            case _11155: return "Clatsop";
            case _11163: return "Columbia River Chinook";
            case _11171: return "Kathlamet";
            case _11189: return "Upper Chinook";
            case _11197: return "Wakiakum Chinook";
            case _11205: return "Willapa Chinook";
            case _11213: return "Wishram";
            case _11239: return "Chippewa";
            case _11247: return "Bad River";
            case _11254: return "Bay Mills Chippewa";
            case _11262: return "Bois Forte";
            case _11270: return "Burt Lake Chippewa";
            case _11288: return "Fond du Lac";
            case _11296: return "Grand Portage";
            case _11304: return "Grand Traverse Band of Ottawa-Chippewa";
            case _11312: return "Keweenaw";
            case _11320: return "Lac Courte Oreilles";
            case _11338: return "Lac du Flambeau";
            case _11346: return "Lac Vieux Desert Chippewa";
            case _11353: return "Lake Superior";
            case _11361: return "Leech Lake";
            case _11379: return "Little Shell Chippewa";
            case _11387: return "Mille Lacs";
            case _11395: return "Minnesota Chippewa";
            case _11403: return "Ontonagon";
            case _11411: return "Red Cliff Chippewa";
            case _11429: return "Red Lake Chippewa";
            case _11437: return "Saginaw Chippewa";
            case _11445: return "St. Croix Chippewa";
            case _11452: return "Sault Ste. Marie Chippewa";
            case _11460: return "Sokoagon Chippewa";
            case _11478: return "Turtle Mountain";
            case _11486: return "White Earth";
            case _11502: return "Chippewa Cree";
            case _11510: return "Rocky Boy's Chippewa Cree";
            case _11536: return "Chitimacha";
            case _11551: return "Choctaw";
            case _11569: return "Clifton Choctaw";
            case _11577: return "Jena Choctaw";
            case _11585: return "Mississippi Choctaw";
            case _11593: return "Mowa Band of Choctaw";
            case _11601: return "Oklahoma Choctaw";
            case _11627: return "Chumash";
            case _11635: return "Santa Ynez";
            case _11650: return "Clear Lake";
            case _11676: return "Coeur D'Alene";
            case _11692: return "Coharie";
            case _11718: return "Colorado River";
            case _11734: return "Colville";
            case _11759: return "Comanche";
            case _11767: return "Oklahoma Comanche";
            case _11783: return "Coos, Lower Umpqua, Siuslaw";
            case _11809: return "Coos";
            case _11825: return "Coquilles";
            case _11841: return "Costanoan";
            case _11866: return "Coushatta";
            case _11874: return "Alabama Coushatta";
            case _11890: return "Cowlitz";
            case _11916: return "Cree";
            case _11932: return "Creek";
            case _11940: return "Alabama Creek";
            case _11957: return "Alabama Quassarte";
            case _11965: return "Eastern Creek";
            case _11973: return "Eastern Muscogee";
            case _11981: return "Kialegee";
            case _11999: return "Lower Muscogee";
            case _12005: return "Machis Lower Creek Indian";
            case _12013: return "Poarch Band";
            case _12021: return "Principal Creek Indian Nation";
            case _12039: return "Star Clan of Muscogee Creeks";
            case _12047: return "Thlopthlocco";
            case _12054: return "Tuckabachee";
            case _12070: return "Croatan";
            case _12096: return "Crow";
            case _12112: return "Cupeno";
            case _12120: return "Agua Caliente";
            case _12146: return "Delaware";
            case _12153: return "Eastern Delaware";
            case _12161: return "Lenni-Lenape";
            case _12179: return "Munsee";
            case _12187: return "Oklahoma Delaware";
            case _12195: return "Rampough Mountain";
            case _12203: return "Sand Hill";
            case _12229: return "Diegueno";
            case _12237: return "Campo";
            case _12245: return "Capitan Grande";
            case _12252: return "Cuyapaipe";
            case _12260: return "La Posta";
            case _12278: return "Manzanita";
            case _12286: return "Mesa Grande";
            case _12294: return "San Pasqual";
            case _12302: return "Santa Ysabel";
            case _12310: return "Sycuan";
            case _12336: return "Eastern Tribes";
            case _12344: return "Attacapa";
            case _12351: return "Biloxi";
            case _12369: return "Georgetown";
            case _12377: return "Moor";
            case _12385: return "Nansemond";
            case _12393: return "Natchez";
            case _12401: return "Nausu Waiwash";
            case _12419: return "Nipmuc";
            case _12427: return "Paugussett";
            case _12435: return "Pocomoke Acohonock";
            case _12443: return "Southeastern Indians";
            case _12450: return "Susquehanock";
            case _12468: return "Tunica Biloxi";
            case _12476: return "Waccamaw-Siousan";
            case _12484: return "Wicomico";
            case _12500: return "Esselen";
            case _12526: return "Fort Belknap";
            case _12542: return "Fort Berthold";
            case _12567: return "Fort Mcdowell";
            case _12583: return "Fort Hall";
            case _12609: return "Gabrieleno";
            case _12625: return "Grand Ronde";
            case _12641: return "Gros Ventres";
            case _12658: return "Atsina";
            case _12674: return "Haliwa";
            case _12690: return "Hidatsa";
            case _12716: return "Hoopa";
            case _12724: return "Trinity";
            case _12732: return "Whilkut";
            case _12757: return "Hoopa Extension";
            case _12773: return "Houma";
            case _12799: return "Inaja-Cosmit";
            case _12815: return "Iowa";
            case _12823: return "Iowa of Kansas-Nebraska";
            case _12831: return "Iowa of Oklahoma";
            case _12856: return "Iroquois";
            case _12864: return "Cayuga";
            case _12872: return "Mohawk";
            case _12880: return "Oneida";
            case _12898: return "Onondaga";
            case _12906: return "Seneca";
            case _12914: return "Seneca Nation";
            case _12922: return "Seneca-Cayuga";
            case _12930: return "Tonawanda Seneca";
            case _12948: return "Tuscarora";
            case _12955: return "Wyandotte";
            case _12971: return "Juaneno";
            case _12997: return "Kalispel";
            case _13011: return "Karuk";
            case _13037: return "Kaw";
            case _13052: return "Kickapoo";
            case _13060: return "Oklahoma Kickapoo";
            case _13078: return "Texas Kickapoo";
            case _13094: return "Kiowa";
            case _13102: return "Oklahoma Kiowa";
            case _13128: return "Klallam";
            case _13136: return "Jamestown";
            case _13144: return "Lower Elwha";
            case _13151: return "Port Gamble Klallam";
            case _13177: return "Klamath";
            case _13193: return "Konkow";
            case _13219: return "Kootenai";
            case _13235: return "Lassik";
            case _13250: return "Long Island";
            case _13268: return "Matinecock";
            case _13276: return "Montauk";
            case _13284: return "Poospatuck";
            case _13292: return "Setauket";
            case _13318: return "Luiseno";
            case _13326: return "La Jolla";
            case _13334: return "Pala";
            case _13342: return "Pauma";
            case _13359: return "Pechanga";
            case _13367: return "Soboba";
            case _13375: return "Twenty-Nine Palms";
            case _13383: return "Temecula";
            case _13409: return "Lumbee";
            case _13425: return "Lummi";
            case _13441: return "Maidu";
            case _13458: return "Mountain Maidu";
            case _13466: return "Nishinam";
            case _13482: return "Makah";
            case _13508: return "Maliseet";
            case _13524: return "Mandan";
            case _13540: return "Mattaponi";
            case _13565: return "Menominee";
            case _13581: return "Miami";
            case _13599: return "Illinois Miami";
            case _13607: return "Indiana Miami";
            case _13615: return "Oklahoma Miami";
            case _13631: return "Miccosukee";
            case _13656: return "Micmac";
            case _13664: return "Aroostook";
            case _13680: return "Mission Indians";
            case _13706: return "Miwok";
            case _13722: return "Modoc";
            case _13748: return "Mohegan";
            case _13763: return "Mono";
            case _13789: return "Nanticoke";
            case _13805: return "Narragansett";
            case _13821: return "Navajo";
            case _13839: return "Alamo Navajo";
            case _13847: return "Canoncito Navajo";
            case _13854: return "Ramah Navajo";
            case _13870: return "Nez Perce";
            case _13896: return "Nomalaki";
            case _13912: return "Northwest Tribes";
            case _13920: return "Alsea";
            case _13938: return "Celilo";
            case _13946: return "Columbia";
            case _13953: return "Kalapuya";
            case _13961: return "Molala";
            case _13979: return "Talakamish";
            case _13987: return "Tenino";
            case _13995: return "Tillamook";
            case _14001: return "Wenatchee";
            case _14019: return "Yahooskin";
            case _14035: return "Omaha";
            case _14050: return "Oregon Athabaskan";
            case _14076: return "Osage";
            case _14092: return "Otoe-Missouria";
            case _14118: return "Ottawa";
            case _14126: return "Burt Lake Ottawa";
            case _14134: return "Michigan Ottawa";
            case _14142: return "Oklahoma Ottawa";
            case _14167: return "Paiute";
            case _14175: return "Bishop";
            case _14183: return "Bridgeport";
            case _14191: return "Burns Paiute";
            case _14209: return "Cedarville";
            case _14217: return "Fort Bidwell";
            case _14225: return "Fort Independence";
            case _14233: return "Kaibab";
            case _14241: return "Las Vegas";
            case _14258: return "Lone Pine";
            case _14266: return "Lovelock";
            case _14274: return "Malheur Paiute";
            case _14282: return "Moapa";
            case _14290: return "Northern Paiute";
            case _14308: return "Owens Valley";
            case _14316: return "Pyramid Lake";
            case _14324: return "San Juan Southern Paiute";
            case _14332: return "Southern Paiute";
            case _14340: return "Summit Lake";
            case _14357: return "Utu Utu Gwaitu Paiute";
            case _14365: return "Walker River";
            case _14373: return "Yerington Paiute";
            case _14399: return "Pamunkey";
            case _14415: return "Passamaquoddy";
            case _14423: return "Indian Township";
            case _14431: return "Pleasant Point Passamaquoddy";
            case _14456: return "Pawnee";
            case _14464: return "Oklahoma Pawnee";
            case _14480: return "Penobscot";
            case _14506: return "Peoria";
            case _14514: return "Oklahoma Peoria";
            case _14530: return "Pequot";
            case _14548: return "Marshantucket Pequot";
            case _14563: return "Pima";
            case _14571: return "Gila River Pima-Maricopa";
            case _14589: return "Salt River Pima-Maricopa";
            case _14605: return "Piscataway";
            case _14621: return "Pit River";
            case _14647: return "Pomo";
            case _14654: return "Central Pomo";
            case _14662: return "Dry Creek";
            case _14670: return "Eastern Pomo";
            case _14688: return "Kashia";
            case _14696: return "Northern Pomo";
            case _14704: return "Scotts Valley";
            case _14712: return "Stonyford";
            case _14720: return "Sulphur Bank";
            case _14746: return "Ponca";
            case _14753: return "Nebraska Ponca";
            case _14761: return "Oklahoma Ponca";
            case _14787: return "Potawatomi";
            case _14795: return "Citizen Band Potawatomi";
            case _14803: return "Forest County";
            case _14811: return "Hannahville";
            case _14829: return "Huron Potawatomi";
            case _14837: return "Pokagon Potawatomi";
            case _14845: return "Prairie Band";
            case _14852: return "Wisconsin Potawatomi";
            case _14878: return "Powhatan";
            case _14894: return "Pueblo";
            case _14902: return "Acoma";
            case _14910: return "Arizona Tewa";
            case _14928: return "Cochiti";
            case _14936: return "Hopi";
            case _14944: return "Isleta";
            case _14951: return "Jemez";
            case _14969: return "Keres";
            case _14977: return "Laguna";
            case _14985: return "Nambe";
            case _14993: return "Picuris";
            case _15008: return "Piro";
            case _15016: return "Pojoaque";
            case _15024: return "San Felipe";
            case _15032: return "San Ildefonso";
            case _15040: return "San Juan Pueblo";
            case _15057: return "San Juan De";
            case _15065: return "San Juan";
            case _15073: return "Sandia";
            case _15081: return "Santa Ana";
            case _15099: return "Santa Clara";
            case _15107: return "Santo Domingo";
            case _15115: return "Taos";
            case _15123: return "Tesuque";
            case _15131: return "Tewa";
            case _15149: return "Tigua";
            case _15156: return "Zia";
            case _15164: return "Zuni";
            case _15180: return "Puget Sound Salish";
            case _15198: return "Duwamish";
            case _15206: return "Kikiallus";
            case _15214: return "Lower Skagit";
            case _15222: return "Muckleshoot";
            case _15230: return "Nisqually";
            case _15248: return "Nooksack";
            case _15255: return "Port Madison";
            case _15263: return "Puyallup";
            case _15271: return "Samish";
            case _15289: return "Sauk-Suiattle";
            case _15297: return "Skokomish";
            case _15305: return "Skykomish";
            case _15313: return "Snohomish";
            case _15321: return "Snoqualmie";
            case _15339: return "Squaxin Island";
            case _15347: return "Steilacoom";
            case _15354: return "Stillaguamish";
            case _15362: return "Suquamish";
            case _15370: return "Swinomish";
            case _15388: return "Tulalip";
            case _15396: return "Upper Skagit";
            case _15412: return "Quapaw";
            case _15438: return "Quinault";
            case _15453: return "Rappahannock";
            case _15479: return "Reno-Sparks";
            case _15495: return "Round Valley";
            case _15511: return "Sac and Fox";
            case _15529: return "Iowa Sac and Fox";
            case _15537: return "Missouri Sac and Fox";
            case _15545: return "Oklahoma Sac and Fox";
            case _15560: return "Salinan";
            case _15586: return "Salish";
            case _15602: return "Salish and Kootenai";
            case _15628: return "Schaghticoke";
            case _15644: return "Scott Valley";
            case _15669: return "Seminole";
            case _15677: return "Big Cypress";
            case _15685: return "Brighton";
            case _15693: return "Florida Seminole";
            case _15701: return "Hollywood Seminole";
            case _15719: return "Oklahoma Seminole";
            case _15735: return "Serrano";
            case _15743: return "San Manual";
            case _15768: return "Shasta";
            case _15784: return "Shawnee";
            case _15792: return "Absentee Shawnee";
            case _15800: return "Eastern Shawnee";
            case _15826: return "Shinnecock";
            case _15842: return "Shoalwater Bay";
            case _15867: return "Shoshone";
            case _15875: return "Battle Mountain";
            case _15883: return "Duckwater";
            case _15891: return "Elko";
            case _15909: return "Ely";
            case _15917: return "Goshute";
            case _15925: return "Panamint";
            case _15933: return "Ruby Valley";
            case _15941: return "Skull Valley";
            case _15958: return "South Fork Shoshone";
            case _15966: return "Te-Moak Western Shoshone";
            case _15974: return "Timbi-Sha Shoshone";
            case _15982: return "Washakie";
            case _15990: return "Wind River Shoshone";
            case _16006: return "Yomba";
            case _16022: return "Shoshone Paiute";
            case _16030: return "Duck Valley";
            case _16048: return "Fallon";
            case _16055: return "Fort McDermitt";
            case _16071: return "Siletz";
            case _16097: return "Sioux";
            case _16105: return "Blackfoot Sioux";
            case _16113: return "Brule Sioux";
            case _16121: return "Cheyenne River Sioux";
            case _16139: return "Crow Creek Sioux";
            case _16147: return "Dakota Sioux";
            case _16154: return "Flandreau Santee";
            case _16162: return "Fort Peck";
            case _16170: return "Lake Traverse Sioux";
            case _16188: return "Lower Brule Sioux";
            case _16196: return "Lower Sioux";
            case _16204: return "Mdewakanton Sioux";
            case _16212: return "Miniconjou";
            case _16220: return "Oglala Sioux";
            case _16238: return "Pine Ridge Sioux";
            case _16246: return "Pipestone Sioux";
            case _16253: return "Prairie Island Sioux";
            case _16261: return "Prior Lake Sioux";
            case _16279: return "Rosebud Sioux";
            case _16287: return "Sans Arc Sioux";
            case _16295: return "Santee Sioux";
            case _16303: return "Sisseton-Wahpeton";
            case _16311: return "Sisseton Sioux";
            case _16329: return "Spirit Lake Sioux";
            case _16337: return "Standing Rock Sioux";
            case _16345: return "Teton Sioux";
            case _16352: return "Two Kettle Sioux";
            case _16360: return "Upper Sioux";
            case _16378: return "Wahpekute Sioux";
            case _16386: return "Wahpeton Sioux";
            case _16394: return "Wazhaza Sioux";
            case _16402: return "Yankton Sioux";
            case _16410: return "Yanktonai Sioux";
            case _16436: return "Siuslaw";
            case _16451: return "Spokane";
            case _16477: return "Stewart";
            case _16493: return "Stockbridge";
            case _16519: return "Susanville";
            case _16535: return "Tohono O'Odham";
            case _16543: return "Ak-Chin";
            case _16550: return "Gila Bend";
            case _16568: return "San Xavier";
            case _16576: return "Sells";
            case _16592: return "Tolowa";
            case _16618: return "Tonkawa";
            case _16634: return "Tygh";
            case _16659: return "Umatilla";
            case _16675: return "Umpqua";
            case _16683: return "Cow Creek Umpqua";
            case _16709: return "Ute";
            case _16717: return "Allen Canyon";
            case _16725: return "Uintah Ute";
            case _16733: return "Ute Mountain Ute";
            case _16758: return "Wailaki";
            case _16774: return "Walla-Walla";
            case _16790: return "Wampanoag";
            case _16808: return "Gay Head Wampanoag";
            case _16816: return "Mashpee Wampanoag";
            case _16832: return "Warm Springs";
            case _16857: return "Wascopum";
            case _16873: return "Washoe";
            case _16881: return "Alpine";
            case _16899: return "Carson";
            case _16907: return "Dresslerville";
            case _16923: return "Wichita";
            case _16949: return "Wind River";
            case _16964: return "Winnebago";
            case _16972: return "Ho-chunk";
            case _16980: return "Nebraska Winnebago";
            case _17004: return "Winnemucca";
            case _17020: return "Wintun";
            case _17046: return "Wiyot";
            case _17053: return "Table Bluff";
            case _17079: return "Yakama";
            case _17095: return "Yakama Cowlitz";
            case _17111: return "Yaqui";
            case _17129: return "Barrio Libre";
            case _17137: return "Pascua Yaqui";
            case _17152: return "Yavapai Apache";
            case _17178: return "Yokuts";
            case _17186: return "Chukchansi";
            case _17194: return "Tachi";
            case _17202: return "Tule River";
            case _17228: return "Yuchi";
            case _17244: return "Yuman";
            case _17251: return "Cocopah";
            case _17269: return "Havasupai";
            case _17277: return "Hualapai";
            case _17285: return "Maricopa";
            case _17293: return "Mohave";
            case _17301: return "Quechan";
            case _17319: return "Yavapai";
            case _17327: return "Yurok";
            case _17335: return "Coast Yurok";
            case _17350: return "Alaska Native";
            case _17376: return "Alaska Indian";
            case _17392: return "Alaskan Athabascan";
            case _17400: return "Ahtna";
            case _18119: return "Southeast Alaska";
            case _18135: return "Tlingit-Haida";
            case _18143: return "Angoon";
            case _18150: return "Central Council of Tlingit and Haida Tribes";
            case _18168: return "Chilkat";
            case _18176: return "Chilkoot";
            case _18184: return "Craig";
            case _18192: return "Douglas";
            case _18200: return "Haida";
            case _18218: return "Hoonah";
            case _18226: return "Hydaburg";
            case _18234: return "Kake";
            case _18242: return "Kasaan";
            case _18259: return "Kenaitze";
            case _18267: return "Ketchikan";
            case _18275: return "Klawock";
            case _18283: return "Pelican";
            case _18291: return "Petersburg";
            case _18309: return "Saxman";
            case _18317: return "Sitka";
            case _18325: return "Tenakee Springs";
            case _18333: return "Tlingit";
            case _18341: return "Wrangell";
            case _18358: return "Yakutat";
            case _18374: return "Tsimshian";
            case _18382: return "Metlakatla";
            case _18408: return "Eskimo";
            case _18424: return "Greenland Eskimo";
            case _18440: return "Inupiat Eskimo";
            case _18457: return "Ambler";
            case _18465: return "Anaktuvuk";
            case _18473: return "Anaktuvuk Pass";
            case _18481: return "Arctic Slope Inupiat";
            case _18499: return "Arctic Slope Corporation";
            case _18507: return "Atqasuk";
            case _18515: return "Barrow";
            case _18523: return "Bering Straits Inupiat";
            case _18531: return "Brevig Mission";
            case _18549: return "Buckland";
            case _18556: return "Chinik";
            case _18564: return "Council";
            case _18572: return "Deering";
            case _18580: return "Elim";
            case _18598: return "Golovin";
            case _18606: return "Inalik Diomede";
            case _18614: return "Inupiaq";
            case _18622: return "Kaktovik";
            case _18630: return "Kawerak";
            case _18648: return "Kiana";
            case _18655: return "Kivalina";
            case _18663: return "Kobuk";
            case _18671: return "Kotzebue";
            case _18689: return "Koyuk";
            case _18697: return "Kwiguk";
            case _18705: return "Mauneluk Inupiat";
            case _18713: return "Nana Inupiat";
            case _18721: return "Noatak";
            case _18739: return "Nome";
            case _18747: return "Noorvik";
            case _18754: return "Nuiqsut";
            case _18762: return "Point Hope";
            case _18770: return "Point Lay";
            case _18788: return "Selawik";
            case _18796: return "Shaktoolik";
            case _18804: return "Shishmaref";
            case _18812: return "Shungnak";
            case _18820: return "Solomon";
            case _18838: return "Teller";
            case _18846: return "Unalakleet";
            case _18853: return "Wainwright";
            case _18861: return "Wales";
            case _18879: return "White Mountain";
            case _18887: return "White Mountain Inupiat";
            case _18895: return "Mary's Igloo";
            case _18911: return "Siberian Eskimo";
            case _18929: return "Gambell";
            case _18937: return "Savoonga";
            case _18945: return "Siberian Yupik";
            case _18960: return "Yupik Eskimo";
            case _18978: return "Akiachak";
            case _18986: return "Akiak";
            case _18994: return "Alakanuk";
            case _19000: return "Aleknagik";
            case _19018: return "Andreafsky";
            case _19026: return "Aniak";
            case _19034: return "Atmautluak";
            case _19042: return "Bethel";
            case _19059: return "Bill Moore's Slough";
            case _19067: return "Bristol Bay Yupik";
            case _19075: return "Calista Yupik";
            case _19083: return "Chefornak";
            case _19091: return "Chevak";
            case _19109: return "Chuathbaluk";
            case _19117: return "Clark's Point";
            case _19125: return "Crooked Creek";
            case _19133: return "Dillingham";
            case _19141: return "Eek";
            case _19158: return "Ekuk";
            case _19166: return "Ekwok";
            case _19174: return "Emmonak";
            case _19182: return "Goodnews Bay";
            case _19190: return "Hooper Bay";
            case _19208: return "Iqurmuit (Russian Mission)";
            case _19216: return "Kalskag";
            case _19224: return "Kasigluk";
            case _19232: return "Kipnuk";
            case _19240: return "Koliganek";
            case _19257: return "Kongiganak";
            case _19265: return "Kotlik";
            case _19273: return "Kwethluk";
            case _19281: return "Kwigillingok";
            case _19299: return "Levelock";
            case _19307: return "Lower Kalskag";
            case _19315: return "Manokotak";
            case _19323: return "Marshall";
            case _19331: return "Mekoryuk";
            case _19349: return "Mountain Village";
            case _19356: return "Naknek";
            case _19364: return "Napaumute";
            case _19372: return "Napakiak";
            case _19380: return "Napaskiak";
            case _19398: return "Newhalen";
            case _19406: return "New Stuyahok";
            case _19414: return "Newtok";
            case _19422: return "Nightmute";
            case _19430: return "Nunapitchukv";
            case _19448: return "Oscarville";
            case _19455: return "Pilot Station";
            case _19463: return "Pitkas Point";
            case _19471: return "Platinum";
            case _19489: return "Portage Creek";
            case _19497: return "Quinhagak";
            case _19505: return "Red Devil";
            case _19513: return "St. Michael";
            case _19521: return "Scammon Bay";
            case _19539: return "Sheldon's Point";
            case _19547: return "Sleetmute";
            case _19554: return "Stebbins";
            case _19562: return "Togiak";
            case _19570: return "Toksook";
            case _19588: return "Tulukskak";
            case _19596: return "Tuntutuliak";
            case _19604: return "Tununak";
            case _19612: return "Twin Hills";
            case _19620: return "Georgetown";
            case _19638: return "St. Mary's";
            case _19646: return "Umkumiate";
            case _19661: return "Aleut";
            case _19687: return "Alutiiq Aleut";
            case _19695: return "Tatitlek";
            case _19703: return "Ugashik";
            case _19729: return "Bristol Bay Aleut";
            case _19737: return "Chignik";
            case _19745: return "Chignik Lake";
            case _19752: return "Egegik";
            case _19760: return "Igiugig";
            case _19778: return "Ivanof Bay";
            case _19786: return "King Salmon";
            case _19794: return "Kokhanok";
            case _19802: return "Perryville";
            case _19810: return "Pilot Point";
            case _19828: return "Port Heiden";
            case _19844: return "Chugach Aleut";
            case _19851: return "Chenega";
            case _19869: return "Chugach Corporation";
            case _19877: return "English Bay";
            case _19885: return "Port Graham";
            case _19901: return "Eyak";
            case _19927: return "Koniag Aleut";
            case _19935: return "Akhiok";
            case _19943: return "Agdaagux";
            case _19950: return "Karluk";
            case _19968: return "Kodiak";
            case _19976: return "Larsen Bay";
            case _19984: return "Old Harbor";
            case _19992: return "Ouzinkie";
            case _20008: return "Port Lions";
            case _20024: return "Sugpiaq";
            case _20040: return "Suqpigaq";
            case _20065: return "Unangan Aleut";
            case _20073: return "Akutan";
            case _20081: return "Aleut Corporation";
            case _20099: return "Aleutian";
            case _20107: return "Aleutian Islander";
            case _20115: return "Atka";
            case _20123: return "Belkofski";
            case _20131: return "Chignik Lagoon";
            case _20149: return "King Cove";
            case _20156: return "False Pass";
            case _20164: return "Nelson Lagoon";
            case _20172: return "Nikolski";
            case _20180: return "Pauloff Harbor";
            case _20198: return "Qagan Toyagungin";
            case _20206: return "Qawalangin";
            case _20214: return "St. George";
            case _20222: return "St. Paul";
            case _20230: return "Sand Point";
            case _20248: return "South Naknek";
            case _20255: return "Unalaska";
            case _20263: return "Unga";
            case _20289: return "Asian";
            case _20297: return "Asian Indian";
            case _20305: return "Bangladeshi";
            case _20313: return "Bhutanese";
            case _20321: return "Burmese";
            case _20339: return "Cambodian";
            case _20347: return "Chinese";
            case _20354: return "Taiwanese";
            case _20362: return "Filipino";
            case _20370: return "Hmong";
            case _20388: return "Indonesian";
            case _20396: return "Japanese";
            case _20404: return "Korean";
            case _20412: return "Laotian";
            case _20420: return "Malaysian";
            case _20438: return "Okinawan";
            case _20446: return "Pakistani";
            case _20453: return "Sri Lankan";
            case _20461: return "Thai";
            case _20479: return "Vietnamese";
            case _20487: return "Iwo Jiman";
            case _20495: return "Maldivian";
            case _20503: return "Nepalese";
            case _20511: return "Singaporean";
            case _20529: return "Madagascar";
            case _20545: return "Black or African American";
            case _20560: return "Black";
            case _20586: return "African American";
            case _20602: return "African";
            case _20610: return "Botswanan";
            case _20628: return "Ethiopian";
            case _20636: return "Liberian";
            case _20644: return "Namibian";
            case _20651: return "Nigerian";
            case _20669: return "Zairean";
            case _20677: return "Bahamian";
            case _20685: return "Barbadian";
            case _20693: return "Dominican";
            case _20701: return "Dominica Islander";
            case _20719: return "Haitian";
            case _20727: return "Jamaican";
            case _20735: return "Tobagoan";
            case _20743: return "Trinidadian";
            case _20750: return "West Indian";
            case _20768: return "Native Hawaiian or Other Pacific Islander";
            case _20784: return "Polynesian";
            case _20792: return "Native Hawaiian";
            case _20800: return "Samoan";
            case _20818: return "Tahitian";
            case _20826: return "Tongan";
            case _20834: return "Tokelauan";
            case _20859: return "Micronesian";
            case _20867: return "Guamanian or Chamorro";
            case _20875: return "Guamanian";
            case _20883: return "Chamorro";
            case _20891: return "Mariana Islander";
            case _20909: return "Marshallese";
            case _20917: return "Palauan";
            case _20925: return "Carolinian";
            case _20933: return "Kosraean";
            case _20941: return "Pohnpeian";
            case _20958: return "Saipanese";
            case _20966: return "Kiribati";
            case _20974: return "Chuukese";
            case _20982: return "Yapese";
            case _21006: return "Melanesian";
            case _21014: return "Fijian";
            case _21022: return "Papua New Guinean";
            case _21030: return "Solomon Islander";
            case _21048: return "New Hebrides";
            case _25007: return "Other Pacific Islander";
            case _21063: return "White";
            case _21089: return "European";
            case _21097: return "Armenian";
            case _21105: return "English";
            case _21113: return "French";
            case _21121: return "German";
            case _21139: return "Irish";
            case _21147: return "Italian";
            case _21154: return "Polish";
            case _21162: return "Scottish";
            case _21188: return "Middle Eastern or North African";
            case _21196: return "Assyrian";
            case _21204: return "Egyptian";
            case _21212: return "Iranian";
            case _21220: return "Iraqi";
            case _21238: return "Lebanese";
            case _21246: return "Palestinian";
            case _21253: return "Syrian";
            case _21261: return "Afghanistani";
            case _21279: return "Israeili";
            case _21295: return "Arab";
            case _21311: return "Other Race";
            default: return "?";
          }
    }


}